/* encoding.c generated by valac 0.56.17, the Vala compiler
 * generated from encoding.vala, do not modify */

/*
 * Copyright (C) 2011-2018 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include "libskk/libskk.h"

#define SKK_ENCODING_CONVERTER_BUFSIZ 4096
#define SKK_ENCODING_CONVERTER_INTERNAL_ENCODING "UTF-8"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define SKK_TYPE_ENCODING_CONVERTER (skk_encoding_converter_get_type ())
#define SKK_ENCODING_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverter))
#define SKK_ENCODING_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverterClass))
#define SKK_IS_ENCODING_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SKK_TYPE_ENCODING_CONVERTER))
#define SKK_IS_ENCODING_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SKK_TYPE_ENCODING_CONVERTER))
#define SKK_ENCODING_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverterClass))

typedef struct _SkkEncodingConverter SkkEncodingConverter;
typedef struct _SkkEncodingConverterClass SkkEncodingConverterClass;
typedef struct _SkkEncodingConverterPrivate SkkEncodingConverterPrivate;
enum  {
	SKK_ENCODING_CONVERTER_0_PROPERTY,
	SKK_ENCODING_CONVERTER_ENCODING_PROPERTY,
	SKK_ENCODING_CONVERTER_NUM_PROPERTIES
};
static GParamSpec* skk_encoding_converter_properties[SKK_ENCODING_CONVERTER_NUM_PROPERTIES];

#define SKK_TYPE_ENTRY (skk_entry_get_type ())
typedef struct _SkkEntry SkkEntry;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _SkkEncodingConverter {
	GObject parent_instance;
	SkkEncodingConverterPrivate * priv;
};

struct _SkkEncodingConverterClass {
	GObjectClass parent_class;
};

struct _SkkEncodingConverterPrivate {
	gchar* _encoding;
	GCharsetConverter* encoder;
	GCharsetConverter* decoder;
};

struct _SkkEntry {
	gpointer key;
	gpointer value;
};

static gint SkkEncodingConverter_private_offset;
static gpointer skk_encoding_converter_parent_class = NULL;
static GRegex* skk_encoding_converter_coding_cookie_regex;
static GRegex* skk_encoding_converter_coding_cookie_regex = NULL;

VALA_EXTERN GType skk_encoding_converter_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType skk_entry_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SkkEntry* skk_entry_dup (const SkkEntry* self);
VALA_EXTERN void skk_entry_free (SkkEntry* self);
VALA_EXTERN void skk_entry_copy (const SkkEntry* self,
                     SkkEntry* dest);
VALA_EXTERN void skk_entry_destroy (SkkEntry* self);
VALA_EXTERN gchar* skk_encoding_converter_extract_coding_system (const gchar* line);
VALA_EXTERN gchar* skk_encoding_converter_get_coding_system (SkkEncodingConverter* self);
VALA_EXTERN const gchar* skk_encoding_converter_get_encoding (SkkEncodingConverter* self);
VALA_EXTERN SkkEncodingConverter* skk_encoding_converter_new (const gchar* encoding,
                                                  GError** error);
VALA_EXTERN SkkEncodingConverter* skk_encoding_converter_construct (GType object_type,
                                                        const gchar* encoding,
                                                        GError** error);
static void skk_encoding_converter_set_encoding (SkkEncodingConverter* self,
                                          const gchar* value);
VALA_EXTERN SkkEncodingConverter* skk_encoding_converter_new_from_coding_system (const gchar* coding,
                                                                     GError** error);
VALA_EXTERN SkkEncodingConverter* skk_encoding_converter_construct_from_coding_system (GType object_type,
                                                                           const gchar* coding,
                                                                           GError** error);
static gchar* skk_encoding_converter_convert (SkkEncodingConverter* self,
                                       GCharsetConverter* converter,
                                       const gchar* str,
                                       GError** error);
static guint8* _vala_array_dup1 (guint8* self,
                          gssize length);
VALA_EXTERN gchar* skk_encoding_converter_encode (SkkEncodingConverter* self,
                                      const gchar* internal_str,
                                      GError** error);
VALA_EXTERN gchar* skk_encoding_converter_decode (SkkEncodingConverter* self,
                                      const gchar* external_str,
                                      GError** error);
static void skk_encoding_converter_finalize (GObject * obj);
static GType skk_encoding_converter_get_type_once (void);
static void _vala_skk_encoding_converter_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_skk_encoding_converter_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const SkkEntry SKK_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE[7] = {{"UTF-8", "utf-8"}, {"EUC-JP", "euc-jp"}, {"Shift_JIS", "shift_jis"}, {"ISO-2022-JP", "iso-2022-jp"}, {"EUC-JISX0213", "euc-jisx0213"}, {"EUC-JISX0213", "euc-jis-2004"}, {"SHIFT_JISX0213", "shift_jis-2004"}};

static inline gpointer
skk_encoding_converter_get_instance_private (SkkEncodingConverter* self)
{
	return G_STRUCT_MEMBER_P (self, SkkEncodingConverter_private_offset);
}

gchar*
skk_encoding_converter_extract_coding_system (const gchar* line)
{
	GMatchInfo* info = NULL;
	GRegex* _tmp0_;
	GMatchInfo* _tmp1_ = NULL;
	gboolean _tmp2_;
	gchar* result;
#line 46 "encoding.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 47 "encoding.vala"
	info = NULL;
#line 48 "encoding.vala"
	_tmp0_ = skk_encoding_converter_coding_cookie_regex;
#line 48 "encoding.vala"
	_tmp2_ = g_regex_match (_tmp0_, line, 0, &_tmp1_);
#line 48 "encoding.vala"
	_g_match_info_unref0 (info);
#line 48 "encoding.vala"
	info = _tmp1_;
#line 48 "encoding.vala"
	if (_tmp2_) {
#line 168 "encoding.c"
		GMatchInfo* _tmp3_;
		gchar* _tmp4_;
#line 49 "encoding.vala"
		_tmp3_ = info;
#line 49 "encoding.vala"
		_tmp4_ = g_match_info_fetch (_tmp3_, 1);
#line 49 "encoding.vala"
		result = _tmp4_;
#line 49 "encoding.vala"
		_g_match_info_unref0 (info);
#line 49 "encoding.vala"
		return result;
#line 181 "encoding.c"
	}
#line 51 "encoding.vala"
	result = NULL;
#line 51 "encoding.vala"
	_g_match_info_unref0 (info);
#line 51 "encoding.vala"
	return result;
#line 189 "encoding.c"
}

gchar*
skk_encoding_converter_get_coding_system (SkkEncodingConverter* self)
{
	gchar* result;
#line 54 "encoding.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 198 "encoding.c"
	{
		SkkEntry* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
#line 55 "encoding.vala"
		entry_collection = SKK_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE;
#line 55 "encoding.vala"
		entry_collection_length1 = G_N_ELEMENTS (SKK_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE);
#line 55 "encoding.vala"
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
#line 210 "encoding.c"
			SkkEntry entry = {0};
#line 55 "encoding.vala"
			entry = entry_collection[entry_it];
#line 214 "encoding.c"
			{
				SkkEntry _tmp0_;
				gconstpointer _tmp1_;
				const gchar* _tmp2_;
#line 56 "encoding.vala"
				_tmp0_ = entry;
#line 56 "encoding.vala"
				_tmp1_ = _tmp0_.key;
#line 56 "encoding.vala"
				_tmp2_ = self->priv->_encoding;
#line 56 "encoding.vala"
				if (g_strcmp0 ((const gchar*) _tmp1_, _tmp2_) == 0) {
#line 227 "encoding.c"
					SkkEntry _tmp3_;
					gconstpointer _tmp4_;
					gchar* _tmp5_;
#line 57 "encoding.vala"
					_tmp3_ = entry;
#line 57 "encoding.vala"
					_tmp4_ = _tmp3_.value;
#line 57 "encoding.vala"
					_tmp5_ = g_strdup ((const gchar*) _tmp4_);
#line 57 "encoding.vala"
					result = _tmp5_;
#line 57 "encoding.vala"
					return result;
#line 241 "encoding.c"
				}
			}
		}
	}
#line 60 "encoding.vala"
	result = NULL;
#line 60 "encoding.vala"
	return result;
#line 250 "encoding.c"
}

SkkEncodingConverter*
skk_encoding_converter_construct (GType object_type,
                                  const gchar* encoding,
                                  GError** error)
{
	SkkEncodingConverter * self = NULL;
	GCharsetConverter* _tmp0_ = NULL;
	GCharsetConverter* _tmp1_;
	GCharsetConverter* _tmp2_;
	GCharsetConverter* _tmp3_ = NULL;
	GCharsetConverter* _tmp4_;
	GCharsetConverter* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 68 "encoding.vala"
	g_return_val_if_fail (encoding != NULL, NULL);
#line 68 "encoding.vala"
	self = (SkkEncodingConverter*) g_object_new (object_type, NULL);
#line 69 "encoding.vala"
	skk_encoding_converter_set_encoding (self, encoding);
#line 70 "encoding.vala"
	_tmp1_ = g_charset_converter_new (encoding, SKK_ENCODING_CONVERTER_INTERNAL_ENCODING, &_inner_error0_);
#line 70 "encoding.vala"
	_tmp0_ = _tmp1_;
#line 70 "encoding.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "encoding.vala"
		g_propagate_error (error, _inner_error0_);
#line 70 "encoding.vala"
		_g_object_unref0 (self);
#line 70 "encoding.vala"
		return NULL;
#line 284 "encoding.c"
	}
#line 70 "encoding.vala"
	_tmp2_ = _tmp0_;
#line 70 "encoding.vala"
	_tmp0_ = NULL;
#line 70 "encoding.vala"
	_g_object_unref0 (self->priv->encoder);
#line 70 "encoding.vala"
	self->priv->encoder = _tmp2_;
#line 71 "encoding.vala"
	_tmp4_ = g_charset_converter_new (SKK_ENCODING_CONVERTER_INTERNAL_ENCODING, encoding, &_inner_error0_);
#line 71 "encoding.vala"
	_tmp3_ = _tmp4_;
#line 71 "encoding.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 71 "encoding.vala"
		g_propagate_error (error, _inner_error0_);
#line 71 "encoding.vala"
		_g_object_unref0 (_tmp0_);
#line 71 "encoding.vala"
		_g_object_unref0 (self);
#line 71 "encoding.vala"
		return NULL;
#line 308 "encoding.c"
	}
#line 71 "encoding.vala"
	_tmp5_ = _tmp3_;
#line 71 "encoding.vala"
	_tmp3_ = NULL;
#line 71 "encoding.vala"
	_g_object_unref0 (self->priv->decoder);
#line 71 "encoding.vala"
	self->priv->decoder = _tmp5_;
#line 68 "encoding.vala"
	_g_object_unref0 (_tmp3_);
#line 68 "encoding.vala"
	_g_object_unref0 (_tmp0_);
#line 68 "encoding.vala"
	return self;
#line 324 "encoding.c"
}

SkkEncodingConverter*
skk_encoding_converter_new (const gchar* encoding,
                            GError** error)
{
#line 68 "encoding.vala"
	return skk_encoding_converter_construct (SKK_TYPE_ENCODING_CONVERTER, encoding, error);
#line 333 "encoding.c"
}

SkkEncodingConverter*
skk_encoding_converter_construct_from_coding_system (GType object_type,
                                                     const gchar* coding,
                                                     GError** error)
{
	SkkEncodingConverter * self = NULL;
	GError* _inner_error0_ = NULL;
#line 74 "encoding.vala"
	g_return_val_if_fail (coding != NULL, NULL);
#line 345 "encoding.c"
	{
		SkkEntry* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
#line 75 "encoding.vala"
		entry_collection = SKK_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE;
#line 75 "encoding.vala"
		entry_collection_length1 = G_N_ELEMENTS (SKK_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE);
#line 75 "encoding.vala"
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
#line 357 "encoding.c"
			SkkEntry entry = {0};
#line 75 "encoding.vala"
			entry = entry_collection[entry_it];
#line 361 "encoding.c"
			{
				SkkEntry _tmp0_;
				gconstpointer _tmp1_;
#line 76 "encoding.vala"
				_tmp0_ = entry;
#line 76 "encoding.vala"
				_tmp1_ = _tmp0_.value;
#line 76 "encoding.vala"
				if (g_strcmp0 ((const gchar*) _tmp1_, coding) == 0) {
#line 371 "encoding.c"
					SkkEntry _tmp2_;
					gconstpointer _tmp3_;
#line 77 "encoding.vala"
					_tmp2_ = entry;
#line 77 "encoding.vala"
					_tmp3_ = _tmp2_.key;
#line 77 "encoding.vala"
					self = (SkkEncodingConverter*) skk_encoding_converter_construct (object_type, (const gchar*) _tmp3_, &_inner_error0_);
#line 77 "encoding.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "encoding.vala"
						g_propagate_error (error, _inner_error0_);
#line 77 "encoding.vala"
						_g_object_unref0 (self);
#line 77 "encoding.vala"
						return NULL;
#line 388 "encoding.c"
					}
#line 78 "encoding.vala"
					return self;
#line 392 "encoding.c"
				}
			}
		}
	}
#line 81 "encoding.vala"
	g_assert_not_reached ();
#line 74 "encoding.vala"
	return self;
#line 401 "encoding.c"
}

SkkEncodingConverter*
skk_encoding_converter_new_from_coding_system (const gchar* coding,
                                               GError** error)
{
#line 74 "encoding.vala"
	return skk_encoding_converter_construct_from_coding_system (SKK_TYPE_ENCODING_CONVERTER, coding, error);
#line 410 "encoding.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 447 "encoding.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 453 "encoding.c"
}

static guint8*
_vala_array_dup1 (guint8* self,
                  gssize length)
{
#line 85 "encoding.vala"
	if (length > 0) {
#line 85 "encoding.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 464 "encoding.c"
	}
#line 85 "encoding.vala"
	return NULL;
#line 468 "encoding.c"
}

static gchar*
skk_encoding_converter_convert (SkkEncodingConverter* self,
                                GCharsetConverter* converter,
                                const gchar* str,
                                GError** error)
{
	guint8* inbuf = NULL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint inbuf_length1;
	gint _inbuf_size_;
	guint8* outbuf = NULL;
	guint8* _tmp4_;
	gint outbuf_length1;
	gint _outbuf_size_;
	GString* builder = NULL;
	GString* _tmp5_;
	gsize total_bytes_read = 0UL;
	GString* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 84 "encoding.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "encoding.vala"
	g_return_val_if_fail (converter != NULL, NULL);
#line 84 "encoding.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 85 "encoding.vala"
	_tmp0_ = string_get_data (str, &_tmp1_);
#line 85 "encoding.vala"
	_tmp0__length1 = _tmp1_;
#line 85 "encoding.vala"
	_tmp2_ = _tmp0_;
#line 85 "encoding.vala"
	_tmp2__length1 = _tmp0__length1;
#line 85 "encoding.vala"
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup1 (_tmp2_, _tmp2__length1) : _tmp2_;
#line 85 "encoding.vala"
	_tmp3__length1 = _tmp2__length1;
#line 85 "encoding.vala"
	inbuf = _tmp3_;
#line 85 "encoding.vala"
	inbuf_length1 = _tmp3__length1;
#line 85 "encoding.vala"
	_inbuf_size_ = inbuf_length1;
#line 86 "encoding.vala"
	_tmp4_ = g_new0 (guint8, SKK_ENCODING_CONVERTER_BUFSIZ);
#line 86 "encoding.vala"
	outbuf = _tmp4_;
#line 86 "encoding.vala"
	outbuf_length1 = SKK_ENCODING_CONVERTER_BUFSIZ;
#line 86 "encoding.vala"
	_outbuf_size_ = outbuf_length1;
#line 87 "encoding.vala"
	_tmp5_ = g_string_new ("");
#line 87 "encoding.vala"
	builder = _tmp5_;
#line 88 "encoding.vala"
	total_bytes_read = (gsize) 0;
#line 89 "encoding.vala"
	while (TRUE) {
#line 539 "encoding.c"
		guint8* _tmp6_;
		gint _tmp6__length1;
		gsize bytes_read = 0UL;
		gsize bytes_written = 0UL;
		guint8* _tmp7_;
		gint _tmp7__length1;
		guint8* _tmp8_;
		gint _tmp8__length1;
		guint8* _tmp9_;
		gint _tmp9__length1;
		gsize _tmp10_ = 0UL;
		gsize _tmp11_ = 0UL;
#line 89 "encoding.vala"
		_tmp6_ = inbuf;
#line 89 "encoding.vala"
		_tmp6__length1 = inbuf_length1;
#line 89 "encoding.vala"
		if (!(total_bytes_read < ((gsize) _tmp6__length1))) {
#line 89 "encoding.vala"
			break;
#line 560 "encoding.c"
		}
#line 96 "encoding.vala"
		_tmp7_ = inbuf;
#line 96 "encoding.vala"
		_tmp7__length1 = inbuf_length1;
#line 96 "encoding.vala"
		_tmp8_ = inbuf;
#line 96 "encoding.vala"
		_tmp8__length1 = inbuf_length1;
#line 96 "encoding.vala"
		_tmp9_ = outbuf;
#line 96 "encoding.vala"
		_tmp9__length1 = outbuf_length1;
#line 96 "encoding.vala"
		g_converter_convert ((GConverter*) converter, _tmp7_ + ((gint) total_bytes_read), (gsize) (_tmp8__length1 - ((gint) total_bytes_read)), _tmp9_, (gsize) _tmp9__length1, G_CONVERTER_INPUT_AT_END, &_tmp10_, &_tmp11_, &_inner_error0_);
#line 96 "encoding.vala"
		bytes_read = _tmp10_;
#line 96 "encoding.vala"
		bytes_written = _tmp11_;
#line 96 "encoding.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "encoding.vala"
			g_propagate_error (error, _inner_error0_);
#line 96 "encoding.vala"
			_g_string_free0 (builder);
#line 96 "encoding.vala"
			outbuf = (g_free (outbuf), NULL);
#line 96 "encoding.vala"
			inbuf = (g_free (inbuf), NULL);
#line 96 "encoding.vala"
			return NULL;
#line 592 "encoding.c"
		}
		{
			gint i = 0;
#line 101 "encoding.vala"
			i = 0;
#line 598 "encoding.c"
			{
				gboolean _tmp12_ = FALSE;
#line 101 "encoding.vala"
				_tmp12_ = TRUE;
#line 101 "encoding.vala"
				while (TRUE) {
#line 605 "encoding.c"
					GString* _tmp14_;
					guint8* _tmp15_;
					gint _tmp15__length1;
					guint8 _tmp16_;
#line 101 "encoding.vala"
					if (!_tmp12_) {
#line 612 "encoding.c"
						gint _tmp13_;
#line 101 "encoding.vala"
						_tmp13_ = i;
#line 101 "encoding.vala"
						i = _tmp13_ + 1;
#line 618 "encoding.c"
					}
#line 101 "encoding.vala"
					_tmp12_ = FALSE;
#line 101 "encoding.vala"
					if (!(((gsize) i) < bytes_written)) {
#line 101 "encoding.vala"
						break;
#line 626 "encoding.c"
					}
#line 102 "encoding.vala"
					_tmp14_ = builder;
#line 102 "encoding.vala"
					_tmp15_ = outbuf;
#line 102 "encoding.vala"
					_tmp15__length1 = outbuf_length1;
#line 102 "encoding.vala"
					_tmp16_ = _tmp15_[i];
#line 102 "encoding.vala"
					g_string_append_c (_tmp14_, (gchar) _tmp16_);
#line 638 "encoding.c"
				}
			}
		}
#line 103 "encoding.vala"
		total_bytes_read += bytes_read;
#line 644 "encoding.c"
	}
#line 105 "encoding.vala"
	_tmp17_ = builder;
#line 105 "encoding.vala"
	_tmp18_ = _tmp17_->str;
#line 105 "encoding.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 105 "encoding.vala"
	result = _tmp19_;
#line 105 "encoding.vala"
	_g_string_free0 (builder);
#line 105 "encoding.vala"
	outbuf = (g_free (outbuf), NULL);
#line 105 "encoding.vala"
	inbuf = (g_free (inbuf), NULL);
#line 105 "encoding.vala"
	return result;
#line 662 "encoding.c"
}

gchar*
skk_encoding_converter_encode (SkkEncodingConverter* self,
                               const gchar* internal_str,
                               GError** error)
{
	gchar* _tmp0_ = NULL;
	GCharsetConverter* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 108 "encoding.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 108 "encoding.vala"
	g_return_val_if_fail (internal_str != NULL, NULL);
#line 109 "encoding.vala"
	_tmp1_ = self->priv->encoder;
#line 109 "encoding.vala"
	_tmp2_ = skk_encoding_converter_convert (self, _tmp1_, internal_str, &_inner_error0_);
#line 109 "encoding.vala"
	_tmp0_ = _tmp2_;
#line 109 "encoding.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 109 "encoding.vala"
		g_propagate_error (error, _inner_error0_);
#line 109 "encoding.vala"
		return NULL;
#line 692 "encoding.c"
	}
#line 109 "encoding.vala"
	_tmp3_ = _tmp0_;
#line 109 "encoding.vala"
	_tmp0_ = NULL;
#line 109 "encoding.vala"
	result = _tmp3_;
#line 109 "encoding.vala"
	_g_free0 (_tmp0_);
#line 109 "encoding.vala"
	return result;
#line 704 "encoding.c"
}

gchar*
skk_encoding_converter_decode (SkkEncodingConverter* self,
                               const gchar* external_str,
                               GError** error)
{
	gchar* _tmp0_ = NULL;
	GCharsetConverter* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 112 "encoding.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 112 "encoding.vala"
	g_return_val_if_fail (external_str != NULL, NULL);
#line 113 "encoding.vala"
	_tmp1_ = self->priv->decoder;
#line 113 "encoding.vala"
	_tmp2_ = skk_encoding_converter_convert (self, _tmp1_, external_str, &_inner_error0_);
#line 113 "encoding.vala"
	_tmp0_ = _tmp2_;
#line 113 "encoding.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "encoding.vala"
		g_propagate_error (error, _inner_error0_);
#line 113 "encoding.vala"
		return NULL;
#line 734 "encoding.c"
	}
#line 113 "encoding.vala"
	_tmp3_ = _tmp0_;
#line 113 "encoding.vala"
	_tmp0_ = NULL;
#line 113 "encoding.vala"
	result = _tmp3_;
#line 113 "encoding.vala"
	_g_free0 (_tmp0_);
#line 113 "encoding.vala"
	return result;
#line 746 "encoding.c"
}

const gchar*
skk_encoding_converter_get_encoding (SkkEncodingConverter* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 63 "encoding.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 63 "encoding.vala"
	_tmp0_ = self->priv->_encoding;
#line 63 "encoding.vala"
	result = _tmp0_;
#line 63 "encoding.vala"
	return result;
#line 762 "encoding.c"
}

static void
skk_encoding_converter_set_encoding (SkkEncodingConverter* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 63 "encoding.vala"
	g_return_if_fail (self != NULL);
#line 63 "encoding.vala"
	old_value = skk_encoding_converter_get_encoding (self);
#line 63 "encoding.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 776 "encoding.c"
		gchar* _tmp0_;
#line 63 "encoding.vala"
		_tmp0_ = g_strdup (value);
#line 63 "encoding.vala"
		_g_free0 (self->priv->_encoding);
#line 63 "encoding.vala"
		self->priv->_encoding = _tmp0_;
#line 63 "encoding.vala"
		g_object_notify_by_pspec ((GObject *) self, skk_encoding_converter_properties[SKK_ENCODING_CONVERTER_ENCODING_PROPERTY]);
#line 786 "encoding.c"
	}
}

static void
skk_encoding_converter_class_init (SkkEncodingConverterClass * klass,
                                   gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 21 "encoding.vala"
	skk_encoding_converter_parent_class = g_type_class_peek_parent (klass);
#line 21 "encoding.vala"
	g_type_class_adjust_private_offset (klass, &SkkEncodingConverter_private_offset);
#line 21 "encoding.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_skk_encoding_converter_get_property;
#line 21 "encoding.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_skk_encoding_converter_set_property;
#line 21 "encoding.vala"
	G_OBJECT_CLASS (klass)->finalize = skk_encoding_converter_finalize;
#line 21 "encoding.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_ENCODING_CONVERTER_ENCODING_PROPERTY, skk_encoding_converter_properties[SKK_ENCODING_CONVERTER_ENCODING_PROPERTY] = g_param_spec_string ("encoding", "encoding", "encoding", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 807 "encoding.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
#line 39 "encoding.vala"
		_tmp1_ = g_regex_new ("-\\*-.*[ \t]coding:[ \t]*([^ \t;]+?)[ \t;].*-\\*-", 0, 0, &_inner_error0_);
#line 39 "encoding.vala"
		_tmp0_ = _tmp1_;
#line 39 "encoding.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "encoding.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 820 "encoding.c"
				goto __catch0_g_regex_error;
			}
#line 39 "encoding.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 39 "encoding.vala"
			g_clear_error (&_inner_error0_);
#line 827 "encoding.c"
		}
#line 39 "encoding.vala"
		_tmp2_ = _tmp0_;
#line 39 "encoding.vala"
		_tmp0_ = NULL;
#line 39 "encoding.vala"
		_g_regex_unref0 (skk_encoding_converter_coding_cookie_regex);
#line 39 "encoding.vala"
		skk_encoding_converter_coding_cookie_regex = _tmp2_;
#line 38 "encoding.vala"
		_g_regex_unref0 (_tmp0_);
#line 839 "encoding.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 38 "encoding.vala"
		g_clear_error (&_inner_error0_);
#line 42 "encoding.vala"
		g_assert_not_reached ();
#line 848 "encoding.c"
	}
	__finally0:
#line 38 "encoding.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 38 "encoding.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 38 "encoding.vala"
		g_clear_error (&_inner_error0_);
#line 857 "encoding.c"
	}
}

static void
skk_encoding_converter_instance_init (SkkEncodingConverter * self,
                                      gpointer klass)
{
#line 21 "encoding.vala"
	self->priv = skk_encoding_converter_get_instance_private (self);
#line 867 "encoding.c"
}

static void
skk_encoding_converter_finalize (GObject * obj)
{
	SkkEncodingConverter * self;
#line 21 "encoding.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverter);
#line 63 "encoding.vala"
	_g_free0 (self->priv->_encoding);
#line 65 "encoding.vala"
	_g_object_unref0 (self->priv->encoder);
#line 66 "encoding.vala"
	_g_object_unref0 (self->priv->decoder);
#line 21 "encoding.vala"
	G_OBJECT_CLASS (skk_encoding_converter_parent_class)->finalize (obj);
#line 884 "encoding.c"
}

static GType
skk_encoding_converter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SkkEncodingConverterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) skk_encoding_converter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SkkEncodingConverter), 0, (GInstanceInitFunc) skk_encoding_converter_instance_init, NULL };
	GType skk_encoding_converter_type_id;
	skk_encoding_converter_type_id = g_type_register_static (G_TYPE_OBJECT, "SkkEncodingConverter", &g_define_type_info, 0);
	SkkEncodingConverter_private_offset = g_type_add_instance_private (skk_encoding_converter_type_id, sizeof (SkkEncodingConverterPrivate));
	return skk_encoding_converter_type_id;
}

GType
skk_encoding_converter_get_type (void)
{
	static volatile gsize skk_encoding_converter_type_id__once = 0;
	if (g_once_init_enter (&skk_encoding_converter_type_id__once)) {
		GType skk_encoding_converter_type_id;
		skk_encoding_converter_type_id = skk_encoding_converter_get_type_once ();
		g_once_init_leave (&skk_encoding_converter_type_id__once, skk_encoding_converter_type_id);
	}
	return skk_encoding_converter_type_id__once;
}

static void
_vala_skk_encoding_converter_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	SkkEncodingConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverter);
#line 21 "encoding.vala"
	switch (property_id) {
#line 21 "encoding.vala"
		case SKK_ENCODING_CONVERTER_ENCODING_PROPERTY:
#line 21 "encoding.vala"
		g_value_set_string (value, skk_encoding_converter_get_encoding (self));
#line 21 "encoding.vala"
		break;
#line 925 "encoding.c"
		default:
#line 21 "encoding.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "encoding.vala"
		break;
#line 931 "encoding.c"
	}
}

static void
_vala_skk_encoding_converter_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	SkkEncodingConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverter);
#line 21 "encoding.vala"
	switch (property_id) {
#line 21 "encoding.vala"
		case SKK_ENCODING_CONVERTER_ENCODING_PROPERTY:
#line 21 "encoding.vala"
		skk_encoding_converter_set_encoding (self, g_value_get_string (value));
#line 21 "encoding.vala"
		break;
#line 951 "encoding.c"
		default:
#line 21 "encoding.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "encoding.vala"
		break;
#line 957 "encoding.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

