/* expr.c generated by valac 0.56.17, the Vala compiler
 * generated from expr.vala, do not modify */

/*
 * Copyright (C) 2011-2018 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <config.h>
#include "libskk/libskk.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef enum  {
	SKK_EXPR_NODE_TYPE_ARRAY,
	SKK_EXPR_NODE_TYPE_SYMBOL,
	SKK_EXPR_NODE_TYPE_STRING
} SkkExprNodeType;

#define SKK_TYPE_EXPR_NODE_TYPE (skk_expr_node_type_get_type ())

#define SKK_TYPE_EXPR_NODE (skk_expr_node_get_type ())
typedef struct _SkkExprNode SkkExprNode;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define SKK_TYPE_EXPR_READER (skk_expr_reader_get_type ())
#define SKK_EXPR_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SKK_TYPE_EXPR_READER, SkkExprReader))
#define SKK_EXPR_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SKK_TYPE_EXPR_READER, SkkExprReaderClass))
#define SKK_IS_EXPR_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SKK_TYPE_EXPR_READER))
#define SKK_IS_EXPR_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SKK_TYPE_EXPR_READER))
#define SKK_EXPR_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SKK_TYPE_EXPR_READER, SkkExprReaderClass))

typedef struct _SkkExprReader SkkExprReader;
typedef struct _SkkExprReaderClass SkkExprReaderClass;
typedef struct _SkkExprReaderPrivate SkkExprReaderPrivate;
enum  {
	SKK_EXPR_READER_0_PROPERTY,
	SKK_EXPR_READER_NUM_PROPERTIES
};
static GParamSpec* skk_expr_reader_properties[SKK_EXPR_READER_NUM_PROPERTIES];
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _skk_expr_node_free0(var) ((var == NULL) ? NULL : (var = (skk_expr_node_free (var), NULL)))

#define SKK_TYPE_EXPR_EVALUATOR (skk_expr_evaluator_get_type ())
#define SKK_EXPR_EVALUATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SKK_TYPE_EXPR_EVALUATOR, SkkExprEvaluator))
#define SKK_EXPR_EVALUATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SKK_TYPE_EXPR_EVALUATOR, SkkExprEvaluatorClass))
#define SKK_IS_EXPR_EVALUATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SKK_TYPE_EXPR_EVALUATOR))
#define SKK_IS_EXPR_EVALUATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SKK_TYPE_EXPR_EVALUATOR))
#define SKK_EXPR_EVALUATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SKK_TYPE_EXPR_EVALUATOR, SkkExprEvaluatorClass))

typedef struct _SkkExprEvaluator SkkExprEvaluator;
typedef struct _SkkExprEvaluatorClass SkkExprEvaluatorClass;
typedef struct _SkkExprEvaluatorPrivate SkkExprEvaluatorPrivate;
enum  {
	SKK_EXPR_EVALUATOR_0_PROPERTY,
	SKK_EXPR_EVALUATOR_NUM_PROPERTIES
};
static GParamSpec* skk_expr_evaluator_properties[SKK_EXPR_EVALUATOR_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _SkkExprNode {
	SkkExprNodeType type;
	GeeLinkedList* nodes;
	gchar* data;
};

struct _SkkExprReader {
	GObject parent_instance;
	SkkExprReaderPrivate * priv;
};

struct _SkkExprReaderClass {
	GObjectClass parent_class;
};

struct _SkkExprEvaluator {
	GObject parent_instance;
	SkkExprEvaluatorPrivate * priv;
};

struct _SkkExprEvaluatorClass {
	GObjectClass parent_class;
};

static gpointer skk_expr_reader_parent_class = NULL;
static gpointer skk_expr_evaluator_parent_class = NULL;

VALA_EXTERN GType skk_expr_node_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType skk_expr_node_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SkkExprNode* skk_expr_node_dup (const SkkExprNode* self);
VALA_EXTERN void skk_expr_node_free (SkkExprNode* self);
VALA_EXTERN void skk_expr_node_copy (const SkkExprNode* self,
                         SkkExprNode* dest);
VALA_EXTERN void skk_expr_node_destroy (SkkExprNode* self);
VALA_EXTERN void skk_expr_node_init (SkkExprNode *self,
                         SkkExprNodeType type);
VALA_EXTERN GType skk_expr_reader_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void skk_expr_reader_read_symbol (SkkExprReader* self,
                                  const gchar* expr,
                                  gint* index,
                                  SkkExprNode* result);
VALA_EXTERN SkkExprNode* skk_expr_reader_read_string (SkkExprReader* self,
                                          const gchar* expr,
                                          gint* index);
VALA_EXTERN SkkExprNode* skk_expr_reader_read_expr (SkkExprReader* self,
                                        const gchar* expr,
                                        gint* index);
VALA_EXTERN SkkExprReader* skk_expr_reader_new (void);
VALA_EXTERN SkkExprReader* skk_expr_reader_construct (GType object_type);
static GType skk_expr_reader_get_type_once (void);
VALA_EXTERN GType skk_expr_evaluator_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* skk_expr_evaluator_eval (SkkExprEvaluator* self,
                                SkkExprNode* node);
VALA_EXTERN SkkExprEvaluator* skk_expr_evaluator_new (void);
VALA_EXTERN SkkExprEvaluator* skk_expr_evaluator_construct (GType object_type);
static GType skk_expr_evaluator_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
skk_expr_node_type_get_type_once (void)
{
	static const GEnumValue values[] = {{SKK_EXPR_NODE_TYPE_ARRAY, "SKK_EXPR_NODE_TYPE_ARRAY", "array"}, {SKK_EXPR_NODE_TYPE_SYMBOL, "SKK_EXPR_NODE_TYPE_SYMBOL", "symbol"}, {SKK_EXPR_NODE_TYPE_STRING, "SKK_EXPR_NODE_TYPE_STRING", "string"}, {0, NULL, NULL}};
	GType skk_expr_node_type_type_id;
	skk_expr_node_type_type_id = g_enum_register_static ("SkkExprNodeType", values);
	return skk_expr_node_type_type_id;
}

GType
skk_expr_node_type_get_type (void)
{
	static volatile gsize skk_expr_node_type_type_id__once = 0;
	if (g_once_init_enter (&skk_expr_node_type_type_id__once)) {
		GType skk_expr_node_type_type_id;
		skk_expr_node_type_type_id = skk_expr_node_type_get_type_once ();
		g_once_init_leave (&skk_expr_node_type_type_id__once, skk_expr_node_type_type_id);
	}
	return skk_expr_node_type_type_id__once;
}

void
skk_expr_node_init (SkkExprNode *self,
                    SkkExprNodeType type)
{
#line 31 "expr.vala"
	memset (self, 0, sizeof (SkkExprNode));
#line 32 "expr.vala"
	(*self).type = type;
#line 176 "expr.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 27 "expr.vala"
	return self ? g_object_ref (self) : NULL;
#line 184 "expr.c"
}

void
skk_expr_node_copy (const SkkExprNode* self,
                    SkkExprNode* dest)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 27 "expr.vala"
	(*dest).type = (*self).type;
#line 27 "expr.vala"
	_tmp0_ = (*self).nodes;
#line 27 "expr.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 27 "expr.vala"
	_g_object_unref0 ((*dest).nodes);
#line 27 "expr.vala"
	(*dest).nodes = _tmp1_;
#line 27 "expr.vala"
	_tmp2_ = (*self).data;
#line 27 "expr.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 27 "expr.vala"
	_g_free0 ((*dest).data);
#line 27 "expr.vala"
	(*dest).data = _tmp3_;
#line 213 "expr.c"
}

void
skk_expr_node_destroy (SkkExprNode* self)
{
#line 29 "expr.vala"
	_g_object_unref0 ((*self).nodes);
#line 30 "expr.vala"
	_g_free0 ((*self).data);
#line 223 "expr.c"
}

SkkExprNode*
skk_expr_node_dup (const SkkExprNode* self)
{
	SkkExprNode* dup;
#line 27 "expr.vala"
	dup = g_new0 (SkkExprNode, 1);
#line 27 "expr.vala"
	skk_expr_node_copy (self, dup);
#line 27 "expr.vala"
	return dup;
#line 236 "expr.c"
}

void
skk_expr_node_free (SkkExprNode* self)
{
#line 27 "expr.vala"
	skk_expr_node_destroy (self);
#line 27 "expr.vala"
	g_free (self);
#line 246 "expr.c"
}

static GType
skk_expr_node_get_type_once (void)
{
	GType skk_expr_node_type_id;
	skk_expr_node_type_id = g_boxed_type_register_static ("SkkExprNode", (GBoxedCopyFunc) skk_expr_node_dup, (GBoxedFreeFunc) skk_expr_node_free);
	return skk_expr_node_type_id;
}

GType
skk_expr_node_get_type (void)
{
	static volatile gsize skk_expr_node_type_id__once = 0;
	if (g_once_init_enter (&skk_expr_node_type_id__once)) {
		GType skk_expr_node_type_id;
		skk_expr_node_type_id = skk_expr_node_get_type_once ();
		g_once_init_leave (&skk_expr_node_type_id__once, skk_expr_node_type_id);
	}
	return skk_expr_node_type_id__once;
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1302 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1303 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1304 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 282 "expr.c"
		gchar* _tmp0_;
#line 1305 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1305 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1306 "glib-2.0.vapi"
		result = TRUE;
#line 1306 "glib-2.0.vapi"
		if (c) {
#line 1306 "glib-2.0.vapi"
			*c = _vala_c;
#line 294 "expr.c"
		}
#line 1306 "glib-2.0.vapi"
		return result;
#line 298 "expr.c"
	} else {
#line 1308 "glib-2.0.vapi"
		result = FALSE;
#line 1308 "glib-2.0.vapi"
		if (c) {
#line 1308 "glib-2.0.vapi"
			*c = _vala_c;
#line 306 "expr.c"
		}
#line 1308 "glib-2.0.vapi"
		return result;
#line 310 "expr.c"
	}
}

void
skk_expr_reader_read_symbol (SkkExprReader* self,
                             const gchar* expr,
                             gint* index,
                             SkkExprNode* result)
{
	GString* builder = NULL;
	GString* _tmp0_;
	gboolean stop = FALSE;
	gunichar uc = 0U;
	SkkExprNode node = {0};
	GString* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
#line 37 "expr.vala"
	g_return_if_fail (self != NULL);
#line 37 "expr.vala"
	g_return_if_fail (expr != NULL);
#line 38 "expr.vala"
	_tmp0_ = g_string_new ("");
#line 38 "expr.vala"
	builder = _tmp0_;
#line 39 "expr.vala"
	stop = FALSE;
#line 40 "expr.vala"
	uc = (gunichar) '\0';
#line 41 "expr.vala"
	while (TRUE) {
#line 342 "expr.c"
		gboolean _tmp1_ = FALSE;
#line 41 "expr.vala"
		if (!stop) {
#line 346 "expr.c"
			gunichar _tmp2_ = 0U;
			gboolean _tmp3_;
#line 41 "expr.vala"
			_tmp3_ = string_get_next_char (expr, index, &_tmp2_);
#line 41 "expr.vala"
			uc = _tmp2_;
#line 41 "expr.vala"
			_tmp1_ = _tmp3_;
#line 355 "expr.c"
		} else {
#line 41 "expr.vala"
			_tmp1_ = FALSE;
#line 359 "expr.c"
		}
#line 41 "expr.vala"
		if (!_tmp1_) {
#line 41 "expr.vala"
			break;
#line 365 "expr.c"
		}
#line 42 "expr.vala"
		switch (uc) {
#line 42 "expr.vala"
			case '\\':
#line 371 "expr.c"
			{
				gunichar _tmp4_ = 0U;
				gboolean _tmp5_;
#line 44 "expr.vala"
				_tmp5_ = string_get_next_char (expr, index, &_tmp4_);
#line 44 "expr.vala"
				uc = _tmp4_;
#line 44 "expr.vala"
				if (_tmp5_) {
#line 381 "expr.c"
					GString* _tmp6_;
#line 45 "expr.vala"
					_tmp6_ = builder;
#line 45 "expr.vala"
					g_string_append_unichar (_tmp6_, uc);
#line 387 "expr.c"
				}
#line 47 "expr.vala"
				break;
#line 391 "expr.c"
			}
#line 42 "expr.vala"
			case '(':
#line 42 "expr.vala"
			case ')':
#line 42 "expr.vala"
			case '"':
#line 42 "expr.vala"
			case ' ':
#line 401 "expr.c"
			{
#line 49 "expr.vala"
				stop = TRUE;
#line 50 "expr.vala"
				break;
#line 407 "expr.c"
			}
			default:
			{
				GString* _tmp7_;
#line 52 "expr.vala"
				_tmp7_ = builder;
#line 52 "expr.vala"
				g_string_append_unichar (_tmp7_, uc);
#line 53 "expr.vala"
				break;
#line 418 "expr.c"
			}
		}
	}
#line 56 "expr.vala"
	skk_expr_node_init (&node, SKK_EXPR_NODE_TYPE_SYMBOL);
#line 57 "expr.vala"
	_tmp8_ = builder;
#line 57 "expr.vala"
	_tmp9_ = _tmp8_->str;
#line 57 "expr.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 57 "expr.vala"
	_g_free0 (node.data);
#line 57 "expr.vala"
	node.data = _tmp10_;
#line 58 "expr.vala"
	*result = node;
#line 58 "expr.vala"
	_g_string_free0 (builder);
#line 58 "expr.vala"
	return;
#line 440 "expr.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 457 "expr.c"
}

static gpointer
_skk_expr_node_dup0 (gpointer self)
{
#line 120 "expr.vala"
	return self ? skk_expr_node_dup (self) : NULL;
#line 465 "expr.c"
}

SkkExprNode*
skk_expr_reader_read_string (SkkExprReader* self,
                             const gchar* expr,
                             gint* index)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	GString* builder = NULL;
	GString* _tmp3_;
	gint _tmp4_;
	gboolean stop = FALSE;
	gunichar uc = 0U;
	SkkExprNode node = {0};
	GString* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	SkkExprNode _tmp24_;
	SkkExprNode* _tmp25_;
	SkkExprNode* _tmp26_;
	SkkExprNode* result;
#line 61 "expr.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "expr.vala"
	g_return_val_if_fail (expr != NULL, NULL);
#line 62 "expr.vala"
	_tmp1_ = strlen (expr);
#line 62 "expr.vala"
	_tmp2_ = _tmp1_;
#line 62 "expr.vala"
	if ((*index) < _tmp2_) {
#line 62 "expr.vala"
		_tmp0_ = string_get (expr, (glong) (*index)) == '"';
#line 501 "expr.c"
	} else {
#line 62 "expr.vala"
		_tmp0_ = FALSE;
#line 505 "expr.c"
	}
#line 62 "expr.vala"
	g_return_val_if_fail (_tmp0_, NULL);
#line 64 "expr.vala"
	_tmp3_ = g_string_new ("");
#line 64 "expr.vala"
	builder = _tmp3_;
#line 65 "expr.vala"
	_tmp4_ = *index;
#line 65 "expr.vala"
	*index = _tmp4_ + 1;
#line 66 "expr.vala"
	stop = FALSE;
#line 67 "expr.vala"
	uc = (gunichar) '\0';
#line 68 "expr.vala"
	while (TRUE) {
#line 523 "expr.c"
		gboolean _tmp5_ = FALSE;
#line 68 "expr.vala"
		if (!stop) {
#line 527 "expr.c"
			gunichar _tmp6_ = 0U;
			gboolean _tmp7_;
#line 68 "expr.vala"
			_tmp7_ = string_get_next_char (expr, index, &_tmp6_);
#line 68 "expr.vala"
			uc = _tmp6_;
#line 68 "expr.vala"
			_tmp5_ = _tmp7_;
#line 536 "expr.c"
		} else {
#line 68 "expr.vala"
			_tmp5_ = FALSE;
#line 540 "expr.c"
		}
#line 68 "expr.vala"
		if (!_tmp5_) {
#line 68 "expr.vala"
			break;
#line 546 "expr.c"
		}
#line 69 "expr.vala"
		switch (uc) {
#line 69 "expr.vala"
			case '\\':
#line 552 "expr.c"
			{
				gunichar _tmp8_ = 0U;
				gboolean _tmp9_;
#line 71 "expr.vala"
				_tmp9_ = string_get_next_char (expr, index, &_tmp8_);
#line 71 "expr.vala"
				uc = _tmp8_;
#line 71 "expr.vala"
				if (_tmp9_) {
#line 562 "expr.c"
					GString* _tmp19_;
#line 72 "expr.vala"
					switch (uc) {
#line 72 "expr.vala"
						case '0':
#line 72 "expr.vala"
						case '1':
#line 72 "expr.vala"
						case '2':
#line 72 "expr.vala"
						case '3':
#line 72 "expr.vala"
						case '4':
#line 72 "expr.vala"
						case '5':
#line 72 "expr.vala"
						case '6':
#line 72 "expr.vala"
						case '7':
#line 582 "expr.c"
						{
							gint start = 0;
							gint num = 0;
							gint _tmp13_;
#line 75 "expr.vala"
							start = *index;
#line 76 "expr.vala"
							num = ((gint) uc) - '0';
#line 77 "expr.vala"
							while (TRUE) {
#line 593 "expr.c"
								gunichar _tmp10_ = 0U;
								gboolean _tmp11_;
								gboolean _tmp12_ = FALSE;
#line 77 "expr.vala"
								_tmp11_ = string_get_next_char (expr, index, &_tmp10_);
#line 77 "expr.vala"
								uc = _tmp10_;
#line 77 "expr.vala"
								if (!_tmp11_) {
#line 77 "expr.vala"
									break;
#line 605 "expr.c"
								}
#line 78 "expr.vala"
								if (((*index) - start) == 3) {
#line 79 "expr.vala"
									break;
#line 611 "expr.c"
								}
#line 80 "expr.vala"
								if (uc < ((gunichar) '0')) {
#line 80 "expr.vala"
									_tmp12_ = TRUE;
#line 617 "expr.c"
								} else {
#line 80 "expr.vala"
									_tmp12_ = uc > ((gunichar) '7');
#line 621 "expr.c"
								}
#line 80 "expr.vala"
								if (_tmp12_) {
#line 81 "expr.vala"
									break;
#line 627 "expr.c"
								}
#line 82 "expr.vala"
								num <<= 3;
#line 83 "expr.vala"
								num += ((gint) uc) - '0';
#line 633 "expr.c"
							}
#line 85 "expr.vala"
							_tmp13_ = *index;
#line 85 "expr.vala"
							*index = _tmp13_ - 1;
#line 86 "expr.vala"
							uc = (gunichar) num;
#line 87 "expr.vala"
							break;
#line 643 "expr.c"
						}
#line 72 "expr.vala"
						case 'x':
#line 647 "expr.c"
						{
							gint num = 0;
							gint _tmp18_;
#line 89 "expr.vala"
							num = 0;
#line 90 "expr.vala"
							while (TRUE) {
#line 655 "expr.c"
								gunichar _tmp14_ = 0U;
								gboolean _tmp15_;
								gboolean _tmp16_ = FALSE;
#line 90 "expr.vala"
								_tmp15_ = string_get_next_char (expr, index, &_tmp14_);
#line 90 "expr.vala"
								uc = _tmp14_;
#line 90 "expr.vala"
								if (!_tmp15_) {
#line 90 "expr.vala"
									break;
#line 667 "expr.c"
								}
#line 91 "expr.vala"
								uc = g_unichar_tolower (uc);
#line 92 "expr.vala"
								if (((gunichar) '0') <= uc) {
#line 92 "expr.vala"
									_tmp16_ = uc <= ((gunichar) '9');
#line 675 "expr.c"
								} else {
#line 92 "expr.vala"
									_tmp16_ = FALSE;
#line 679 "expr.c"
								}
#line 92 "expr.vala"
								if (_tmp16_) {
#line 93 "expr.vala"
									num <<= 4;
#line 94 "expr.vala"
									num += ((gint) uc) - '0';
#line 687 "expr.c"
								} else {
									gboolean _tmp17_ = FALSE;
#line 95 "expr.vala"
									if (((gunichar) 'a') <= uc) {
#line 95 "expr.vala"
										_tmp17_ = uc <= ((gunichar) 'f');
#line 694 "expr.c"
									} else {
#line 95 "expr.vala"
										_tmp17_ = FALSE;
#line 698 "expr.c"
									}
#line 95 "expr.vala"
									if (_tmp17_) {
#line 96 "expr.vala"
										num <<= 4;
#line 97 "expr.vala"
										num += (((gint) uc) - 'a') + 10;
#line 706 "expr.c"
									} else {
#line 99 "expr.vala"
										break;
#line 710 "expr.c"
									}
								}
							}
#line 101 "expr.vala"
							_tmp18_ = *index;
#line 101 "expr.vala"
							*index = _tmp18_ - 1;
#line 102 "expr.vala"
							uc = (gunichar) num;
#line 103 "expr.vala"
							break;
#line 722 "expr.c"
						}
						default:
						{
#line 105 "expr.vala"
							break;
#line 728 "expr.c"
						}
					}
#line 107 "expr.vala"
					_tmp19_ = builder;
#line 107 "expr.vala"
					g_string_append_unichar (_tmp19_, uc);
#line 735 "expr.c"
				}
#line 109 "expr.vala"
				break;
#line 739 "expr.c"
			}
#line 69 "expr.vala"
			case '\"':
#line 743 "expr.c"
			{
#line 111 "expr.vala"
				stop = TRUE;
#line 112 "expr.vala"
				break;
#line 749 "expr.c"
			}
			default:
			{
				GString* _tmp20_;
#line 114 "expr.vala"
				_tmp20_ = builder;
#line 114 "expr.vala"
				g_string_append_unichar (_tmp20_, uc);
#line 115 "expr.vala"
				break;
#line 760 "expr.c"
			}
		}
	}
#line 118 "expr.vala"
	skk_expr_node_init (&node, SKK_EXPR_NODE_TYPE_STRING);
#line 119 "expr.vala"
	_tmp21_ = builder;
#line 119 "expr.vala"
	_tmp22_ = _tmp21_->str;
#line 119 "expr.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 119 "expr.vala"
	_g_free0 (node.data);
#line 119 "expr.vala"
	node.data = _tmp23_;
#line 120 "expr.vala"
	_tmp24_ = node;
#line 120 "expr.vala"
	_tmp25_ = _skk_expr_node_dup0 (&_tmp24_);
#line 120 "expr.vala"
	_tmp26_ = _tmp25_;
#line 120 "expr.vala"
	skk_expr_node_destroy (&_tmp24_);
#line 120 "expr.vala"
	result = _tmp26_;
#line 120 "expr.vala"
	_g_string_free0 (builder);
#line 120 "expr.vala"
	return result;
#line 790 "expr.c"
}

SkkExprNode*
skk_expr_reader_read_expr (SkkExprReader* self,
                           const gchar* expr,
                           gint* index)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	GeeLinkedList* nodes = NULL;
	GeeLinkedList* _tmp3_;
	gboolean stop = FALSE;
	gint _tmp4_;
	gunichar uc = 0U;
	SkkExprNode node = {0};
	GeeLinkedList* _tmp22_;
	GeeLinkedList* _tmp23_;
	SkkExprNode _tmp24_;
	SkkExprNode* _tmp25_;
	SkkExprNode* _tmp26_;
	SkkExprNode* result;
#line 123 "expr.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 123 "expr.vala"
	g_return_val_if_fail (expr != NULL, NULL);
#line 124 "expr.vala"
	_tmp1_ = strlen (expr);
#line 124 "expr.vala"
	_tmp2_ = _tmp1_;
#line 124 "expr.vala"
	if ((*index) < _tmp2_) {
#line 124 "expr.vala"
		_tmp0_ = string_get (expr, (glong) (*index)) == '(';
#line 825 "expr.c"
	} else {
#line 124 "expr.vala"
		_tmp0_ = FALSE;
#line 829 "expr.c"
	}
#line 124 "expr.vala"
	g_return_val_if_fail (_tmp0_, NULL);
#line 126 "expr.vala"
	_tmp3_ = gee_linked_list_new (SKK_TYPE_EXPR_NODE, (GBoxedCopyFunc) skk_expr_node_dup, (GDestroyNotify) skk_expr_node_free, NULL, NULL, NULL);
#line 126 "expr.vala"
	nodes = _tmp3_;
#line 127 "expr.vala"
	stop = FALSE;
#line 128 "expr.vala"
	_tmp4_ = *index;
#line 128 "expr.vala"
	*index = _tmp4_ + 1;
#line 129 "expr.vala"
	uc = (gunichar) '\0';
#line 130 "expr.vala"
	while (TRUE) {
#line 847 "expr.c"
		gboolean _tmp5_ = FALSE;
#line 130 "expr.vala"
		if (!stop) {
#line 851 "expr.c"
			gunichar _tmp6_ = 0U;
			gboolean _tmp7_;
#line 130 "expr.vala"
			_tmp7_ = string_get_next_char (expr, index, &_tmp6_);
#line 130 "expr.vala"
			uc = _tmp6_;
#line 130 "expr.vala"
			_tmp5_ = _tmp7_;
#line 860 "expr.c"
		} else {
#line 130 "expr.vala"
			_tmp5_ = FALSE;
#line 864 "expr.c"
		}
#line 130 "expr.vala"
		if (!_tmp5_) {
#line 130 "expr.vala"
			break;
#line 870 "expr.c"
		}
#line 131 "expr.vala"
		switch (uc) {
#line 131 "expr.vala"
			case ' ':
#line 876 "expr.c"
			{
#line 133 "expr.vala"
				break;
#line 880 "expr.c"
			}
#line 131 "expr.vala"
			case ')':
#line 884 "expr.c"
			{
				gint _tmp8_;
#line 135 "expr.vala"
				_tmp8_ = *index;
#line 135 "expr.vala"
				*index = _tmp8_ + 1;
#line 136 "expr.vala"
				stop = TRUE;
#line 137 "expr.vala"
				break;
#line 895 "expr.c"
			}
#line 131 "expr.vala"
			case '(':
#line 899 "expr.c"
			{
				gint _tmp9_;
				GeeLinkedList* _tmp10_;
				SkkExprNode* _tmp11_;
				SkkExprNode* _tmp12_;
#line 139 "expr.vala"
				_tmp9_ = *index;
#line 139 "expr.vala"
				*index = _tmp9_ - 1;
#line 140 "expr.vala"
				_tmp10_ = nodes;
#line 140 "expr.vala"
				_tmp11_ = skk_expr_reader_read_expr (self, expr, index);
#line 140 "expr.vala"
				_tmp12_ = _tmp11_;
#line 140 "expr.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp12_);
#line 140 "expr.vala"
				_skk_expr_node_free0 (_tmp12_);
#line 141 "expr.vala"
				break;
#line 921 "expr.c"
			}
#line 131 "expr.vala"
			case '"':
#line 925 "expr.c"
			{
				gint _tmp13_;
				GeeLinkedList* _tmp14_;
				SkkExprNode* _tmp15_;
				SkkExprNode* _tmp16_;
#line 143 "expr.vala"
				_tmp13_ = *index;
#line 143 "expr.vala"
				*index = _tmp13_ - 1;
#line 144 "expr.vala"
				_tmp14_ = nodes;
#line 144 "expr.vala"
				_tmp15_ = skk_expr_reader_read_string (self, expr, index);
#line 144 "expr.vala"
				_tmp16_ = _tmp15_;
#line 144 "expr.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp16_);
#line 144 "expr.vala"
				_skk_expr_node_free0 (_tmp16_);
#line 145 "expr.vala"
				break;
#line 947 "expr.c"
			}
			default:
			{
				gint _tmp17_;
				GeeLinkedList* _tmp18_;
				SkkExprNode _tmp19_ = {0};
				SkkExprNode _tmp20_;
				SkkExprNode _tmp21_;
#line 147 "expr.vala"
				_tmp17_ = *index;
#line 147 "expr.vala"
				*index = _tmp17_ - 1;
#line 148 "expr.vala"
				_tmp18_ = nodes;
#line 148 "expr.vala"
				skk_expr_reader_read_symbol (self, expr, index, &_tmp19_);
#line 148 "expr.vala"
				_tmp20_ = _tmp19_;
#line 148 "expr.vala"
				_tmp21_ = _tmp20_;
#line 148 "expr.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, &_tmp21_);
#line 148 "expr.vala"
				skk_expr_node_destroy (&_tmp20_);
#line 149 "expr.vala"
				break;
#line 974 "expr.c"
			}
		}
	}
#line 152 "expr.vala"
	skk_expr_node_init (&node, SKK_EXPR_NODE_TYPE_ARRAY);
#line 153 "expr.vala"
	_tmp22_ = nodes;
#line 153 "expr.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 153 "expr.vala"
	_g_object_unref0 (node.nodes);
#line 153 "expr.vala"
	node.nodes = _tmp23_;
#line 154 "expr.vala"
	_tmp24_ = node;
#line 154 "expr.vala"
	_tmp25_ = _skk_expr_node_dup0 (&_tmp24_);
#line 154 "expr.vala"
	_tmp26_ = _tmp25_;
#line 154 "expr.vala"
	skk_expr_node_destroy (&_tmp24_);
#line 154 "expr.vala"
	result = _tmp26_;
#line 154 "expr.vala"
	_g_object_unref0 (nodes);
#line 154 "expr.vala"
	return result;
#line 1002 "expr.c"
}

SkkExprReader*
skk_expr_reader_construct (GType object_type)
{
	SkkExprReader * self = NULL;
#line 36 "expr.vala"
	self = (SkkExprReader*) g_object_new (object_type, NULL);
#line 36 "expr.vala"
	return self;
#line 1013 "expr.c"
}

SkkExprReader*
skk_expr_reader_new (void)
{
#line 36 "expr.vala"
	return skk_expr_reader_construct (SKK_TYPE_EXPR_READER);
#line 1021 "expr.c"
}

static void
skk_expr_reader_class_init (SkkExprReaderClass * klass,
                            gpointer klass_data)
{
#line 36 "expr.vala"
	skk_expr_reader_parent_class = g_type_class_peek_parent (klass);
#line 1030 "expr.c"
}

static void
skk_expr_reader_instance_init (SkkExprReader * self,
                               gpointer klass)
{
}

static GType
skk_expr_reader_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SkkExprReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) skk_expr_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SkkExprReader), 0, (GInstanceInitFunc) skk_expr_reader_instance_init, NULL };
	GType skk_expr_reader_type_id;
	skk_expr_reader_type_id = g_type_register_static (G_TYPE_OBJECT, "SkkExprReader", &g_define_type_info, 0);
	return skk_expr_reader_type_id;
}

GType
skk_expr_reader_get_type (void)
{
	static volatile gsize skk_expr_reader_type_id__once = 0;
	if (g_once_init_enter (&skk_expr_reader_type_id__once)) {
		GType skk_expr_reader_type_id;
		skk_expr_reader_type_id = skk_expr_reader_get_type_once ();
		g_once_init_leave (&skk_expr_reader_type_id__once, skk_expr_reader_type_id);
	}
	return skk_expr_reader_type_id__once;
}

gchar*
skk_expr_evaluator_eval (SkkExprEvaluator* self,
                         SkkExprNode* node)
{
	SkkExprNode _tmp0_;
	gchar* result;
#line 159 "expr.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 159 "expr.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 160 "expr.vala"
	_tmp0_ = *node;
#line 160 "expr.vala"
	if (_tmp0_.type == SKK_EXPR_NODE_TYPE_ARRAY) {
#line 1074 "expr.c"
		GeeListIterator* iter = NULL;
		SkkExprNode _tmp1_;
		GeeLinkedList* _tmp2_;
		GeeListIterator* _tmp3_;
		GeeListIterator* _tmp4_;
#line 161 "expr.vala"
		_tmp1_ = *node;
#line 161 "expr.vala"
		_tmp2_ = _tmp1_.nodes;
#line 161 "expr.vala"
		_tmp3_ = gee_abstract_list_list_iterator ((GeeAbstractList*) _tmp2_);
#line 161 "expr.vala"
		iter = _tmp3_;
#line 162 "expr.vala"
		_tmp4_ = iter;
#line 162 "expr.vala"
		if (gee_iterator_next ((GeeIterator*) _tmp4_)) {
#line 1092 "expr.c"
			SkkExprNode* funcall = NULL;
			GeeListIterator* _tmp5_;
			gpointer _tmp6_;
			SkkExprNode* _tmp7_;
#line 163 "expr.vala"
			_tmp5_ = iter;
#line 163 "expr.vala"
			_tmp6_ = gee_iterator_get ((GeeIterator*) _tmp5_);
#line 163 "expr.vala"
			funcall = (SkkExprNode*) _tmp6_;
#line 164 "expr.vala"
			_tmp7_ = funcall;
#line 164 "expr.vala"
			if ((*_tmp7_).type == SKK_EXPR_NODE_TYPE_SYMBOL) {
#line 1107 "expr.c"
				SkkExprNode* _tmp8_;
				const gchar* _tmp9_;
#line 166 "expr.vala"
				_tmp8_ = funcall;
#line 166 "expr.vala"
				_tmp9_ = (*_tmp8_).data;
#line 166 "expr.vala"
				if (g_strcmp0 (_tmp9_, "concat") == 0) {
#line 1116 "expr.c"
					GString* builder = NULL;
					GString* _tmp10_;
					GString* _tmp18_;
					const gchar* _tmp19_;
					gchar* _tmp20_;
#line 167 "expr.vala"
					_tmp10_ = g_string_new ("");
#line 167 "expr.vala"
					builder = _tmp10_;
#line 168 "expr.vala"
					while (TRUE) {
#line 1128 "expr.c"
						GeeListIterator* _tmp11_;
						SkkExprNode* arg = NULL;
						GeeListIterator* _tmp12_;
						gpointer _tmp13_;
						SkkExprNode* _tmp14_;
#line 168 "expr.vala"
						_tmp11_ = iter;
#line 168 "expr.vala"
						if (!gee_iterator_next ((GeeIterator*) _tmp11_)) {
#line 168 "expr.vala"
							break;
#line 1140 "expr.c"
						}
#line 169 "expr.vala"
						_tmp12_ = iter;
#line 169 "expr.vala"
						_tmp13_ = gee_iterator_get ((GeeIterator*) _tmp12_);
#line 169 "expr.vala"
						arg = (SkkExprNode*) _tmp13_;
#line 170 "expr.vala"
						_tmp14_ = arg;
#line 170 "expr.vala"
						if ((*_tmp14_).type == SKK_EXPR_NODE_TYPE_STRING) {
#line 1152 "expr.c"
							GString* _tmp15_;
							SkkExprNode* _tmp16_;
							const gchar* _tmp17_;
#line 171 "expr.vala"
							_tmp15_ = builder;
#line 171 "expr.vala"
							_tmp16_ = arg;
#line 171 "expr.vala"
							_tmp17_ = (*_tmp16_).data;
#line 171 "expr.vala"
							g_string_append (_tmp15_, _tmp17_);
#line 1164 "expr.c"
						}
#line 168 "expr.vala"
						_skk_expr_node_free0 (arg);
#line 1168 "expr.c"
					}
#line 174 "expr.vala"
					_tmp18_ = builder;
#line 174 "expr.vala"
					_tmp19_ = _tmp18_->str;
#line 174 "expr.vala"
					_tmp20_ = g_strdup (_tmp19_);
#line 174 "expr.vala"
					result = _tmp20_;
#line 174 "expr.vala"
					_g_string_free0 (builder);
#line 174 "expr.vala"
					_skk_expr_node_free0 (funcall);
#line 174 "expr.vala"
					_g_object_unref0 (iter);
#line 174 "expr.vala"
					return result;
#line 1186 "expr.c"
				} else {
					SkkExprNode* _tmp21_;
					const gchar* _tmp22_;
#line 176 "expr.vala"
					_tmp21_ = funcall;
#line 176 "expr.vala"
					_tmp22_ = (*_tmp21_).data;
#line 176 "expr.vala"
					if (g_strcmp0 (_tmp22_, "current-time-string") == 0) {
#line 1196 "expr.c"
						GDateTime* datetime = NULL;
						GDateTime* _tmp23_;
						GDateTime* _tmp24_;
						gchar* _tmp25_;
#line 177 "expr.vala"
						_tmp23_ = g_date_time_new_now_local ();
#line 177 "expr.vala"
						datetime = _tmp23_;
#line 178 "expr.vala"
						_tmp24_ = datetime;
#line 178 "expr.vala"
						_tmp25_ = g_date_time_format (_tmp24_, "%a, %d %b %Y %T %z");
#line 178 "expr.vala"
						result = _tmp25_;
#line 178 "expr.vala"
						_g_date_time_unref0 (datetime);
#line 178 "expr.vala"
						_skk_expr_node_free0 (funcall);
#line 178 "expr.vala"
						_g_object_unref0 (iter);
#line 178 "expr.vala"
						return result;
#line 1219 "expr.c"
					} else {
						SkkExprNode* _tmp26_;
						const gchar* _tmp27_;
#line 180 "expr.vala"
						_tmp26_ = funcall;
#line 180 "expr.vala"
						_tmp27_ = (*_tmp26_).data;
#line 180 "expr.vala"
						if (g_strcmp0 (_tmp27_, "pwd") == 0) {
#line 1229 "expr.c"
							gchar* _tmp28_;
#line 181 "expr.vala"
							_tmp28_ = g_get_current_dir ();
#line 181 "expr.vala"
							result = _tmp28_;
#line 181 "expr.vala"
							_skk_expr_node_free0 (funcall);
#line 181 "expr.vala"
							_g_object_unref0 (iter);
#line 181 "expr.vala"
							return result;
#line 1241 "expr.c"
						} else {
							SkkExprNode* _tmp29_;
							const gchar* _tmp30_;
#line 183 "expr.vala"
							_tmp29_ = funcall;
#line 183 "expr.vala"
							_tmp30_ = (*_tmp29_).data;
#line 183 "expr.vala"
							if (g_strcmp0 (_tmp30_, "skk-version") == 0) {
#line 1251 "expr.c"
								gchar* _tmp31_;
#line 184 "expr.vala"
								_tmp31_ = g_strdup_printf ("%s/%s", PACKAGE_NAME, PACKAGE_VERSION);
#line 184 "expr.vala"
								result = _tmp31_;
#line 184 "expr.vala"
								_skk_expr_node_free0 (funcall);
#line 184 "expr.vala"
								_g_object_unref0 (iter);
#line 184 "expr.vala"
								return result;
#line 1263 "expr.c"
							}
						}
					}
				}
			}
#line 162 "expr.vala"
			_skk_expr_node_free0 (funcall);
#line 1271 "expr.c"
		}
#line 160 "expr.vala"
		_g_object_unref0 (iter);
#line 1275 "expr.c"
	}
#line 190 "expr.vala"
	result = NULL;
#line 190 "expr.vala"
	return result;
#line 1281 "expr.c"
}

SkkExprEvaluator*
skk_expr_evaluator_construct (GType object_type)
{
	SkkExprEvaluator * self = NULL;
#line 158 "expr.vala"
	self = (SkkExprEvaluator*) g_object_new (object_type, NULL);
#line 158 "expr.vala"
	return self;
#line 1292 "expr.c"
}

SkkExprEvaluator*
skk_expr_evaluator_new (void)
{
#line 158 "expr.vala"
	return skk_expr_evaluator_construct (SKK_TYPE_EXPR_EVALUATOR);
#line 1300 "expr.c"
}

static void
skk_expr_evaluator_class_init (SkkExprEvaluatorClass * klass,
                               gpointer klass_data)
{
#line 158 "expr.vala"
	skk_expr_evaluator_parent_class = g_type_class_peek_parent (klass);
#line 1309 "expr.c"
}

static void
skk_expr_evaluator_instance_init (SkkExprEvaluator * self,
                                  gpointer klass)
{
}

static GType
skk_expr_evaluator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SkkExprEvaluatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) skk_expr_evaluator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SkkExprEvaluator), 0, (GInstanceInitFunc) skk_expr_evaluator_instance_init, NULL };
	GType skk_expr_evaluator_type_id;
	skk_expr_evaluator_type_id = g_type_register_static (G_TYPE_OBJECT, "SkkExprEvaluator", &g_define_type_info, 0);
	return skk_expr_evaluator_type_id;
}

GType
skk_expr_evaluator_get_type (void)
{
	static volatile gsize skk_expr_evaluator_type_id__once = 0;
	if (g_once_init_enter (&skk_expr_evaluator_type_id__once)) {
		GType skk_expr_evaluator_type_id;
		skk_expr_evaluator_type_id = skk_expr_evaluator_get_type_once ();
		g_once_init_leave (&skk_expr_evaluator_type_id__once, skk_expr_evaluator_type_id);
	}
	return skk_expr_evaluator_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 145 "rule.vala"
	if (mem && byte_size != 0) {
#line 145 "rule.vala"
		new_mem = g_malloc (byte_size);
#line 145 "rule.vala"
		memcpy (new_mem, mem, byte_size);
#line 1350 "expr.c"
	} else {
#line 145 "rule.vala"
		new_mem = NULL;
#line 1354 "expr.c"
	}
#line 145 "rule.vala"
	return new_mem;
#line 1358 "expr.c"
}

