/* file-dict.c generated by valac 0.56.17, the Vala compiler
 * generated from file-dict.vala, do not modify */

/*
 * Copyright (C) 2011-2018 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "libskk/libskk.h"
#include <gio/gio.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define SKK_TYPE_MEMORY_MAPPED_FILE (skk_memory_mapped_file_get_type ())
#define SKK_MEMORY_MAPPED_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SKK_TYPE_MEMORY_MAPPED_FILE, SkkMemoryMappedFile))
#define SKK_MEMORY_MAPPED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SKK_TYPE_MEMORY_MAPPED_FILE, SkkMemoryMappedFileClass))
#define SKK_IS_MEMORY_MAPPED_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SKK_TYPE_MEMORY_MAPPED_FILE))
#define SKK_IS_MEMORY_MAPPED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SKK_TYPE_MEMORY_MAPPED_FILE))
#define SKK_MEMORY_MAPPED_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SKK_TYPE_MEMORY_MAPPED_FILE, SkkMemoryMappedFileClass))

typedef struct _SkkMemoryMappedFile SkkMemoryMappedFile;
typedef struct _SkkMemoryMappedFileClass SkkMemoryMappedFileClass;

#define SKK_TYPE_ENCODING_CONVERTER (skk_encoding_converter_get_type ())
#define SKK_ENCODING_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverter))
#define SKK_ENCODING_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverterClass))
#define SKK_IS_ENCODING_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SKK_TYPE_ENCODING_CONVERTER))
#define SKK_IS_ENCODING_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SKK_TYPE_ENCODING_CONVERTER))
#define SKK_ENCODING_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverterClass))

typedef struct _SkkEncodingConverter SkkEncodingConverter;
typedef struct _SkkEncodingConverterClass SkkEncodingConverterClass;
enum  {
	SKK_FILE_DICT_0_PROPERTY,
	SKK_FILE_DICT_READ_ONLY_PROPERTY,
	SKK_FILE_DICT_NUM_PROPERTIES
};
static GParamSpec* skk_file_dict_properties[SKK_FILE_DICT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define SKK_TYPE_SKK_DICT_ERROR (skk_skk_dict_error_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SkkFileDictPrivate {
	GFile* file;
	SkkMemoryMappedFile* mmap;
	gchar* etag;
	SkkEncodingConverter* converter;
	glong okuri_ari_offset;
	glong okuri_nasi_offset;
};

typedef enum  {
	SKK_SKK_DICT_ERROR_NOT_READABLE,
	SKK_SKK_DICT_ERROR_MALFORMED_INPUT
} SkkSkkDictError;
#define SKK_SKK_DICT_ERROR skk_skk_dict_error_quark ()

static gint SkkFileDict_private_offset;
static gpointer skk_file_dict_parent_class = NULL;

VALA_EXTERN GType skk_memory_mapped_file_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType skk_encoding_converter_get_type (void) G_GNUC_CONST ;
static gchar* skk_file_dict_read_line (SkkFileDict* self,
                                glong* offset);
VALA_EXTERN gsize skk_memory_mapped_file_get_length (SkkMemoryMappedFile* self);
VALA_EXTERN void* skk_memory_mapped_file_get_memory (SkkMemoryMappedFile* self);
static gchar* skk_file_dict_read_previous_line (SkkFileDict* self,
                                         glong* pos,
                                         const gchar* line);
static gchar* skk_file_dict_read_next_line (SkkFileDict* self,
                                     glong* pos,
                                     const gchar* line);
static gboolean skk_file_dict_read_until (SkkFileDict* self,
                                   glong* offset,
                                   const gchar* line);
VALA_EXTERN GQuark skk_skk_dict_error_quark (void);
VALA_EXTERN GType skk_skk_dict_error_get_type (void) G_GNUC_CONST ;
static void skk_file_dict_load (SkkFileDict* self,
                         GError** error);
VALA_EXTERN void skk_memory_mapped_file_remap (SkkMemoryMappedFile* self,
                                   GError** error);
VALA_EXTERN gchar* skk_encoding_converter_extract_coding_system (const gchar* line);
VALA_EXTERN SkkEncodingConverter* skk_encoding_converter_new_from_coding_system (const gchar* coding,
                                                                     GError** error);
VALA_EXTERN SkkEncodingConverter* skk_encoding_converter_construct_from_coding_system (GType object_type,
                                                                           const gchar* coding,
                                                                           GError** error);
static void skk_file_dict_real_reload (SkkDict* base,
                                GError** error);
static gboolean skk_file_dict_search_pos (SkkFileDict* self,
                                   const gchar* midasi,
                                   glong start_offset,
                                   glong end_offset,
                                   GCompareFunc cmp,
                                   glong* pos,
                                   gchar** line,
                                   gint direction);
static SkkCandidate** skk_file_dict_real_lookup (SkkDict* base,
                                          const gchar* midasi,
                                          gboolean okuri,
                                          gint* result_length1);
VALA_EXTERN gchar* skk_encoding_converter_encode (SkkEncodingConverter* self,
                                      const gchar* internal_str,
                                      GError** error);
VALA_EXTERN gchar* skk_encoding_converter_decode (SkkEncodingConverter* self,
                                      const gchar* external_str,
                                      GError** error);
static gint skk_file_dict_strcmp_prefix (const gchar* a,
                                  const gchar* b);
static gchar** skk_file_dict_real_complete (SkkDict* base,
                                     const gchar* midasi,
                                     gint* result_length1);
static gint _skk_file_dict_strcmp_prefix_gcompare_func (gconstpointer a,
                                                 gconstpointer b);
VALA_EXTERN SkkMemoryMappedFile* skk_memory_mapped_file_new (GFile* file);
VALA_EXTERN SkkMemoryMappedFile* skk_memory_mapped_file_construct (GType object_type,
                                                       GFile* file);
VALA_EXTERN SkkEncodingConverter* skk_encoding_converter_new (const gchar* encoding,
                                                  GError** error);
VALA_EXTERN SkkEncodingConverter* skk_encoding_converter_construct (GType object_type,
                                                        const gchar* encoding,
                                                        GError** error);
static void skk_file_dict_finalize (GObject * obj);
static GType skk_file_dict_get_type_once (void);
static void _vala_skk_file_dict_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
skk_file_dict_get_instance_private (SkkFileDict* self)
{
	return G_STRUCT_MEMBER_P (self, SkkFileDict_private_offset);
}

static gchar*
skk_file_dict_read_line (SkkFileDict* self,
                         glong* offset)
{
	SkkMemoryMappedFile* _tmp0_;
	gsize _tmp1_;
	gsize _tmp2_;
	gchar* p = NULL;
	SkkMemoryMappedFile* _tmp3_;
	void* _tmp4_;
	void* _tmp5_;
	GString* builder = NULL;
	GString* _tmp12_;
	glong _offset = 0L;
	GString* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* result;
#line 27 "file-dict.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "file-dict.vala"
	_tmp0_ = self->priv->mmap;
#line 28 "file-dict.vala"
	_tmp1_ = skk_memory_mapped_file_get_length (_tmp0_);
#line 28 "file-dict.vala"
	_tmp2_ = _tmp1_;
#line 28 "file-dict.vala"
	g_return_val_if_fail (((gsize) (*offset)) < _tmp2_, NULL);
#line 29 "file-dict.vala"
	_tmp3_ = self->priv->mmap;
#line 29 "file-dict.vala"
	_tmp4_ = skk_memory_mapped_file_get_memory (_tmp3_);
#line 29 "file-dict.vala"
	_tmp5_ = _tmp4_;
#line 29 "file-dict.vala"
	p = ((gchar*) _tmp5_) + (*offset);
#line 207 "file-dict.c"
	{
		gboolean _tmp6_ = FALSE;
#line 30 "file-dict.vala"
		_tmp6_ = TRUE;
#line 30 "file-dict.vala"
		while (TRUE) {
#line 214 "file-dict.c"
			gchar* _tmp9_;
#line 30 "file-dict.vala"
			if (!_tmp6_) {
#line 218 "file-dict.c"
				glong _tmp7_;
				gchar* _tmp8_;
#line 30 "file-dict.vala"
				_tmp7_ = *offset;
#line 30 "file-dict.vala"
				*offset = _tmp7_ - 1;
#line 30 "file-dict.vala"
				_tmp8_ = p;
#line 30 "file-dict.vala"
				p = _tmp8_ - 1;
#line 229 "file-dict.c"
			}
#line 30 "file-dict.vala"
			_tmp6_ = FALSE;
#line 30 "file-dict.vala"
			if (!((*offset) > ((glong) 0))) {
#line 30 "file-dict.vala"
				break;
#line 237 "file-dict.c"
			}
#line 31 "file-dict.vala"
			_tmp9_ = p;
#line 31 "file-dict.vala"
			if ((*_tmp9_) == '\n') {
#line 32 "file-dict.vala"
				break;
#line 245 "file-dict.c"
			}
		}
	}
#line 35 "file-dict.vala"
	if ((*offset) > ((glong) 0)) {
#line 251 "file-dict.c"
		glong _tmp10_;
		gchar* _tmp11_;
#line 36 "file-dict.vala"
		_tmp10_ = *offset;
#line 36 "file-dict.vala"
		*offset = _tmp10_ + 1;
#line 37 "file-dict.vala"
		_tmp11_ = p;
#line 37 "file-dict.vala"
		p = _tmp11_ + 1;
#line 262 "file-dict.c"
	}
#line 40 "file-dict.vala"
	_tmp12_ = g_string_new ("");
#line 40 "file-dict.vala"
	builder = _tmp12_;
#line 41 "file-dict.vala"
	_offset = *offset;
#line 270 "file-dict.c"
	{
		gboolean _tmp13_ = FALSE;
#line 42 "file-dict.vala"
		_tmp13_ = TRUE;
#line 42 "file-dict.vala"
		while (TRUE) {
#line 277 "file-dict.c"
			SkkMemoryMappedFile* _tmp16_;
			gsize _tmp17_;
			gsize _tmp18_;
			gchar* _tmp19_;
			GString* _tmp20_;
			gchar* _tmp21_;
#line 42 "file-dict.vala"
			if (!_tmp13_) {
#line 286 "file-dict.c"
				glong _tmp14_;
				gchar* _tmp15_;
#line 42 "file-dict.vala"
				_tmp14_ = _offset;
#line 42 "file-dict.vala"
				_offset = _tmp14_ + 1;
#line 42 "file-dict.vala"
				_tmp15_ = p;
#line 42 "file-dict.vala"
				p = _tmp15_ + 1;
#line 297 "file-dict.c"
			}
#line 42 "file-dict.vala"
			_tmp13_ = FALSE;
#line 42 "file-dict.vala"
			_tmp16_ = self->priv->mmap;
#line 42 "file-dict.vala"
			_tmp17_ = skk_memory_mapped_file_get_length (_tmp16_);
#line 42 "file-dict.vala"
			_tmp18_ = _tmp17_;
#line 42 "file-dict.vala"
			if (!(((gsize) _offset) < _tmp18_)) {
#line 42 "file-dict.vala"
				break;
#line 311 "file-dict.c"
			}
#line 43 "file-dict.vala"
			_tmp19_ = p;
#line 43 "file-dict.vala"
			if ((*_tmp19_) == '\n') {
#line 44 "file-dict.vala"
				break;
#line 319 "file-dict.c"
			}
#line 45 "file-dict.vala"
			_tmp20_ = builder;
#line 45 "file-dict.vala"
			_tmp21_ = p;
#line 45 "file-dict.vala"
			g_string_append_c (_tmp20_, *_tmp21_);
#line 327 "file-dict.c"
		}
	}
#line 47 "file-dict.vala"
	_tmp22_ = builder;
#line 47 "file-dict.vala"
	_tmp23_ = _tmp22_->str;
#line 47 "file-dict.vala"
	_tmp24_ = g_strdup (_tmp23_);
#line 47 "file-dict.vala"
	result = _tmp24_;
#line 47 "file-dict.vala"
	_g_string_free0 (builder);
#line 47 "file-dict.vala"
	return result;
#line 342 "file-dict.c"
}

static gchar*
skk_file_dict_read_previous_line (SkkFileDict* self,
                                  glong* pos,
                                  const gchar* line)
{
	gchar* _tmp0_;
	gchar* result;
#line 51 "file-dict.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "file-dict.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 52 "file-dict.vala"
	if ((*pos) < ((glong) 2)) {
#line 53 "file-dict.vala"
		result = NULL;
#line 53 "file-dict.vala"
		return result;
#line 362 "file-dict.c"
	}
#line 56 "file-dict.vala"
	*pos = (*pos) - 2;
#line 57 "file-dict.vala"
	_tmp0_ = skk_file_dict_read_line (self, pos);
#line 57 "file-dict.vala"
	result = _tmp0_;
#line 57 "file-dict.vala"
	return result;
#line 372 "file-dict.c"
}

static gchar*
skk_file_dict_read_next_line (SkkFileDict* self,
                              glong* pos,
                              const gchar* line)
{
	gint _tmp0_;
	gint _tmp1_;
	SkkMemoryMappedFile* _tmp2_;
	gsize _tmp3_;
	gsize _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 61 "file-dict.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "file-dict.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 62 "file-dict.vala"
	_tmp0_ = strlen (line);
#line 62 "file-dict.vala"
	_tmp1_ = _tmp0_;
#line 62 "file-dict.vala"
	_tmp2_ = self->priv->mmap;
#line 62 "file-dict.vala"
	_tmp3_ = skk_memory_mapped_file_get_length (_tmp2_);
#line 62 "file-dict.vala"
	_tmp4_ = _tmp3_;
#line 62 "file-dict.vala"
	if (((gsize) (((*pos) + _tmp1_) + 1)) >= _tmp4_) {
#line 63 "file-dict.vala"
		result = NULL;
#line 63 "file-dict.vala"
		return result;
#line 409 "file-dict.c"
	}
#line 66 "file-dict.vala"
	_tmp5_ = strlen (line);
#line 66 "file-dict.vala"
	_tmp6_ = _tmp5_;
#line 66 "file-dict.vala"
	*pos = (*pos) + (_tmp6_ + 1);
#line 67 "file-dict.vala"
	_tmp7_ = skk_file_dict_read_line (self, pos);
#line 67 "file-dict.vala"
	result = _tmp7_;
#line 67 "file-dict.vala"
	return result;
#line 423 "file-dict.c"
}

static gboolean
skk_file_dict_read_until (SkkFileDict* self,
                          glong* offset,
                          const gchar* line)
{
	SkkMemoryMappedFile* _tmp0_;
	gsize _tmp1_;
	gsize _tmp2_;
	gboolean result;
#line 72 "file-dict.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 72 "file-dict.vala"
	g_return_val_if_fail (line != NULL, FALSE);
#line 73 "file-dict.vala"
	_tmp0_ = self->priv->mmap;
#line 73 "file-dict.vala"
	_tmp1_ = skk_memory_mapped_file_get_length (_tmp0_);
#line 73 "file-dict.vala"
	_tmp2_ = _tmp1_;
#line 73 "file-dict.vala"
	g_return_val_if_fail (((gsize) (*offset)) < _tmp2_, FALSE);
#line 74 "file-dict.vala"
	while (TRUE) {
#line 449 "file-dict.c"
		gint _tmp3_;
		gint _tmp4_;
		SkkMemoryMappedFile* _tmp5_;
		gsize _tmp6_;
		gsize _tmp7_;
		gchar* p = NULL;
		SkkMemoryMappedFile* _tmp8_;
		void* _tmp9_;
		void* _tmp10_;
		gboolean _tmp11_ = FALSE;
		gchar* _tmp12_;
		glong _tmp18_;
#line 74 "file-dict.vala"
		_tmp3_ = strlen (line);
#line 74 "file-dict.vala"
		_tmp4_ = _tmp3_;
#line 74 "file-dict.vala"
		_tmp5_ = self->priv->mmap;
#line 74 "file-dict.vala"
		_tmp6_ = skk_memory_mapped_file_get_length (_tmp5_);
#line 74 "file-dict.vala"
		_tmp7_ = _tmp6_;
#line 74 "file-dict.vala"
		if (!(((gsize) ((*offset) + _tmp4_)) < _tmp7_)) {
#line 74 "file-dict.vala"
			break;
#line 476 "file-dict.c"
		}
#line 75 "file-dict.vala"
		_tmp8_ = self->priv->mmap;
#line 75 "file-dict.vala"
		_tmp9_ = skk_memory_mapped_file_get_memory (_tmp8_);
#line 75 "file-dict.vala"
		_tmp10_ = _tmp9_;
#line 75 "file-dict.vala"
		p = ((gchar*) _tmp10_) + (*offset);
#line 76 "file-dict.vala"
		_tmp12_ = p;
#line 76 "file-dict.vala"
		if ((*_tmp12_) == '\n') {
#line 490 "file-dict.c"
			gchar* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
#line 77 "file-dict.vala"
			_tmp13_ = p;
#line 77 "file-dict.vala"
			_tmp14_ = strlen (line);
#line 77 "file-dict.vala"
			_tmp15_ = _tmp14_;
#line 77 "file-dict.vala"
			_tmp11_ = memcmp (_tmp13_ + 1, (void*) line, (gsize) _tmp15_) == 0;
#line 502 "file-dict.c"
		} else {
#line 76 "file-dict.vala"
			_tmp11_ = FALSE;
#line 506 "file-dict.c"
		}
#line 76 "file-dict.vala"
		if (_tmp11_) {
#line 510 "file-dict.c"
			gint _tmp16_;
			gint _tmp17_;
#line 78 "file-dict.vala"
			_tmp16_ = strlen (line);
#line 78 "file-dict.vala"
			_tmp17_ = _tmp16_;
#line 78 "file-dict.vala"
			*offset = (*offset) + _tmp17_;
#line 79 "file-dict.vala"
			result = TRUE;
#line 79 "file-dict.vala"
			return result;
#line 523 "file-dict.c"
		}
#line 81 "file-dict.vala"
		_tmp18_ = *offset;
#line 81 "file-dict.vala"
		*offset = _tmp18_ + 1;
#line 529 "file-dict.c"
	}
#line 83 "file-dict.vala"
	result = FALSE;
#line 83 "file-dict.vala"
	return result;
#line 535 "file-dict.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 102 "file-dict.vala"
	return self ? g_object_ref (self) : NULL;
#line 543 "file-dict.c"
}

static void
skk_file_dict_load (SkkFileDict* self,
                    GError** error)
{
	SkkMemoryMappedFile* _tmp0_;
	glong offset = 0L;
	gchar* line = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* coding = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gboolean _tmp15_;
	gboolean _tmp17_;
	GError* _inner_error0_ = NULL;
#line 86 "file-dict.vala"
	g_return_if_fail (self != NULL);
#line 87 "file-dict.vala"
	_tmp0_ = self->priv->mmap;
#line 87 "file-dict.vala"
	skk_memory_mapped_file_remap (_tmp0_, &_inner_error0_);
#line 87 "file-dict.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 87 "file-dict.vala"
		if (_inner_error0_->domain == SKK_SKK_DICT_ERROR) {
#line 87 "file-dict.vala"
			g_propagate_error (error, _inner_error0_);
#line 87 "file-dict.vala"
			return;
#line 576 "file-dict.c"
		} else {
#line 87 "file-dict.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 87 "file-dict.vala"
			g_clear_error (&_inner_error0_);
#line 87 "file-dict.vala"
			return;
#line 584 "file-dict.c"
		}
	}
#line 89 "file-dict.vala"
	offset = (glong) 0;
#line 90 "file-dict.vala"
	_tmp1_ = skk_file_dict_read_line (self, &offset);
#line 90 "file-dict.vala"
	line = _tmp1_;
#line 91 "file-dict.vala"
	_tmp2_ = line;
#line 91 "file-dict.vala"
	if (_tmp2_ == NULL) {
#line 597 "file-dict.c"
		GError* _tmp3_;
#line 92 "file-dict.vala"
		_tmp3_ = g_error_new_literal (SKK_SKK_DICT_ERROR, SKK_SKK_DICT_ERROR_MALFORMED_INPUT, "can't read the first line");
#line 92 "file-dict.vala"
		_inner_error0_ = _tmp3_;
#line 92 "file-dict.vala"
		if (_inner_error0_->domain == SKK_SKK_DICT_ERROR) {
#line 92 "file-dict.vala"
			g_propagate_error (error, _inner_error0_);
#line 92 "file-dict.vala"
			_g_free0 (line);
#line 92 "file-dict.vala"
			return;
#line 611 "file-dict.c"
		} else {
#line 92 "file-dict.vala"
			_g_free0 (line);
#line 92 "file-dict.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 92 "file-dict.vala"
			g_clear_error (&_inner_error0_);
#line 92 "file-dict.vala"
			return;
#line 621 "file-dict.c"
		}
	}
#line 96 "file-dict.vala"
	_tmp4_ = line;
#line 96 "file-dict.vala"
	_tmp5_ = skk_encoding_converter_extract_coding_system (_tmp4_);
#line 96 "file-dict.vala"
	coding = _tmp5_;
#line 97 "file-dict.vala"
	_tmp6_ = coding;
#line 97 "file-dict.vala"
	if (_tmp6_ != NULL) {
#line 634 "file-dict.c"
		{
			SkkEncodingConverter* _converter = NULL;
			const gchar* _tmp7_;
			SkkEncodingConverter* _tmp8_;
			SkkEncodingConverter* _tmp9_;
#line 99 "file-dict.vala"
			_tmp7_ = coding;
#line 99 "file-dict.vala"
			_tmp8_ = skk_encoding_converter_new_from_coding_system (_tmp7_, &_inner_error0_);
#line 99 "file-dict.vala"
			_converter = _tmp8_;
#line 99 "file-dict.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 648 "file-dict.c"
				goto __catch0_g_error;
			}
#line 101 "file-dict.vala"
			_tmp9_ = _converter;
#line 101 "file-dict.vala"
			if (_tmp9_ != NULL) {
#line 655 "file-dict.c"
				SkkEncodingConverter* _tmp10_;
				SkkEncodingConverter* _tmp11_;
#line 102 "file-dict.vala"
				_tmp10_ = _converter;
#line 102 "file-dict.vala"
				_tmp11_ = _g_object_ref0 (_tmp10_);
#line 102 "file-dict.vala"
				_g_object_unref0 (self->priv->converter);
#line 102 "file-dict.vala"
				self->priv->converter = _tmp11_;
#line 666 "file-dict.c"
			}
#line 98 "file-dict.vala"
			_g_object_unref0 (_converter);
#line 670 "file-dict.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp12_;
			GError* _tmp13_;
			const gchar* _tmp14_;
#line 98 "file-dict.vala"
			e = _inner_error0_;
#line 98 "file-dict.vala"
			_inner_error0_ = NULL;
#line 105 "file-dict.vala"
			_tmp12_ = coding;
#line 105 "file-dict.vala"
			_tmp13_ = e;
#line 105 "file-dict.vala"
			_tmp14_ = _tmp13_->message;
#line 105 "file-dict.vala"
			g_warning ("file-dict.vala:105: can't create converter from coding system %s: %s", _tmp12_, _tmp14_);
#line 98 "file-dict.vala"
			_g_error_free0 (e);
#line 693 "file-dict.c"
		}
		__finally0:
#line 98 "file-dict.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "file-dict.vala"
			if (_inner_error0_->domain == SKK_SKK_DICT_ERROR) {
#line 98 "file-dict.vala"
				g_propagate_error (error, _inner_error0_);
#line 98 "file-dict.vala"
				_g_free0 (coding);
#line 98 "file-dict.vala"
				_g_free0 (line);
#line 98 "file-dict.vala"
				return;
#line 708 "file-dict.c"
			} else {
#line 98 "file-dict.vala"
				_g_free0 (coding);
#line 98 "file-dict.vala"
				_g_free0 (line);
#line 98 "file-dict.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "file-dict.vala"
				g_clear_error (&_inner_error0_);
#line 98 "file-dict.vala"
				return;
#line 720 "file-dict.c"
			}
		}
	}
#line 110 "file-dict.vala"
	offset = (glong) 0;
#line 111 "file-dict.vala"
	_tmp15_ = skk_file_dict_read_until (self, &offset, ";; okuri-ari entries.\n");
#line 111 "file-dict.vala"
	if (!_tmp15_) {
#line 730 "file-dict.c"
		GError* _tmp16_;
#line 112 "file-dict.vala"
		_tmp16_ = g_error_new_literal (SKK_SKK_DICT_ERROR, SKK_SKK_DICT_ERROR_MALFORMED_INPUT, "no okuri-ari boundary");
#line 112 "file-dict.vala"
		_inner_error0_ = _tmp16_;
#line 112 "file-dict.vala"
		if (_inner_error0_->domain == SKK_SKK_DICT_ERROR) {
#line 112 "file-dict.vala"
			g_propagate_error (error, _inner_error0_);
#line 112 "file-dict.vala"
			_g_free0 (coding);
#line 112 "file-dict.vala"
			_g_free0 (line);
#line 112 "file-dict.vala"
			return;
#line 746 "file-dict.c"
		} else {
#line 112 "file-dict.vala"
			_g_free0 (coding);
#line 112 "file-dict.vala"
			_g_free0 (line);
#line 112 "file-dict.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 112 "file-dict.vala"
			g_clear_error (&_inner_error0_);
#line 112 "file-dict.vala"
			return;
#line 758 "file-dict.c"
		}
	}
#line 115 "file-dict.vala"
	self->priv->okuri_ari_offset = offset;
#line 117 "file-dict.vala"
	_tmp17_ = skk_file_dict_read_until (self, &offset, ";; okuri-nasi entries.\n");
#line 117 "file-dict.vala"
	if (!_tmp17_) {
#line 767 "file-dict.c"
		GError* _tmp18_;
#line 118 "file-dict.vala"
		_tmp18_ = g_error_new_literal (SKK_SKK_DICT_ERROR, SKK_SKK_DICT_ERROR_MALFORMED_INPUT, "no okuri-nasi boundary");
#line 118 "file-dict.vala"
		_inner_error0_ = _tmp18_;
#line 118 "file-dict.vala"
		if (_inner_error0_->domain == SKK_SKK_DICT_ERROR) {
#line 118 "file-dict.vala"
			g_propagate_error (error, _inner_error0_);
#line 118 "file-dict.vala"
			_g_free0 (coding);
#line 118 "file-dict.vala"
			_g_free0 (line);
#line 118 "file-dict.vala"
			return;
#line 783 "file-dict.c"
		} else {
#line 118 "file-dict.vala"
			_g_free0 (coding);
#line 118 "file-dict.vala"
			_g_free0 (line);
#line 118 "file-dict.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 118 "file-dict.vala"
			g_clear_error (&_inner_error0_);
#line 118 "file-dict.vala"
			return;
#line 795 "file-dict.c"
		}
	}
#line 121 "file-dict.vala"
	self->priv->okuri_nasi_offset = offset;
#line 86 "file-dict.vala"
	_g_free0 (coding);
#line 86 "file-dict.vala"
	_g_free0 (line);
#line 804 "file-dict.c"
}

/**
         * {@inheritDoc}
         */
static void
skk_file_dict_real_reload (SkkDict* base,
                           GError** error)
{
	SkkFileDict * self;
	gchar* attributes = NULL;
	gchar* _tmp0_;
	GFileInfo* info = NULL;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 127 "file-dict.vala"
	self = (SkkFileDict*) base;
#line 129 "file-dict.vala"
	_tmp0_ = g_strdup (G_FILE_ATTRIBUTE_ETAG_VALUE);
#line 129 "file-dict.vala"
	attributes = _tmp0_;
#line 133 "file-dict.vala"
	_tmp1_ = self->priv->file;
#line 133 "file-dict.vala"
	_tmp2_ = g_file_query_info (_tmp1_, attributes, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 133 "file-dict.vala"
	info = _tmp2_;
#line 133 "file-dict.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 133 "file-dict.vala"
		g_propagate_error (error, _inner_error0_);
#line 133 "file-dict.vala"
		_g_free0 (attributes);
#line 133 "file-dict.vala"
		return;
#line 843 "file-dict.c"
	}
#line 135 "file-dict.vala"
	_tmp3_ = g_file_info_get_etag (info);
#line 135 "file-dict.vala"
	_tmp4_ = self->priv->etag;
#line 135 "file-dict.vala"
	if (g_strcmp0 (_tmp3_, _tmp4_) != 0) {
#line 851 "file-dict.c"
		{
			const gchar* _tmp5_;
			gchar* _tmp6_;
#line 137 "file-dict.vala"
			skk_file_dict_load (self, &_inner_error0_);
#line 137 "file-dict.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 137 "file-dict.vala"
				if (_inner_error0_->domain == SKK_SKK_DICT_ERROR) {
#line 861 "file-dict.c"
					goto __catch0_skk_skk_dict_error;
				}
#line 137 "file-dict.vala"
				_g_object_unref0 (info);
#line 137 "file-dict.vala"
				_g_free0 (attributes);
#line 137 "file-dict.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 137 "file-dict.vala"
				g_clear_error (&_inner_error0_);
#line 137 "file-dict.vala"
				return;
#line 874 "file-dict.c"
			}
#line 138 "file-dict.vala"
			_tmp5_ = g_file_info_get_etag (info);
#line 138 "file-dict.vala"
			_tmp6_ = g_strdup (_tmp5_);
#line 138 "file-dict.vala"
			_g_free0 (self->priv->etag);
#line 138 "file-dict.vala"
			self->priv->etag = _tmp6_;
#line 884 "file-dict.c"
		}
		goto __finally0;
		__catch0_skk_skk_dict_error:
		{
			GError* e = NULL;
			GFile* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			GError* _tmp10_;
			const gchar* _tmp11_;
#line 136 "file-dict.vala"
			e = _inner_error0_;
#line 136 "file-dict.vala"
			_inner_error0_ = NULL;
#line 140 "file-dict.vala"
			_tmp7_ = self->priv->file;
#line 140 "file-dict.vala"
			_tmp8_ = g_file_get_path (_tmp7_);
#line 140 "file-dict.vala"
			_tmp9_ = _tmp8_;
#line 140 "file-dict.vala"
			_tmp10_ = e;
#line 140 "file-dict.vala"
			_tmp11_ = _tmp10_->message;
#line 140 "file-dict.vala"
			g_warning ("file-dict.vala:140: error loading file dictionary %s %s", _tmp9_, _tmp11_);
#line 140 "file-dict.vala"
			_g_free0 (_tmp9_);
#line 136 "file-dict.vala"
			_g_error_free0 (e);
#line 915 "file-dict.c"
		}
		__finally0:
#line 136 "file-dict.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 136 "file-dict.vala"
			g_propagate_error (error, _inner_error0_);
#line 136 "file-dict.vala"
			_g_object_unref0 (info);
#line 136 "file-dict.vala"
			_g_free0 (attributes);
#line 136 "file-dict.vala"
			return;
#line 928 "file-dict.c"
		}
	}
#line 127 "file-dict.vala"
	_g_object_unref0 (info);
#line 127 "file-dict.vala"
	_g_free0 (attributes);
#line 935 "file-dict.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1185 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1185 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1187 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1187 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 959 "file-dict.c"
		gchar* _tmp2_;
#line 1188 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1188 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1188 "glib-2.0.vapi"
		return result;
#line 967 "file-dict.c"
	} else {
#line 1190 "glib-2.0.vapi"
		result = -1;
#line 1190 "glib-2.0.vapi"
		return result;
#line 973 "file-dict.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 1001 "file-dict.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 1007 "file-dict.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1013 "file-dict.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1017 "file-dict.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1025 "file-dict.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1029 "file-dict.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 1041 "file-dict.c"
}

static gboolean
skk_file_dict_search_pos (SkkFileDict* self,
                          const gchar* midasi,
                          glong start_offset,
                          glong end_offset,
                          GCompareFunc cmp,
                          glong* pos,
                          gchar** line,
                          gint direction)
{
	glong _vala_pos = 0L;
	gchar* _vala_line = NULL;
	glong offset = 0L;
	gboolean result;
#line 146 "file-dict.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 146 "file-dict.vala"
	g_return_val_if_fail (midasi != NULL, FALSE);
#line 153 "file-dict.vala"
	offset = start_offset + ((end_offset - start_offset) / 2);
#line 154 "file-dict.vala"
	while (TRUE) {
#line 1066 "file-dict.c"
		SkkMemoryMappedFile* _tmp0_;
		gsize _tmp1_;
		gsize _tmp2_;
		gchar* _line = NULL;
		gchar* _tmp3_;
		gint index = 0;
		const gchar* _tmp4_;
		gint r = 0;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gint _tmp9_;
#line 154 "file-dict.vala"
		if (!(start_offset <= end_offset)) {
#line 154 "file-dict.vala"
			break;
#line 1083 "file-dict.c"
		}
#line 155 "file-dict.vala"
		_tmp0_ = self->priv->mmap;
#line 155 "file-dict.vala"
		_tmp1_ = skk_memory_mapped_file_get_length (_tmp0_);
#line 155 "file-dict.vala"
		_tmp2_ = _tmp1_;
#line 155 "file-dict.vala"
		_vala_assert (((gsize) offset) < _tmp2_, "offset < mmap.length");
#line 157 "file-dict.vala"
		_tmp3_ = skk_file_dict_read_line (self, &offset);
#line 157 "file-dict.vala"
		_line = _tmp3_;
#line 158 "file-dict.vala"
		_tmp4_ = _line;
#line 158 "file-dict.vala"
		index = string_index_of (_tmp4_, " ", 0);
#line 159 "file-dict.vala"
		if (index < 1) {
#line 1103 "file-dict.c"
			const gchar* _tmp5_;
#line 160 "file-dict.vala"
			_tmp5_ = _line;
#line 160 "file-dict.vala"
			g_warning ("file-dict.vala:160: corrupted dictionary entry: %s", _tmp5_);
#line 161 "file-dict.vala"
			_g_free0 (_line);
#line 161 "file-dict.vala"
			break;
#line 1113 "file-dict.c"
		}
#line 164 "file-dict.vala"
		_tmp6_ = _line;
#line 164 "file-dict.vala"
		_tmp7_ = string_slice (_tmp6_, (glong) 0, (glong) index);
#line 164 "file-dict.vala"
		_tmp8_ = _tmp7_;
#line 164 "file-dict.vala"
		_tmp9_ = cmp (_tmp8_, midasi);
#line 164 "file-dict.vala"
		_g_free0 (_tmp8_);
#line 164 "file-dict.vala"
		r = _tmp9_;
#line 165 "file-dict.vala"
		if (r == 0) {
#line 1129 "file-dict.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 166 "file-dict.vala"
			_vala_pos = offset;
#line 167 "file-dict.vala"
			_tmp10_ = _line;
#line 167 "file-dict.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 167 "file-dict.vala"
			_g_free0 (_vala_line);
#line 167 "file-dict.vala"
			_vala_line = _tmp11_;
#line 168 "file-dict.vala"
			result = TRUE;
#line 168 "file-dict.vala"
			_g_free0 (_line);
#line 168 "file-dict.vala"
			if (pos) {
#line 168 "file-dict.vala"
				*pos = _vala_pos;
#line 1150 "file-dict.c"
			}
#line 168 "file-dict.vala"
			if (line) {
#line 168 "file-dict.vala"
				*line = _vala_line;
#line 1156 "file-dict.c"
			} else {
#line 168 "file-dict.vala"
				_g_free0 (_vala_line);
#line 1160 "file-dict.c"
			}
#line 168 "file-dict.vala"
			return result;
#line 1164 "file-dict.c"
		}
#line 171 "file-dict.vala"
		if ((r * direction) > 0) {
#line 172 "file-dict.vala"
			end_offset = offset - 2;
#line 1170 "file-dict.c"
		} else {
			const gchar* _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
#line 174 "file-dict.vala"
			_tmp12_ = _line;
#line 174 "file-dict.vala"
			_tmp13_ = strlen (_tmp12_);
#line 174 "file-dict.vala"
			_tmp14_ = _tmp13_;
#line 174 "file-dict.vala"
			start_offset = (offset + _tmp14_) + 1;
#line 1183 "file-dict.c"
		}
#line 176 "file-dict.vala"
		offset = start_offset + ((end_offset - start_offset) / 2);
#line 154 "file-dict.vala"
		_g_free0 (_line);
#line 1189 "file-dict.c"
	}
#line 178 "file-dict.vala"
	_vala_pos = (glong) -1;
#line 179 "file-dict.vala"
	_g_free0 (_vala_line);
#line 179 "file-dict.vala"
	_vala_line = NULL;
#line 180 "file-dict.vala"
	result = FALSE;
#line 180 "file-dict.vala"
	if (pos) {
#line 180 "file-dict.vala"
		*pos = _vala_pos;
#line 1203 "file-dict.c"
	}
#line 180 "file-dict.vala"
	if (line) {
#line 180 "file-dict.vala"
		*line = _vala_line;
#line 1209 "file-dict.c"
	} else {
#line 180 "file-dict.vala"
		_g_free0 (_vala_line);
#line 1213 "file-dict.c"
	}
#line 180 "file-dict.vala"
	return result;
#line 1217 "file-dict.c"
}

/**
         * {@inheritDoc}
         */
static SkkCandidate**
skk_file_dict_real_lookup (SkkDict* base,
                           const gchar* midasi,
                           gboolean okuri,
                           gint* result_length1)
{
	SkkFileDict * self;
	SkkMemoryMappedFile* _tmp0_;
	void* _tmp1_;
	void* _tmp2_;
	glong start_offset = 0L;
	glong end_offset = 0L;
	gchar* _midasi = NULL;
	glong pos = 0L;
	gchar* line = NULL;
	gint _tmp16_ = 0;
	const gchar* _tmp17_;
	GCompareFunc _tmp18_;
	glong _tmp19_ = 0L;
	gchar* _tmp20_ = NULL;
	gboolean _tmp21_;
	SkkCandidate** _tmp43_;
	SkkCandidate** _tmp44_;
	gint _tmp44__length1;
	GError* _inner_error0_ = NULL;
	SkkCandidate** result;
#line 186 "file-dict.vala"
	self = (SkkFileDict*) base;
#line 186 "file-dict.vala"
	g_return_val_if_fail (midasi != NULL, NULL);
#line 187 "file-dict.vala"
	_tmp0_ = self->priv->mmap;
#line 187 "file-dict.vala"
	_tmp1_ = skk_memory_mapped_file_get_memory (_tmp0_);
#line 187 "file-dict.vala"
	_tmp2_ = _tmp1_;
#line 187 "file-dict.vala"
	if (_tmp2_ == NULL) {
#line 1261 "file-dict.c"
		SkkCandidate** _tmp3_;
		SkkCandidate** _tmp4_;
		gint _tmp4__length1;
#line 188 "file-dict.vala"
		_tmp3_ = g_new0 (SkkCandidate*, 0 + 1);
#line 188 "file-dict.vala"
		_tmp4_ = _tmp3_;
#line 188 "file-dict.vala"
		_tmp4__length1 = 0;
#line 188 "file-dict.vala"
		if (result_length1) {
#line 188 "file-dict.vala"
			*result_length1 = _tmp4__length1;
#line 1275 "file-dict.c"
		}
#line 188 "file-dict.vala"
		result = _tmp4_;
#line 188 "file-dict.vala"
		return result;
#line 1281 "file-dict.c"
	}
#line 191 "file-dict.vala"
	if (okuri) {
#line 192 "file-dict.vala"
		start_offset = self->priv->okuri_ari_offset;
#line 193 "file-dict.vala"
		end_offset = self->priv->okuri_nasi_offset;
#line 1289 "file-dict.c"
	} else {
		SkkMemoryMappedFile* _tmp5_;
		gsize _tmp6_;
		gsize _tmp7_;
#line 195 "file-dict.vala"
		start_offset = self->priv->okuri_nasi_offset;
#line 196 "file-dict.vala"
		_tmp5_ = self->priv->mmap;
#line 196 "file-dict.vala"
		_tmp6_ = skk_memory_mapped_file_get_length (_tmp5_);
#line 196 "file-dict.vala"
		_tmp7_ = _tmp6_;
#line 196 "file-dict.vala"
		end_offset = ((glong) _tmp7_) - 1;
#line 1304 "file-dict.c"
	}
	{
		gchar* _tmp8_ = NULL;
		SkkEncodingConverter* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 200 "file-dict.vala"
		_tmp9_ = self->priv->converter;
#line 200 "file-dict.vala"
		_tmp10_ = skk_encoding_converter_encode (_tmp9_, midasi, &_inner_error0_);
#line 200 "file-dict.vala"
		_tmp8_ = _tmp10_;
#line 200 "file-dict.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1319 "file-dict.c"
			goto __catch0_g_error;
		}
#line 200 "file-dict.vala"
		_tmp11_ = _tmp8_;
#line 200 "file-dict.vala"
		_tmp8_ = NULL;
#line 200 "file-dict.vala"
		_g_free0 (_midasi);
#line 200 "file-dict.vala"
		_midasi = _tmp11_;
#line 199 "file-dict.vala"
		_g_free0 (_tmp8_);
#line 1332 "file-dict.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
		SkkCandidate** _tmp14_;
		SkkCandidate** _tmp15_;
		gint _tmp15__length1;
#line 199 "file-dict.vala"
		e = _inner_error0_;
#line 199 "file-dict.vala"
		_inner_error0_ = NULL;
#line 202 "file-dict.vala"
		_tmp12_ = e;
#line 202 "file-dict.vala"
		_tmp13_ = _tmp12_->message;
#line 202 "file-dict.vala"
		g_warning ("file-dict.vala:202: can't encode %s: %s", midasi, _tmp13_);
#line 203 "file-dict.vala"
		_tmp14_ = g_new0 (SkkCandidate*, 0 + 1);
#line 203 "file-dict.vala"
		_tmp15_ = _tmp14_;
#line 203 "file-dict.vala"
		_tmp15__length1 = 0;
#line 203 "file-dict.vala"
		if (result_length1) {
#line 203 "file-dict.vala"
			*result_length1 = _tmp15__length1;
#line 1363 "file-dict.c"
		}
#line 203 "file-dict.vala"
		result = _tmp15_;
#line 203 "file-dict.vala"
		_g_error_free0 (e);
#line 203 "file-dict.vala"
		_g_free0 (_midasi);
#line 203 "file-dict.vala"
		return result;
#line 1373 "file-dict.c"
	}
	__finally0:
#line 199 "file-dict.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "file-dict.vala"
		_g_free0 (_midasi);
#line 199 "file-dict.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 199 "file-dict.vala"
		g_clear_error (&_inner_error0_);
#line 199 "file-dict.vala"
		return NULL;
#line 1386 "file-dict.c"
	}
#line 214 "file-dict.vala"
	if (okuri) {
#line 214 "file-dict.vala"
		_tmp16_ = -1;
#line 1392 "file-dict.c"
	} else {
#line 214 "file-dict.vala"
		_tmp16_ = 1;
#line 1396 "file-dict.c"
	}
#line 208 "file-dict.vala"
	_tmp17_ = _midasi;
#line 208 "file-dict.vala"
	_tmp18_ = ((GCompareFunc) g_strcmp0);
#line 208 "file-dict.vala"
	_tmp21_ = skk_file_dict_search_pos (self, _tmp17_, start_offset, end_offset, _tmp18_, &_tmp19_, &_tmp20_, _tmp16_);
#line 208 "file-dict.vala"
	pos = _tmp19_;
#line 208 "file-dict.vala"
	_g_free0 (line);
#line 208 "file-dict.vala"
	line = _tmp20_;
#line 208 "file-dict.vala"
	if (_tmp21_) {
#line 1412 "file-dict.c"
		gint index = 0;
		const gchar* _tmp22_;
		gchar* _line = NULL;
#line 215 "file-dict.vala"
		_tmp22_ = line;
#line 215 "file-dict.vala"
		index = string_index_of (_tmp22_, " ", 0);
#line 217 "file-dict.vala"
		if (index > 0) {
#line 1422 "file-dict.c"
			const gchar* _tmp39_;
			gint _tmp40_ = 0;
			SkkCandidate** _tmp41_;
			SkkCandidate** _tmp42_;
			gint _tmp42__length1;
			{
				gchar* _tmp23_ = NULL;
				SkkEncodingConverter* _tmp24_;
				const gchar* _tmp25_;
				const gchar* _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
#line 219 "file-dict.vala"
				_tmp24_ = self->priv->converter;
#line 219 "file-dict.vala"
				_tmp25_ = line;
#line 219 "file-dict.vala"
				_tmp26_ = line;
#line 219 "file-dict.vala"
				_tmp27_ = strlen (_tmp26_);
#line 219 "file-dict.vala"
				_tmp28_ = _tmp27_;
#line 219 "file-dict.vala"
				_tmp29_ = string_slice (_tmp25_, (glong) index, (glong) _tmp28_);
#line 219 "file-dict.vala"
				_tmp30_ = _tmp29_;
#line 219 "file-dict.vala"
				_tmp31_ = skk_encoding_converter_decode (_tmp24_, _tmp30_, &_inner_error0_);
#line 219 "file-dict.vala"
				_tmp32_ = _tmp31_;
#line 219 "file-dict.vala"
				_g_free0 (_tmp30_);
#line 219 "file-dict.vala"
				_tmp23_ = _tmp32_;
#line 219 "file-dict.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1464 "file-dict.c"
					goto __catch1_g_error;
				}
#line 219 "file-dict.vala"
				_tmp33_ = _tmp23_;
#line 219 "file-dict.vala"
				_tmp23_ = NULL;
#line 219 "file-dict.vala"
				_g_free0 (_line);
#line 219 "file-dict.vala"
				_line = _tmp33_;
#line 218 "file-dict.vala"
				_g_free0 (_tmp23_);
#line 1477 "file-dict.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* e = NULL;
				const gchar* _tmp34_;
				GError* _tmp35_;
				const gchar* _tmp36_;
				SkkCandidate** _tmp37_;
				SkkCandidate** _tmp38_;
				gint _tmp38__length1;
#line 218 "file-dict.vala"
				e = _inner_error0_;
#line 218 "file-dict.vala"
				_inner_error0_ = NULL;
#line 221 "file-dict.vala"
				_tmp34_ = line;
#line 221 "file-dict.vala"
				_tmp35_ = e;
#line 221 "file-dict.vala"
				_tmp36_ = _tmp35_->message;
#line 221 "file-dict.vala"
				g_warning ("file-dict.vala:221: can't decode line %s: %s", _tmp34_, _tmp36_);
#line 223 "file-dict.vala"
				_tmp37_ = g_new0 (SkkCandidate*, 0 + 1);
#line 223 "file-dict.vala"
				_tmp38_ = _tmp37_;
#line 223 "file-dict.vala"
				_tmp38__length1 = 0;
#line 223 "file-dict.vala"
				if (result_length1) {
#line 223 "file-dict.vala"
					*result_length1 = _tmp38__length1;
#line 1511 "file-dict.c"
				}
#line 223 "file-dict.vala"
				result = _tmp38_;
#line 223 "file-dict.vala"
				_g_error_free0 (e);
#line 223 "file-dict.vala"
				_g_free0 (_line);
#line 223 "file-dict.vala"
				_g_free0 (line);
#line 223 "file-dict.vala"
				_g_free0 (_midasi);
#line 223 "file-dict.vala"
				return result;
#line 1525 "file-dict.c"
			}
			__finally1:
#line 218 "file-dict.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 218 "file-dict.vala"
				_g_free0 (_line);
#line 218 "file-dict.vala"
				_g_free0 (line);
#line 218 "file-dict.vala"
				_g_free0 (_midasi);
#line 218 "file-dict.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 218 "file-dict.vala"
				g_clear_error (&_inner_error0_);
#line 218 "file-dict.vala"
				return NULL;
#line 1542 "file-dict.c"
			}
#line 225 "file-dict.vala"
			_tmp39_ = _line;
#line 225 "file-dict.vala"
			_tmp41_ = skk_dict_split_candidates ((SkkDict*) self, midasi, okuri, _tmp39_, &_tmp40_);
#line 225 "file-dict.vala"
			_tmp42_ = _tmp41_;
#line 225 "file-dict.vala"
			_tmp42__length1 = _tmp40_;
#line 225 "file-dict.vala"
			if (result_length1) {
#line 225 "file-dict.vala"
				*result_length1 = _tmp42__length1;
#line 1556 "file-dict.c"
			}
#line 225 "file-dict.vala"
			result = _tmp42_;
#line 225 "file-dict.vala"
			_g_free0 (_line);
#line 225 "file-dict.vala"
			_g_free0 (line);
#line 225 "file-dict.vala"
			_g_free0 (_midasi);
#line 225 "file-dict.vala"
			return result;
#line 1568 "file-dict.c"
		}
#line 208 "file-dict.vala"
		_g_free0 (_line);
#line 1572 "file-dict.c"
	}
#line 228 "file-dict.vala"
	_tmp43_ = g_new0 (SkkCandidate*, 0 + 1);
#line 228 "file-dict.vala"
	_tmp44_ = _tmp43_;
#line 228 "file-dict.vala"
	_tmp44__length1 = 0;
#line 228 "file-dict.vala"
	if (result_length1) {
#line 228 "file-dict.vala"
		*result_length1 = _tmp44__length1;
#line 1584 "file-dict.c"
	}
#line 228 "file-dict.vala"
	result = _tmp44_;
#line 228 "file-dict.vala"
	_g_free0 (line);
#line 228 "file-dict.vala"
	_g_free0 (_midasi);
#line 228 "file-dict.vala"
	return result;
#line 1594 "file-dict.c"
}

static gint
skk_file_dict_strcmp_prefix (const gchar* a,
                             const gchar* b)
{
	GCompareFunc _tmp0_;
	gint result;
#line 231 "file-dict.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 231 "file-dict.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 232 "file-dict.vala"
	if (g_str_has_prefix (a, b)) {
#line 233 "file-dict.vala"
		result = 0;
#line 233 "file-dict.vala"
		return result;
#line 1613 "file-dict.c"
	}
#line 234 "file-dict.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 234 "file-dict.vala"
	result = _tmp0_ (a, b);
#line 234 "file-dict.vala"
	return result;
#line 1621 "file-dict.c"
}

/**
         * {@inheritDoc}
         */
static gint
_skk_file_dict_strcmp_prefix_gcompare_func (gconstpointer a,
                                            gconstpointer b)
{
	gint result;
	result = skk_file_dict_strcmp_prefix ((const gchar*) a, (const gchar*) b);
#line 260 "file-dict.vala"
	return result;
#line 1635 "file-dict.c"
}

static gchar**
skk_file_dict_real_complete (SkkDict* base,
                             const gchar* midasi,
                             gint* result_length1)
{
	SkkFileDict * self;
	SkkMemoryMappedFile* _tmp0_;
	void* _tmp1_;
	void* _tmp2_;
	GeeArrayList* completion = NULL;
	GeeArrayList* _tmp5_;
	glong start_offset = 0L;
	glong end_offset = 0L;
	SkkMemoryMappedFile* _tmp6_;
	gsize _tmp7_;
	gsize _tmp8_;
	gchar* _midasi = NULL;
	glong pos = 0L;
	gchar* line = NULL;
	const gchar* _tmp19_;
	glong _tmp20_ = 0L;
	gchar* _tmp21_ = NULL;
	gboolean _tmp22_;
	GeeArrayList* _tmp68_;
	gint _tmp69_ = 0;
	gpointer* _tmp70_;
	gchar** _tmp71_;
	gint _tmp71__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 240 "file-dict.vala"
	self = (SkkFileDict*) base;
#line 240 "file-dict.vala"
	g_return_val_if_fail (midasi != NULL, NULL);
#line 241 "file-dict.vala"
	_tmp0_ = self->priv->mmap;
#line 241 "file-dict.vala"
	_tmp1_ = skk_memory_mapped_file_get_memory (_tmp0_);
#line 241 "file-dict.vala"
	_tmp2_ = _tmp1_;
#line 241 "file-dict.vala"
	if (_tmp2_ == NULL) {
#line 1680 "file-dict.c"
		gchar** _tmp3_;
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 242 "file-dict.vala"
		_tmp3_ = g_new0 (gchar*, 0 + 1);
#line 242 "file-dict.vala"
		_tmp4_ = _tmp3_;
#line 242 "file-dict.vala"
		_tmp4__length1 = 0;
#line 242 "file-dict.vala"
		if (result_length1) {
#line 242 "file-dict.vala"
			*result_length1 = _tmp4__length1;
#line 1694 "file-dict.c"
		}
#line 242 "file-dict.vala"
		result = _tmp4_;
#line 242 "file-dict.vala"
		return result;
#line 1700 "file-dict.c"
	}
#line 244 "file-dict.vala"
	_tmp5_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 244 "file-dict.vala"
	completion = _tmp5_;
#line 247 "file-dict.vala"
	start_offset = self->priv->okuri_nasi_offset;
#line 248 "file-dict.vala"
	_tmp6_ = self->priv->mmap;
#line 248 "file-dict.vala"
	_tmp7_ = skk_memory_mapped_file_get_length (_tmp6_);
#line 248 "file-dict.vala"
	_tmp8_ = _tmp7_;
#line 248 "file-dict.vala"
	end_offset = ((glong) _tmp8_) - 1;
#line 1716 "file-dict.c"
	{
		gchar* _tmp9_ = NULL;
		SkkEncodingConverter* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 252 "file-dict.vala"
		_tmp10_ = self->priv->converter;
#line 252 "file-dict.vala"
		_tmp11_ = skk_encoding_converter_encode (_tmp10_, midasi, &_inner_error0_);
#line 252 "file-dict.vala"
		_tmp9_ = _tmp11_;
#line 252 "file-dict.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1730 "file-dict.c"
			goto __catch0_g_error;
		}
#line 252 "file-dict.vala"
		_tmp12_ = _tmp9_;
#line 252 "file-dict.vala"
		_tmp9_ = NULL;
#line 252 "file-dict.vala"
		_g_free0 (_midasi);
#line 252 "file-dict.vala"
		_midasi = _tmp12_;
#line 251 "file-dict.vala"
		_g_free0 (_tmp9_);
#line 1743 "file-dict.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		GeeArrayList* _tmp15_;
		gint _tmp16_ = 0;
		gpointer* _tmp17_;
		gchar** _tmp18_;
		gint _tmp18__length1;
#line 251 "file-dict.vala"
		e = _inner_error0_;
#line 251 "file-dict.vala"
		_inner_error0_ = NULL;
#line 254 "file-dict.vala"
		_tmp13_ = e;
#line 254 "file-dict.vala"
		_tmp14_ = _tmp13_->message;
#line 254 "file-dict.vala"
		g_warning ("file-dict.vala:254: can't decode %s: %s", midasi, _tmp14_);
#line 255 "file-dict.vala"
		_tmp15_ = completion;
#line 255 "file-dict.vala"
		_tmp17_ = gee_collection_to_array ((GeeCollection*) _tmp15_, &_tmp16_);
#line 255 "file-dict.vala"
		_tmp18_ = _tmp17_;
#line 255 "file-dict.vala"
		_tmp18__length1 = _tmp16_;
#line 255 "file-dict.vala"
		if (result_length1) {
#line 255 "file-dict.vala"
			*result_length1 = _tmp18__length1;
#line 1778 "file-dict.c"
		}
#line 255 "file-dict.vala"
		result = _tmp18_;
#line 255 "file-dict.vala"
		_g_error_free0 (e);
#line 255 "file-dict.vala"
		_g_free0 (_midasi);
#line 255 "file-dict.vala"
		_g_object_unref0 (completion);
#line 255 "file-dict.vala"
		return result;
#line 1790 "file-dict.c"
	}
	__finally0:
#line 251 "file-dict.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 251 "file-dict.vala"
		_g_free0 (_midasi);
#line 251 "file-dict.vala"
		_g_object_unref0 (completion);
#line 251 "file-dict.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 251 "file-dict.vala"
		g_clear_error (&_inner_error0_);
#line 251 "file-dict.vala"
		return NULL;
#line 1805 "file-dict.c"
	}
#line 260 "file-dict.vala"
	_tmp19_ = _midasi;
#line 260 "file-dict.vala"
	_tmp22_ = skk_file_dict_search_pos (self, _tmp19_, start_offset, end_offset, _skk_file_dict_strcmp_prefix_gcompare_func, &_tmp20_, &_tmp21_, 1);
#line 260 "file-dict.vala"
	pos = _tmp20_;
#line 260 "file-dict.vala"
	_g_free0 (line);
#line 260 "file-dict.vala"
	line = _tmp21_;
#line 260 "file-dict.vala"
	if (_tmp22_) {
#line 1819 "file-dict.c"
		glong _pos = 0L;
		gchar* _line = NULL;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp46_;
		gchar* _tmp47_;
#line 267 "file-dict.vala"
		_pos = pos;
#line 268 "file-dict.vala"
		_tmp23_ = line;
#line 268 "file-dict.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 268 "file-dict.vala"
		_line = _tmp24_;
#line 1834 "file-dict.c"
		{
			gboolean _tmp25_ = FALSE;
#line 271 "file-dict.vala"
			_tmp25_ = TRUE;
#line 271 "file-dict.vala"
			while (TRUE) {
#line 1841 "file-dict.c"
				gint index = 0;
				const gchar* _tmp32_;
#line 271 "file-dict.vala"
				if (!_tmp25_) {
#line 1846 "file-dict.c"
					gboolean _tmp26_ = FALSE;
					const gchar* _tmp27_;
					gchar* _tmp28_;
					const gchar* _tmp29_;
#line 289 "file-dict.vala"
					_tmp27_ = line;
#line 289 "file-dict.vala"
					_tmp28_ = skk_file_dict_read_previous_line (self, &pos, _tmp27_);
#line 289 "file-dict.vala"
					_g_free0 (line);
#line 289 "file-dict.vala"
					line = _tmp28_;
#line 289 "file-dict.vala"
					_tmp29_ = line;
#line 289 "file-dict.vala"
					if (_tmp29_ != NULL) {
#line 1863 "file-dict.c"
						const gchar* _tmp30_;
						const gchar* _tmp31_;
#line 290 "file-dict.vala"
						_tmp30_ = line;
#line 290 "file-dict.vala"
						_tmp31_ = _midasi;
#line 290 "file-dict.vala"
						_tmp26_ = g_str_has_prefix (_tmp30_, _tmp31_);
#line 1872 "file-dict.c"
					} else {
#line 289 "file-dict.vala"
						_tmp26_ = FALSE;
#line 1876 "file-dict.c"
					}
#line 289 "file-dict.vala"
					if (!_tmp26_) {
#line 289 "file-dict.vala"
						break;
#line 1882 "file-dict.c"
					}
				}
#line 271 "file-dict.vala"
				_tmp25_ = FALSE;
#line 272 "file-dict.vala"
				_tmp32_ = line;
#line 272 "file-dict.vala"
				index = string_index_of (_tmp32_, " ", 0);
#line 273 "file-dict.vala"
				if (index < 0) {
#line 1893 "file-dict.c"
					const gchar* _tmp33_;
#line 274 "file-dict.vala"
					_tmp33_ = line;
#line 274 "file-dict.vala"
					g_warning ("file-dict.vala:274: corrupted dictionary entry: %s", _tmp33_);
#line 1899 "file-dict.c"
				} else {
					gchar* completed = NULL;
					const gchar* _tmp34_;
					gchar* _tmp35_;
					const gchar* _tmp36_;
					const gchar* _tmp37_;
#line 277 "file-dict.vala"
					_tmp34_ = line;
#line 277 "file-dict.vala"
					_tmp35_ = string_slice (_tmp34_, (glong) 0, (glong) index);
#line 277 "file-dict.vala"
					completed = _tmp35_;
#line 279 "file-dict.vala"
					_tmp36_ = completed;
#line 279 "file-dict.vala"
					_tmp37_ = _midasi;
#line 279 "file-dict.vala"
					if (g_strcmp0 (_tmp36_, _tmp37_) != 0) {
#line 1918 "file-dict.c"
						{
							gchar* decoded = NULL;
							SkkEncodingConverter* _tmp38_;
							const gchar* _tmp39_;
							gchar* _tmp40_;
							GeeArrayList* _tmp41_;
							const gchar* _tmp42_;
#line 281 "file-dict.vala"
							_tmp38_ = self->priv->converter;
#line 281 "file-dict.vala"
							_tmp39_ = completed;
#line 281 "file-dict.vala"
							_tmp40_ = skk_encoding_converter_decode (_tmp38_, _tmp39_, &_inner_error0_);
#line 281 "file-dict.vala"
							decoded = _tmp40_;
#line 281 "file-dict.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1936 "file-dict.c"
								goto __catch1_g_error;
							}
#line 282 "file-dict.vala"
							_tmp41_ = completion;
#line 282 "file-dict.vala"
							_tmp42_ = decoded;
#line 282 "file-dict.vala"
							gee_abstract_list_insert ((GeeAbstractList*) _tmp41_, 0, _tmp42_);
#line 280 "file-dict.vala"
							_g_free0 (decoded);
#line 1947 "file-dict.c"
						}
						goto __finally1;
						__catch1_g_error:
						{
							GError* e = NULL;
							const gchar* _tmp43_;
							GError* _tmp44_;
							const gchar* _tmp45_;
#line 280 "file-dict.vala"
							e = _inner_error0_;
#line 280 "file-dict.vala"
							_inner_error0_ = NULL;
#line 284 "file-dict.vala"
							_tmp43_ = line;
#line 284 "file-dict.vala"
							_tmp44_ = e;
#line 284 "file-dict.vala"
							_tmp45_ = _tmp44_->message;
#line 284 "file-dict.vala"
							g_warning ("file-dict.vala:284: can't decode line %s: %s", _tmp43_, _tmp45_);
#line 280 "file-dict.vala"
							_g_error_free0 (e);
#line 1970 "file-dict.c"
						}
						__finally1:
#line 280 "file-dict.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 280 "file-dict.vala"
							_g_free0 (completed);
#line 280 "file-dict.vala"
							_g_free0 (_line);
#line 280 "file-dict.vala"
							_g_free0 (line);
#line 280 "file-dict.vala"
							_g_free0 (_midasi);
#line 280 "file-dict.vala"
							_g_object_unref0 (completion);
#line 280 "file-dict.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 280 "file-dict.vala"
							g_clear_error (&_inner_error0_);
#line 280 "file-dict.vala"
							return NULL;
#line 1991 "file-dict.c"
						}
					}
#line 273 "file-dict.vala"
					_g_free0 (completed);
#line 1996 "file-dict.c"
				}
			}
		}
#line 293 "file-dict.vala"
		pos = _pos;
#line 294 "file-dict.vala"
		_tmp46_ = _line;
#line 294 "file-dict.vala"
		_tmp47_ = g_strdup (_tmp46_);
#line 294 "file-dict.vala"
		_g_free0 (line);
#line 294 "file-dict.vala"
		line = _tmp47_;
#line 295 "file-dict.vala"
		while (TRUE) {
#line 2012 "file-dict.c"
			gboolean _tmp48_ = FALSE;
			const gchar* _tmp49_;
			gchar* _tmp50_;
			const gchar* _tmp51_;
			gint index = 0;
			const gchar* _tmp54_;
#line 295 "file-dict.vala"
			_tmp49_ = line;
#line 295 "file-dict.vala"
			_tmp50_ = skk_file_dict_read_next_line (self, &pos, _tmp49_);
#line 295 "file-dict.vala"
			_g_free0 (line);
#line 295 "file-dict.vala"
			line = _tmp50_;
#line 295 "file-dict.vala"
			_tmp51_ = line;
#line 295 "file-dict.vala"
			if (_tmp51_ != NULL) {
#line 2031 "file-dict.c"
				const gchar* _tmp52_;
				const gchar* _tmp53_;
#line 296 "file-dict.vala"
				_tmp52_ = line;
#line 296 "file-dict.vala"
				_tmp53_ = _midasi;
#line 296 "file-dict.vala"
				_tmp48_ = g_str_has_prefix (_tmp52_, _tmp53_);
#line 2040 "file-dict.c"
			} else {
#line 295 "file-dict.vala"
				_tmp48_ = FALSE;
#line 2044 "file-dict.c"
			}
#line 295 "file-dict.vala"
			if (!_tmp48_) {
#line 295 "file-dict.vala"
				break;
#line 2050 "file-dict.c"
			}
#line 297 "file-dict.vala"
			_tmp54_ = line;
#line 297 "file-dict.vala"
			index = string_index_of (_tmp54_, " ", 0);
#line 298 "file-dict.vala"
			if (index < 0) {
#line 2058 "file-dict.c"
				const gchar* _tmp55_;
#line 299 "file-dict.vala"
				_tmp55_ = line;
#line 299 "file-dict.vala"
				g_warning ("file-dict.vala:299: corrupted dictionary entry: %s", _tmp55_);
#line 2064 "file-dict.c"
			} else {
				gchar* completed = NULL;
				const gchar* _tmp56_;
				gchar* _tmp57_;
				const gchar* _tmp58_;
				const gchar* _tmp59_;
#line 302 "file-dict.vala"
				_tmp56_ = line;
#line 302 "file-dict.vala"
				_tmp57_ = string_slice (_tmp56_, (glong) 0, (glong) index);
#line 302 "file-dict.vala"
				completed = _tmp57_;
#line 304 "file-dict.vala"
				_tmp58_ = completed;
#line 304 "file-dict.vala"
				_tmp59_ = _midasi;
#line 304 "file-dict.vala"
				if (g_strcmp0 (_tmp58_, _tmp59_) != 0) {
#line 2083 "file-dict.c"
					{
						gchar* decoded = NULL;
						SkkEncodingConverter* _tmp60_;
						const gchar* _tmp61_;
						gchar* _tmp62_;
						GeeArrayList* _tmp63_;
						const gchar* _tmp64_;
#line 306 "file-dict.vala"
						_tmp60_ = self->priv->converter;
#line 306 "file-dict.vala"
						_tmp61_ = completed;
#line 306 "file-dict.vala"
						_tmp62_ = skk_encoding_converter_decode (_tmp60_, _tmp61_, &_inner_error0_);
#line 306 "file-dict.vala"
						decoded = _tmp62_;
#line 306 "file-dict.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2101 "file-dict.c"
							goto __catch2_g_error;
						}
#line 307 "file-dict.vala"
						_tmp63_ = completion;
#line 307 "file-dict.vala"
						_tmp64_ = decoded;
#line 307 "file-dict.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp63_, _tmp64_);
#line 305 "file-dict.vala"
						_g_free0 (decoded);
#line 2112 "file-dict.c"
					}
					goto __finally2;
					__catch2_g_error:
					{
						GError* e = NULL;
						const gchar* _tmp65_;
						GError* _tmp66_;
						const gchar* _tmp67_;
#line 305 "file-dict.vala"
						e = _inner_error0_;
#line 305 "file-dict.vala"
						_inner_error0_ = NULL;
#line 309 "file-dict.vala"
						_tmp65_ = line;
#line 309 "file-dict.vala"
						_tmp66_ = e;
#line 309 "file-dict.vala"
						_tmp67_ = _tmp66_->message;
#line 309 "file-dict.vala"
						g_warning ("file-dict.vala:309: can't decode line %s: %s", _tmp65_, _tmp67_);
#line 305 "file-dict.vala"
						_g_error_free0 (e);
#line 2135 "file-dict.c"
					}
					__finally2:
#line 305 "file-dict.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 305 "file-dict.vala"
						_g_free0 (completed);
#line 305 "file-dict.vala"
						_g_free0 (_line);
#line 305 "file-dict.vala"
						_g_free0 (line);
#line 305 "file-dict.vala"
						_g_free0 (_midasi);
#line 305 "file-dict.vala"
						_g_object_unref0 (completion);
#line 305 "file-dict.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 305 "file-dict.vala"
						g_clear_error (&_inner_error0_);
#line 305 "file-dict.vala"
						return NULL;
#line 2156 "file-dict.c"
					}
				}
#line 298 "file-dict.vala"
				_g_free0 (completed);
#line 2161 "file-dict.c"
			}
		}
#line 260 "file-dict.vala"
		_g_free0 (_line);
#line 2166 "file-dict.c"
	}
#line 316 "file-dict.vala"
	_tmp68_ = completion;
#line 316 "file-dict.vala"
	_tmp70_ = gee_collection_to_array ((GeeCollection*) _tmp68_, &_tmp69_);
#line 316 "file-dict.vala"
	_tmp71_ = _tmp70_;
#line 316 "file-dict.vala"
	_tmp71__length1 = _tmp69_;
#line 316 "file-dict.vala"
	if (result_length1) {
#line 316 "file-dict.vala"
		*result_length1 = _tmp71__length1;
#line 2180 "file-dict.c"
	}
#line 316 "file-dict.vala"
	result = _tmp71_;
#line 316 "file-dict.vala"
	_g_free0 (line);
#line 316 "file-dict.vala"
	_g_free0 (_midasi);
#line 316 "file-dict.vala"
	_g_object_unref0 (completion);
#line 316 "file-dict.vala"
	return result;
#line 2192 "file-dict.c"
}

/**
         * Create a new FileDict.
         *
         * @param path a path to the file
         * @param encoding encoding of the file (default EUC-JP)
         *
         * @return a new FileDict
         * @throws GLib.Error if opening the file is failed
         */
SkkFileDict*
skk_file_dict_construct (GType object_type,
                         const gchar* path,
                         const gchar* encoding,
                         GError** error)
{
	SkkFileDict * self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	SkkMemoryMappedFile* _tmp2_;
	gchar* _tmp3_;
	SkkEncodingConverter* _tmp4_ = NULL;
	SkkEncodingConverter* _tmp5_;
	SkkEncodingConverter* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 344 "file-dict.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 344 "file-dict.vala"
	g_return_val_if_fail (encoding != NULL, NULL);
#line 344 "file-dict.vala"
	self = (SkkFileDict*) skk_dict_construct (object_type);
#line 347 "file-dict.vala"
	_tmp0_ = g_file_new_for_path (path);
#line 347 "file-dict.vala"
	_g_object_unref0 (self->priv->file);
#line 347 "file-dict.vala"
	self->priv->file = _tmp0_;
#line 348 "file-dict.vala"
	_tmp1_ = self->priv->file;
#line 348 "file-dict.vala"
	_tmp2_ = skk_memory_mapped_file_new (_tmp1_);
#line 348 "file-dict.vala"
	_g_object_unref0 (self->priv->mmap);
#line 348 "file-dict.vala"
	self->priv->mmap = _tmp2_;
#line 349 "file-dict.vala"
	_tmp3_ = g_strdup ("");
#line 349 "file-dict.vala"
	_g_free0 (self->priv->etag);
#line 349 "file-dict.vala"
	self->priv->etag = _tmp3_;
#line 350 "file-dict.vala"
	_tmp5_ = skk_encoding_converter_new (encoding, &_inner_error0_);
#line 350 "file-dict.vala"
	_tmp4_ = _tmp5_;
#line 350 "file-dict.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 350 "file-dict.vala"
		g_propagate_error (error, _inner_error0_);
#line 350 "file-dict.vala"
		_g_object_unref0 (self);
#line 350 "file-dict.vala"
		return NULL;
#line 2257 "file-dict.c"
	}
#line 350 "file-dict.vala"
	_tmp6_ = _tmp4_;
#line 350 "file-dict.vala"
	_tmp4_ = NULL;
#line 350 "file-dict.vala"
	_g_object_unref0 (self->priv->converter);
#line 350 "file-dict.vala"
	self->priv->converter = _tmp6_;
#line 351 "file-dict.vala"
	skk_dict_reload ((SkkDict*) self, &_inner_error0_);
#line 351 "file-dict.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 351 "file-dict.vala"
		g_propagate_error (error, _inner_error0_);
#line 351 "file-dict.vala"
		_g_object_unref0 (_tmp4_);
#line 351 "file-dict.vala"
		_g_object_unref0 (self);
#line 351 "file-dict.vala"
		return NULL;
#line 2279 "file-dict.c"
	}
#line 344 "file-dict.vala"
	_g_object_unref0 (_tmp4_);
#line 344 "file-dict.vala"
	return self;
#line 2285 "file-dict.c"
}

SkkFileDict*
skk_file_dict_new (const gchar* path,
                   const gchar* encoding,
                   GError** error)
{
#line 344 "file-dict.vala"
	return skk_file_dict_construct (SKK_TYPE_FILE_DICT, path, encoding, error);
#line 2295 "file-dict.c"
}

static gboolean
skk_file_dict_real_get_read_only (SkkDict* base)
{
	gboolean result;
	SkkFileDict* self;
#line 323 "file-dict.vala"
	self = (SkkFileDict*) base;
#line 324 "file-dict.vala"
	result = TRUE;
#line 324 "file-dict.vala"
	return result;
#line 2309 "file-dict.c"
}

static void
skk_file_dict_class_init (SkkFileDictClass * klass,
                          gpointer klass_data)
{
#line 24 "file-dict.vala"
	skk_file_dict_parent_class = g_type_class_peek_parent (klass);
#line 24 "file-dict.vala"
	g_type_class_adjust_private_offset (klass, &SkkFileDict_private_offset);
#line 24 "file-dict.vala"
	((SkkDictClass *) klass)->reload = (void (*) (SkkDict*, GError**)) skk_file_dict_real_reload;
#line 24 "file-dict.vala"
	((SkkDictClass *) klass)->lookup = (SkkCandidate** (*) (SkkDict*, const gchar*, gboolean, gint*)) skk_file_dict_real_lookup;
#line 24 "file-dict.vala"
	((SkkDictClass *) klass)->complete = (gchar** (*) (SkkDict*, const gchar*, gint*)) skk_file_dict_real_complete;
#line 24 "file-dict.vala"
	SKK_DICT_CLASS (klass)->get_read_only = (gboolean (*) (SkkDict*)) skk_file_dict_real_get_read_only;
#line 24 "file-dict.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_skk_file_dict_get_property;
#line 24 "file-dict.vala"
	G_OBJECT_CLASS (klass)->finalize = skk_file_dict_finalize;
#line 2332 "file-dict.c"
	/**
	         * {@inheritDoc}
	         */
#line 24 "file-dict.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_FILE_DICT_READ_ONLY_PROPERTY, skk_file_dict_properties[SKK_FILE_DICT_READ_ONLY_PROPERTY] = g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2338 "file-dict.c"
}

static void
skk_file_dict_instance_init (SkkFileDict * self,
                             gpointer klass)
{
#line 24 "file-dict.vala"
	self->priv = skk_file_dict_get_instance_private (self);
#line 2347 "file-dict.c"
}

static void
skk_file_dict_finalize (GObject * obj)
{
	SkkFileDict * self;
#line 24 "file-dict.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SKK_TYPE_FILE_DICT, SkkFileDict);
#line 328 "file-dict.vala"
	_g_object_unref0 (self->priv->file);
#line 329 "file-dict.vala"
	_g_object_unref0 (self->priv->mmap);
#line 330 "file-dict.vala"
	_g_free0 (self->priv->etag);
#line 331 "file-dict.vala"
	_g_object_unref0 (self->priv->converter);
#line 24 "file-dict.vala"
	G_OBJECT_CLASS (skk_file_dict_parent_class)->finalize (obj);
#line 2366 "file-dict.c"
}

/**
     * Read-only file based implementation of Dict.
     */
static GType
skk_file_dict_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SkkFileDictClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) skk_file_dict_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SkkFileDict), 0, (GInstanceInitFunc) skk_file_dict_instance_init, NULL };
	GType skk_file_dict_type_id;
	skk_file_dict_type_id = g_type_register_static (SKK_TYPE_DICT, "SkkFileDict", &g_define_type_info, 0);
	SkkFileDict_private_offset = g_type_add_instance_private (skk_file_dict_type_id, sizeof (SkkFileDictPrivate));
	return skk_file_dict_type_id;
}

GType
skk_file_dict_get_type (void)
{
	static volatile gsize skk_file_dict_type_id__once = 0;
	if (g_once_init_enter (&skk_file_dict_type_id__once)) {
		GType skk_file_dict_type_id;
		skk_file_dict_type_id = skk_file_dict_get_type_once ();
		g_once_init_leave (&skk_file_dict_type_id__once, skk_file_dict_type_id);
	}
	return skk_file_dict_type_id__once;
}

static void
_vala_skk_file_dict_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	SkkFileDict * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SKK_TYPE_FILE_DICT, SkkFileDict);
#line 24 "file-dict.vala"
	switch (property_id) {
#line 24 "file-dict.vala"
		case SKK_FILE_DICT_READ_ONLY_PROPERTY:
#line 24 "file-dict.vala"
		g_value_set_boolean (value, skk_dict_get_read_only ((SkkDict*) self));
#line 24 "file-dict.vala"
		break;
#line 2410 "file-dict.c"
		default:
#line 24 "file-dict.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "file-dict.vala"
		break;
#line 2416 "file-dict.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

