/* key-event.c generated by valac 0.56.17, the Vala compiler
 * generated from key-event.vala, do not modify */

/*
 * Copyright (C) 2011-2018 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "libskk/libskk.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SKK_KEY_EVENT_0_PROPERTY,
	SKK_KEY_EVENT_NAME_PROPERTY,
	SKK_KEY_EVENT_CODE_PROPERTY,
	SKK_KEY_EVENT_MODIFIERS_PROPERTY,
	SKK_KEY_EVENT_NUM_PROPERTIES
};
static GParamSpec* skk_key_event_properties[SKK_KEY_EVENT_NUM_PROPERTIES];

#define SKK_KEY_EVENT_TYPE_CODE_KEYVAL_ENTRY (skk_key_event_code_keyval_entry_get_type ())
typedef struct _SkkKeyEventCodeKeyvalEntry SkkKeyEventCodeKeyvalEntry;

#define SKK_KEY_EVENT_TYPE_NAME_KEYVAL_ENTRY (skk_key_event_name_keyval_entry_get_type ())
typedef struct _SkkKeyEventNameKeyvalEntry SkkKeyEventNameKeyvalEntry;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SkkKeyEventPrivate {
	gchar* _name;
	gunichar _code;
	SkkModifierType _modifiers;
};

struct _SkkKeyEventCodeKeyvalEntry {
	guint key;
	gunichar value;
};

struct _SkkKeyEventNameKeyvalEntry {
	guint key;
	gchar* value;
};

static gint SkkKeyEvent_private_offset;
static gpointer skk_key_event_parent_class = NULL;

static GType skk_key_event_code_keyval_entry_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static SkkKeyEventCodeKeyvalEntry* skk_key_event_code_keyval_entry_dup (const SkkKeyEventCodeKeyvalEntry* self);
static void skk_key_event_code_keyval_entry_free (SkkKeyEventCodeKeyvalEntry* self);
static GType skk_key_event_name_keyval_entry_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static SkkKeyEventNameKeyvalEntry* skk_key_event_name_keyval_entry_dup (const SkkKeyEventNameKeyvalEntry* self);
static void skk_key_event_name_keyval_entry_free (SkkKeyEventNameKeyvalEntry* self);
static void skk_key_event_name_keyval_entry_copy (const SkkKeyEventNameKeyvalEntry* self,
                                           SkkKeyEventNameKeyvalEntry* dest);
static void skk_key_event_name_keyval_entry_destroy (SkkKeyEventNameKeyvalEntry* self);
static void skk_key_event_set_name (SkkKeyEvent* self,
                             const gchar* value);
static void skk_key_event_set_code (SkkKeyEvent* self,
                             gunichar value);
static void skk_key_event_finalize (GObject * obj);
static GType skk_key_event_get_type_once (void);
static void _vala_skk_key_event_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_skk_key_event_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const SkkKeyEventCodeKeyvalEntry SKK_KEY_EVENT_CODE_KEYVALS[3] = {{SKK_KEYSYMS_Tab, (gunichar) '\t'}, {SKK_KEYSYMS_Return, (gunichar) '\n'}, {SKK_KEYSYMS_BackSpace, (gunichar) '\b'}};
static const SkkKeyEventNameKeyvalEntry SKK_KEY_EVENT_NAME_KEYVALS[10] = {{SKK_KEYSYMS_Up, "Up"}, {SKK_KEYSYMS_Down, "Down"}, {SKK_KEYSYMS_Left, "Left"}, {SKK_KEYSYMS_Right, "Right"}, {SKK_KEYSYMS_Page_Up, "Page_Up"}, {SKK_KEYSYMS_KP_Page_Up, "Page_Up"}, {SKK_KEYSYMS_Page_Down, "Page_Down"}, {SKK_KEYSYMS_KP_Page_Down, "Page_Down"}, {SKK_KEYSYMS_Muhenkan, "lshift"}, {SKK_KEYSYMS_Henkan, "rshift"}};

GQuark
skk_key_event_format_error_quark (void)
{
	return g_quark_from_static_string ("skk-key-event-format-error-quark");
}

static GType
skk_key_event_format_error_get_type_once (void)
{
	static const GEnumValue values[] = {{SKK_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED, "SKK_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED", "parse-failed"}, {SKK_KEY_EVENT_FORMAT_ERROR_KEYSYM_NOT_FOUND, "SKK_KEY_EVENT_FORMAT_ERROR_KEYSYM_NOT_FOUND", "keysym-not-found"}, {0, NULL, NULL}};
	GType skk_key_event_format_error_type_id;
	skk_key_event_format_error_type_id = g_enum_register_static ("SkkKeyEventFormatError", values);
	return skk_key_event_format_error_type_id;
}

GType
skk_key_event_format_error_get_type (void)
{
	static volatile gsize skk_key_event_format_error_type_id__once = 0;
	if (g_once_init_enter (&skk_key_event_format_error_type_id__once)) {
		GType skk_key_event_format_error_type_id;
		skk_key_event_format_error_type_id = skk_key_event_format_error_get_type_once ();
		g_once_init_leave (&skk_key_event_format_error_type_id__once, skk_key_event_format_error_type_id);
	}
	return skk_key_event_format_error_type_id__once;
}

/**
     * A set of bit-flags to indicate the state of modifier keys.
     */
static GType
skk_modifier_type_get_type_once (void)
{
	static const GFlagsValue values[] = {{SKK_MODIFIER_TYPE_NONE, "SKK_MODIFIER_TYPE_NONE", "none"}, {SKK_MODIFIER_TYPE_SHIFT_MASK, "SKK_MODIFIER_TYPE_SHIFT_MASK", "shift-mask"}, {SKK_MODIFIER_TYPE_LOCK_MASK, "SKK_MODIFIER_TYPE_LOCK_MASK", "lock-mask"}, {SKK_MODIFIER_TYPE_CONTROL_MASK, "SKK_MODIFIER_TYPE_CONTROL_MASK", "control-mask"}, {SKK_MODIFIER_TYPE_MOD1_MASK, "SKK_MODIFIER_TYPE_MOD1_MASK", "mod1-mask"}, {SKK_MODIFIER_TYPE_MOD2_MASK, "SKK_MODIFIER_TYPE_MOD2_MASK", "mod2-mask"}, {SKK_MODIFIER_TYPE_MOD3_MASK, "SKK_MODIFIER_TYPE_MOD3_MASK", "mod3-mask"}, {SKK_MODIFIER_TYPE_MOD4_MASK, "SKK_MODIFIER_TYPE_MOD4_MASK", "mod4-mask"}, {SKK_MODIFIER_TYPE_MOD5_MASK, "SKK_MODIFIER_TYPE_MOD5_MASK", "mod5-mask"}, {SKK_MODIFIER_TYPE_LSHIFT_MASK, "SKK_MODIFIER_TYPE_LSHIFT_MASK", "lshift-mask"}, {SKK_MODIFIER_TYPE_RSHIFT_MASK, "SKK_MODIFIER_TYPE_RSHIFT_MASK", "rshift-mask"}, {SKK_MODIFIER_TYPE_USLEEP_MASK, "SKK_MODIFIER_TYPE_USLEEP_MASK", "usleep-mask"}, {SKK_MODIFIER_TYPE_SUPER_MASK, "SKK_MODIFIER_TYPE_SUPER_MASK", "super-mask"}, {SKK_MODIFIER_TYPE_HYPER_MASK, "SKK_MODIFIER_TYPE_HYPER_MASK", "hyper-mask"}, {SKK_MODIFIER_TYPE_META_MASK, "SKK_MODIFIER_TYPE_META_MASK", "meta-mask"}, {SKK_MODIFIER_TYPE_RELEASE_MASK, "SKK_MODIFIER_TYPE_RELEASE_MASK", "release-mask"}, {0, NULL, NULL}};
	GType skk_modifier_type_type_id;
	skk_modifier_type_type_id = g_flags_register_static ("SkkModifierType", values);
	return skk_modifier_type_type_id;
}

GType
skk_modifier_type_get_type (void)
{
	static volatile gsize skk_modifier_type_type_id__once = 0;
	if (g_once_init_enter (&skk_modifier_type_type_id__once)) {
		GType skk_modifier_type_type_id;
		skk_modifier_type_type_id = skk_modifier_type_get_type_once ();
		g_once_init_leave (&skk_modifier_type_type_id__once, skk_modifier_type_type_id);
	}
	return skk_modifier_type_type_id__once;
}

static inline gpointer
skk_key_event_get_instance_private (SkkKeyEvent* self)
{
	return G_STRUCT_MEMBER_P (self, SkkKeyEvent_private_offset);
}

/**
         * Create a key event.
         *
         * @param name a key name
         * @param code a character code
         * @param modifiers state of modifier keys
         *
         * @return a new KeyEvent
         */
SkkKeyEvent*
skk_key_event_construct (GType object_type,
                         const gchar* name,
                         gunichar code,
                         SkkModifierType modifiers)
{
	SkkKeyEvent * self = NULL;
#line 84 "key-event.vala"
	self = (SkkKeyEvent*) g_object_new (object_type, NULL);
#line 87 "key-event.vala"
	skk_key_event_set_name (self, name);
#line 88 "key-event.vala"
	skk_key_event_set_code (self, code);
#line 89 "key-event.vala"
	skk_key_event_set_modifiers (self, modifiers);
#line 84 "key-event.vala"
	return self;
#line 198 "key-event.c"
}

SkkKeyEvent*
skk_key_event_new (const gchar* name,
                   gunichar code,
                   SkkModifierType modifiers)
{
#line 84 "key-event.vala"
	return skk_key_event_construct (SKK_TYPE_KEY_EVENT, name, code, modifiers);
#line 208 "key-event.c"
}

/**
         * Create a copy of the key event.
         *
         * @return a new KeyEvent
         */
SkkKeyEvent*
skk_key_event_copy (SkkKeyEvent* self)
{
	const gchar* _tmp0_;
	gunichar _tmp1_;
	SkkModifierType _tmp2_;
	SkkKeyEvent* _tmp3_;
	SkkKeyEvent* result;
#line 97 "key-event.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "key-event.vala"
	_tmp0_ = self->priv->_name;
#line 98 "key-event.vala"
	_tmp1_ = self->priv->_code;
#line 98 "key-event.vala"
	_tmp2_ = self->priv->_modifiers;
#line 98 "key-event.vala"
	_tmp3_ = skk_key_event_new (_tmp0_, _tmp1_, _tmp2_);
#line 98 "key-event.vala"
	result = _tmp3_;
#line 98 "key-event.vala"
	return result;
#line 238 "key-event.c"
}

/**
         * Create a key event from string.
         *
         * @param key a string representation of a key event
         *
         * @return a new KeyEvent
         */
static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 272 "key-event.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 278 "key-event.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 284 "key-event.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 288 "key-event.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 296 "key-event.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 300 "key-event.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 312 "key-event.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1313 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1314 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1314 "glib-2.0.vapi"
	return result;
#line 326 "key-event.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1194 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1194 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1195 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1195 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1197 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1197 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 350 "key-event.c"
		gchar* _tmp2_;
#line 1198 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1198 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1198 "glib-2.0.vapi"
		return result;
#line 358 "key-event.c"
	} else {
#line 1200 "glib-2.0.vapi"
		result = -1;
#line 1200 "glib-2.0.vapi"
		return result;
#line 364 "key-event.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 388 "key-event.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 397 "key-event.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 416 "key-event.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 420 "key-event.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 426 "key-event.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 436 "key-event.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 444 "key-event.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 448 "key-event.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 454 "key-event.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 464 "key-event.c"
}

SkkKeyEvent*
skk_key_event_construct_from_string (GType object_type,
                                     const gchar* key,
                                     GError** error)
{
	SkkKeyEvent * self = NULL;
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 108 "key-event.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 108 "key-event.vala"
	self = (SkkKeyEvent*) g_object_new (object_type, NULL);
#line 109 "key-event.vala"
	if (g_str_has_prefix (key, "(")) {
#line 109 "key-event.vala"
		_tmp0_ = g_str_has_suffix (key, ")");
#line 483 "key-event.c"
	} else {
#line 109 "key-event.vala"
		_tmp0_ = FALSE;
#line 487 "key-event.c"
	}
#line 109 "key-event.vala"
	if (_tmp0_) {
#line 491 "key-event.c"
		gchar** strv = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		gint strv_length1;
		gint _strv_size_;
		gint index = 0;
		gchar** _tmp39_;
		gint _tmp39__length1;
		const gchar* _tmp40_;
		gunichar _tmp41_ = 0U;
		const gchar* _tmp42_;
#line 110 "key-event.vala"
		_tmp1_ = string_slice (key, (glong) 1, (glong) -1);
#line 110 "key-event.vala"
		_tmp2_ = _tmp1_;
#line 110 "key-event.vala"
		_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, " ", 0);
#line 110 "key-event.vala"
		_tmp5_ = _tmp4_;
#line 110 "key-event.vala"
		_tmp5__length1 = _vala_array_length (_tmp3_);
#line 110 "key-event.vala"
		_g_free0 (_tmp2_);
#line 110 "key-event.vala"
		strv = _tmp5_;
#line 110 "key-event.vala"
		strv_length1 = _tmp5__length1;
#line 110 "key-event.vala"
		_strv_size_ = strv_length1;
#line 111 "key-event.vala"
		index = 0;
#line 527 "key-event.c"
		{
			gboolean _tmp6_ = FALSE;
#line 112 "key-event.vala"
			_tmp6_ = TRUE;
#line 112 "key-event.vala"
			while (TRUE) {
#line 534 "key-event.c"
				gchar** _tmp8_;
				gint _tmp8__length1;
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
#line 112 "key-event.vala"
				if (!_tmp6_) {
#line 542 "key-event.c"
					gint _tmp7_;
#line 112 "key-event.vala"
					_tmp7_ = index;
#line 112 "key-event.vala"
					index = _tmp7_ + 1;
#line 548 "key-event.c"
				}
#line 112 "key-event.vala"
				_tmp6_ = FALSE;
#line 112 "key-event.vala"
				_tmp8_ = strv;
#line 112 "key-event.vala"
				_tmp8__length1 = strv_length1;
#line 112 "key-event.vala"
				if (!(index < (_tmp8__length1 - 1))) {
#line 112 "key-event.vala"
					break;
#line 560 "key-event.c"
				}
#line 113 "key-event.vala"
				_tmp9_ = strv;
#line 113 "key-event.vala"
				_tmp9__length1 = strv_length1;
#line 113 "key-event.vala"
				_tmp10_ = _tmp9_[index];
#line 113 "key-event.vala"
				if (g_strcmp0 (_tmp10_, "control") == 0) {
#line 570 "key-event.c"
					SkkModifierType _tmp11_;
#line 114 "key-event.vala"
					_tmp11_ = self->priv->_modifiers;
#line 114 "key-event.vala"
					skk_key_event_set_modifiers (self, _tmp11_ | SKK_MODIFIER_TYPE_CONTROL_MASK);
#line 576 "key-event.c"
				} else {
					gchar** _tmp12_;
					gint _tmp12__length1;
					const gchar* _tmp13_;
#line 115 "key-event.vala"
					_tmp12_ = strv;
#line 115 "key-event.vala"
					_tmp12__length1 = strv_length1;
#line 115 "key-event.vala"
					_tmp13_ = _tmp12_[index];
#line 115 "key-event.vala"
					if (g_strcmp0 (_tmp13_, "meta") == 0) {
#line 589 "key-event.c"
						SkkModifierType _tmp14_;
#line 116 "key-event.vala"
						_tmp14_ = self->priv->_modifiers;
#line 116 "key-event.vala"
						skk_key_event_set_modifiers (self, _tmp14_ | SKK_MODIFIER_TYPE_META_MASK);
#line 595 "key-event.c"
					} else {
						gchar** _tmp15_;
						gint _tmp15__length1;
						const gchar* _tmp16_;
#line 117 "key-event.vala"
						_tmp15_ = strv;
#line 117 "key-event.vala"
						_tmp15__length1 = strv_length1;
#line 117 "key-event.vala"
						_tmp16_ = _tmp15_[index];
#line 117 "key-event.vala"
						if (g_strcmp0 (_tmp16_, "hyper") == 0) {
#line 608 "key-event.c"
							SkkModifierType _tmp17_;
#line 118 "key-event.vala"
							_tmp17_ = self->priv->_modifiers;
#line 118 "key-event.vala"
							skk_key_event_set_modifiers (self, _tmp17_ | SKK_MODIFIER_TYPE_HYPER_MASK);
#line 614 "key-event.c"
						} else {
							gchar** _tmp18_;
							gint _tmp18__length1;
							const gchar* _tmp19_;
#line 119 "key-event.vala"
							_tmp18_ = strv;
#line 119 "key-event.vala"
							_tmp18__length1 = strv_length1;
#line 119 "key-event.vala"
							_tmp19_ = _tmp18_[index];
#line 119 "key-event.vala"
							if (g_strcmp0 (_tmp19_, "super") == 0) {
#line 627 "key-event.c"
								SkkModifierType _tmp20_;
#line 120 "key-event.vala"
								_tmp20_ = self->priv->_modifiers;
#line 120 "key-event.vala"
								skk_key_event_set_modifiers (self, _tmp20_ | SKK_MODIFIER_TYPE_SUPER_MASK);
#line 633 "key-event.c"
							} else {
								gchar** _tmp21_;
								gint _tmp21__length1;
								const gchar* _tmp22_;
#line 121 "key-event.vala"
								_tmp21_ = strv;
#line 121 "key-event.vala"
								_tmp21__length1 = strv_length1;
#line 121 "key-event.vala"
								_tmp22_ = _tmp21_[index];
#line 121 "key-event.vala"
								if (g_strcmp0 (_tmp22_, "alt") == 0) {
#line 646 "key-event.c"
									SkkModifierType _tmp23_;
#line 122 "key-event.vala"
									_tmp23_ = self->priv->_modifiers;
#line 122 "key-event.vala"
									skk_key_event_set_modifiers (self, _tmp23_ | SKK_MODIFIER_TYPE_MOD1_MASK);
#line 652 "key-event.c"
								} else {
									gchar** _tmp24_;
									gint _tmp24__length1;
									const gchar* _tmp25_;
#line 123 "key-event.vala"
									_tmp24_ = strv;
#line 123 "key-event.vala"
									_tmp24__length1 = strv_length1;
#line 123 "key-event.vala"
									_tmp25_ = _tmp24_[index];
#line 123 "key-event.vala"
									if (g_strcmp0 (_tmp25_, "lshift") == 0) {
#line 665 "key-event.c"
										SkkModifierType _tmp26_;
#line 124 "key-event.vala"
										_tmp26_ = self->priv->_modifiers;
#line 124 "key-event.vala"
										skk_key_event_set_modifiers (self, _tmp26_ | SKK_MODIFIER_TYPE_LSHIFT_MASK);
#line 671 "key-event.c"
									} else {
										gchar** _tmp27_;
										gint _tmp27__length1;
										const gchar* _tmp28_;
#line 125 "key-event.vala"
										_tmp27_ = strv;
#line 125 "key-event.vala"
										_tmp27__length1 = strv_length1;
#line 125 "key-event.vala"
										_tmp28_ = _tmp27_[index];
#line 125 "key-event.vala"
										if (g_strcmp0 (_tmp28_, "rshift") == 0) {
#line 684 "key-event.c"
											SkkModifierType _tmp29_;
#line 126 "key-event.vala"
											_tmp29_ = self->priv->_modifiers;
#line 126 "key-event.vala"
											skk_key_event_set_modifiers (self, _tmp29_ | SKK_MODIFIER_TYPE_RSHIFT_MASK);
#line 690 "key-event.c"
										} else {
											gchar** _tmp30_;
											gint _tmp30__length1;
											const gchar* _tmp31_;
#line 127 "key-event.vala"
											_tmp30_ = strv;
#line 127 "key-event.vala"
											_tmp30__length1 = strv_length1;
#line 127 "key-event.vala"
											_tmp31_ = _tmp30_[index];
#line 127 "key-event.vala"
											if (g_strcmp0 (_tmp31_, "usleep") == 0) {
#line 703 "key-event.c"
												SkkModifierType _tmp32_;
#line 128 "key-event.vala"
												_tmp32_ = self->priv->_modifiers;
#line 128 "key-event.vala"
												skk_key_event_set_modifiers (self, _tmp32_ | SKK_MODIFIER_TYPE_USLEEP_MASK);
#line 709 "key-event.c"
											} else {
												gchar** _tmp33_;
												gint _tmp33__length1;
												const gchar* _tmp34_;
#line 129 "key-event.vala"
												_tmp33_ = strv;
#line 129 "key-event.vala"
												_tmp33__length1 = strv_length1;
#line 129 "key-event.vala"
												_tmp34_ = _tmp33_[index];
#line 129 "key-event.vala"
												if (g_strcmp0 (_tmp34_, "release") == 0) {
#line 722 "key-event.c"
													SkkModifierType _tmp35_;
#line 130 "key-event.vala"
													_tmp35_ = self->priv->_modifiers;
#line 130 "key-event.vala"
													skk_key_event_set_modifiers (self, _tmp35_ | SKK_MODIFIER_TYPE_RELEASE_MASK);
#line 728 "key-event.c"
												} else {
													gchar** _tmp36_;
													gint _tmp36__length1;
													const gchar* _tmp37_;
													GError* _tmp38_;
#line 132 "key-event.vala"
													_tmp36_ = strv;
#line 132 "key-event.vala"
													_tmp36__length1 = strv_length1;
#line 132 "key-event.vala"
													_tmp37_ = _tmp36_[index];
#line 132 "key-event.vala"
													_tmp38_ = g_error_new (SKK_KEY_EVENT_FORMAT_ERROR, SKK_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED, "unknown modifier %s", _tmp37_);
#line 132 "key-event.vala"
													_inner_error0_ = _tmp38_;
#line 132 "key-event.vala"
													if (_inner_error0_->domain == SKK_KEY_EVENT_FORMAT_ERROR) {
#line 132 "key-event.vala"
														g_propagate_error (error, _inner_error0_);
#line 132 "key-event.vala"
														strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 132 "key-event.vala"
														_g_object_unref0 (self);
#line 132 "key-event.vala"
														return NULL;
#line 754 "key-event.c"
													} else {
#line 132 "key-event.vala"
														strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 132 "key-event.vala"
														g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 132 "key-event.vala"
														g_clear_error (&_inner_error0_);
#line 132 "key-event.vala"
														return NULL;
#line 764 "key-event.c"
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
#line 136 "key-event.vala"
		_tmp39_ = strv;
#line 136 "key-event.vala"
		_tmp39__length1 = strv_length1;
#line 136 "key-event.vala"
		_tmp40_ = _tmp39_[index];
#line 136 "key-event.vala"
		skk_key_event_set_name (self, _tmp40_);
#line 137 "key-event.vala"
		_tmp42_ = self->priv->_name;
#line 137 "key-event.vala"
		if (g_utf8_strlen (_tmp42_, (gssize) -1) == 1) {
#line 789 "key-event.c"
			const gchar* _tmp43_;
#line 137 "key-event.vala"
			_tmp43_ = self->priv->_name;
#line 137 "key-event.vala"
			_tmp41_ = string_get_char (_tmp43_, (glong) 0);
#line 795 "key-event.c"
		} else {
#line 137 "key-event.vala"
			_tmp41_ = (gunichar) '\0';
#line 799 "key-event.c"
		}
#line 137 "key-event.vala"
		skk_key_event_set_code (self, _tmp41_);
#line 109 "key-event.vala"
		strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 805 "key-event.c"
	} else {
		gint index = 0;
#line 140 "key-event.vala"
		index = string_last_index_of (key, "-", 0);
#line 141 "key-event.vala"
		if (index > 0) {
#line 812 "key-event.c"
			gchar** mods = NULL;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gchar** _tmp46_;
			gchar** _tmp47_;
			gchar** _tmp48_;
			gint _tmp48__length1;
			gint mods_length1;
			gint _mods_size_;
			gchar** _tmp49_;
			gint _tmp49__length1;
			gchar* _tmp59_;
			gchar* _tmp60_;
			gunichar _tmp61_ = 0U;
			const gchar* _tmp62_;
#line 143 "key-event.vala"
			_tmp44_ = string_substring (key, (glong) 0, (glong) index);
#line 143 "key-event.vala"
			_tmp45_ = _tmp44_;
#line 143 "key-event.vala"
			_tmp47_ = _tmp46_ = g_strsplit (_tmp45_, "-", 0);
#line 143 "key-event.vala"
			_tmp48_ = _tmp47_;
#line 143 "key-event.vala"
			_tmp48__length1 = _vala_array_length (_tmp46_);
#line 143 "key-event.vala"
			_g_free0 (_tmp45_);
#line 143 "key-event.vala"
			mods = _tmp48_;
#line 143 "key-event.vala"
			mods_length1 = _tmp48__length1;
#line 143 "key-event.vala"
			_mods_size_ = mods_length1;
#line 144 "key-event.vala"
			_tmp49_ = mods;
#line 144 "key-event.vala"
			_tmp49__length1 = mods_length1;
#line 850 "key-event.c"
			{
				gchar** mod_collection = NULL;
				gint mod_collection_length1 = 0;
				gint _mod_collection_size_ = 0;
				gint mod_it = 0;
#line 144 "key-event.vala"
				mod_collection = _tmp49_;
#line 144 "key-event.vala"
				mod_collection_length1 = _tmp49__length1;
#line 144 "key-event.vala"
				for (mod_it = 0; mod_it < mod_collection_length1; mod_it = mod_it + 1) {
#line 862 "key-event.c"
					gchar* _tmp50_;
					gchar* mod = NULL;
#line 144 "key-event.vala"
					_tmp50_ = g_strdup (mod_collection[mod_it]);
#line 144 "key-event.vala"
					mod = _tmp50_;
#line 869 "key-event.c"
					{
						const gchar* _tmp51_;
#line 145 "key-event.vala"
						_tmp51_ = mod;
#line 145 "key-event.vala"
						if (g_strcmp0 (_tmp51_, "C") == 0) {
#line 876 "key-event.c"
							SkkModifierType _tmp52_;
#line 146 "key-event.vala"
							_tmp52_ = self->priv->_modifiers;
#line 146 "key-event.vala"
							skk_key_event_set_modifiers (self, _tmp52_ | SKK_MODIFIER_TYPE_CONTROL_MASK);
#line 882 "key-event.c"
						} else {
							const gchar* _tmp53_;
#line 147 "key-event.vala"
							_tmp53_ = mod;
#line 147 "key-event.vala"
							if (g_strcmp0 (_tmp53_, "A") == 0) {
#line 889 "key-event.c"
								SkkModifierType _tmp54_;
#line 148 "key-event.vala"
								_tmp54_ = self->priv->_modifiers;
#line 148 "key-event.vala"
								skk_key_event_set_modifiers (self, _tmp54_ | SKK_MODIFIER_TYPE_MOD1_MASK);
#line 895 "key-event.c"
							} else {
								const gchar* _tmp55_;
#line 149 "key-event.vala"
								_tmp55_ = mod;
#line 149 "key-event.vala"
								if (g_strcmp0 (_tmp55_, "M") == 0) {
#line 902 "key-event.c"
									SkkModifierType _tmp56_;
#line 150 "key-event.vala"
									_tmp56_ = self->priv->_modifiers;
#line 150 "key-event.vala"
									skk_key_event_set_modifiers (self, _tmp56_ | SKK_MODIFIER_TYPE_META_MASK);
#line 908 "key-event.c"
								} else {
									const gchar* _tmp57_;
#line 151 "key-event.vala"
									_tmp57_ = mod;
#line 151 "key-event.vala"
									if (g_strcmp0 (_tmp57_, "G") == 0) {
#line 915 "key-event.c"
										SkkModifierType _tmp58_;
#line 152 "key-event.vala"
										_tmp58_ = self->priv->_modifiers;
#line 152 "key-event.vala"
										skk_key_event_set_modifiers (self, _tmp58_ | SKK_MODIFIER_TYPE_MOD5_MASK);
#line 921 "key-event.c"
									}
								}
							}
						}
#line 144 "key-event.vala"
						_g_free0 (mod);
#line 928 "key-event.c"
					}
				}
			}
#line 155 "key-event.vala"
			_tmp59_ = string_substring (key, (glong) (index + 1), (glong) -1);
#line 155 "key-event.vala"
			_tmp60_ = _tmp59_;
#line 155 "key-event.vala"
			skk_key_event_set_name (self, _tmp60_);
#line 155 "key-event.vala"
			_g_free0 (_tmp60_);
#line 156 "key-event.vala"
			_tmp62_ = self->priv->_name;
#line 156 "key-event.vala"
			if (g_utf8_strlen (_tmp62_, (gssize) -1) == 1) {
#line 944 "key-event.c"
				const gchar* _tmp63_;
#line 156 "key-event.vala"
				_tmp63_ = self->priv->_name;
#line 156 "key-event.vala"
				_tmp61_ = string_get_char (_tmp63_, (glong) 0);
#line 950 "key-event.c"
			} else {
#line 156 "key-event.vala"
				_tmp61_ = (gunichar) '\0';
#line 954 "key-event.c"
			}
#line 156 "key-event.vala"
			skk_key_event_set_code (self, _tmp61_);
#line 141 "key-event.vala"
			mods = (_vala_array_free (mods, mods_length1, (GDestroyNotify) g_free), NULL);
#line 960 "key-event.c"
		} else {
			gunichar _tmp64_ = 0U;
			const gchar* _tmp65_;
#line 158 "key-event.vala"
			skk_key_event_set_modifiers (self, SKK_MODIFIER_TYPE_NONE);
#line 159 "key-event.vala"
			skk_key_event_set_name (self, key);
#line 160 "key-event.vala"
			_tmp65_ = self->priv->_name;
#line 160 "key-event.vala"
			if (g_utf8_strlen (_tmp65_, (gssize) -1) == 1) {
#line 972 "key-event.c"
				const gchar* _tmp66_;
#line 160 "key-event.vala"
				_tmp66_ = self->priv->_name;
#line 160 "key-event.vala"
				_tmp64_ = string_get_char (_tmp66_, (glong) 0);
#line 978 "key-event.c"
			} else {
#line 160 "key-event.vala"
				_tmp64_ = (gunichar) '\0';
#line 982 "key-event.c"
			}
#line 160 "key-event.vala"
			skk_key_event_set_code (self, _tmp64_);
#line 986 "key-event.c"
		}
	}
#line 108 "key-event.vala"
	return self;
#line 991 "key-event.c"
}

SkkKeyEvent*
skk_key_event_new_from_string (const gchar* key,
                               GError** error)
{
#line 108 "key-event.vala"
	return skk_key_event_construct_from_string (SKK_TYPE_KEY_EVENT, key, error);
#line 1000 "key-event.c"
}

/**
         * Convert the KeyEvent to string.
         *
         * @return a string representing the KeyEvent
         */
static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1122 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1122 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1123 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1124 "glib-2.0.vapi"
	result = str;
#line 1124 "glib-2.0.vapi"
	return result;
#line 1024 "key-event.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 1038 "key-event.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 1042 "key-event.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 1048 "key-event.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 1053 "key-event.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 1059 "key-event.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 1063 "key-event.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 1067 "key-event.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 1071 "key-event.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1075 "key-event.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1079 "key-event.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 1094 "key-event.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 1103 "key-event.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1110 "key-event.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1116 "key-event.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 1124 "key-event.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1128 "key-event.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1134 "key-event.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1139 "key-event.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1145 "key-event.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1149 "key-event.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1153 "key-event.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 1159 "key-event.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1165 "key-event.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1177 "key-event.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1181 "key-event.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1185 "key-event.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 1190 "key-event.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 1198 "key-event.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 1216 "key-event.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1222 "key-event.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1226 "key-event.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1234 "key-event.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 1243 "key-event.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1252 "key-event.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1258 "key-event.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 1266 "key-event.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1278 "key-event.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1284 "key-event.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1288 "key-event.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1296 "key-event.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 1307 "key-event.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 1316 "key-event.c"
	}
}

gchar*
skk_key_event_to_string (SkkKeyEvent* self)
{
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* _base = NULL;
	gchar* _tmp6_;
	SkkModifierType _tmp7_;
	gchar* result;
#line 170 "key-event.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 171 "key-event.vala"
	_tmp1_ = self->priv->_name;
#line 171 "key-event.vala"
	if (_tmp1_ != NULL) {
#line 1335 "key-event.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 171 "key-event.vala"
		_tmp2_ = self->priv->_name;
#line 171 "key-event.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 171 "key-event.vala"
		_g_free0 (_tmp0_);
#line 171 "key-event.vala"
		_tmp0_ = _tmp3_;
#line 1346 "key-event.c"
	} else {
		gunichar _tmp4_;
		gchar* _tmp5_;
#line 171 "key-event.vala"
		_tmp4_ = self->priv->_code;
#line 171 "key-event.vala"
		_tmp5_ = g_unichar_to_string (_tmp4_);
#line 171 "key-event.vala"
		_g_free0 (_tmp0_);
#line 171 "key-event.vala"
		_tmp0_ = _tmp5_;
#line 1358 "key-event.c"
	}
#line 171 "key-event.vala"
	_tmp6_ = g_strdup (_tmp0_);
#line 171 "key-event.vala"
	_base = _tmp6_;
#line 172 "key-event.vala"
	_tmp7_ = self->priv->_modifiers;
#line 172 "key-event.vala"
	if (_tmp7_ != 0) {
#line 1368 "key-event.c"
		GeeArrayList* elements = NULL;
		GeeArrayList* _tmp8_;
		SkkModifierType _tmp9_;
		SkkModifierType _tmp11_;
		SkkModifierType _tmp13_;
		SkkModifierType _tmp15_;
		SkkModifierType _tmp17_;
		SkkModifierType _tmp19_;
		SkkModifierType _tmp21_;
		SkkModifierType _tmp23_;
		SkkModifierType _tmp25_;
		GeeArrayList* _tmp27_;
		const gchar* _tmp28_;
		GeeArrayList* _tmp29_;
		gchar** array = NULL;
		GeeArrayList* _tmp30_;
		gint _tmp31_ = 0;
		gpointer* _tmp32_;
		gint array_length1;
		gint _array_size_;
		gint old_length = 0;
		gchar** _tmp33_;
		gint _tmp33__length1;
		gchar* key_string = NULL;
		gchar** _tmp34_;
		gint _tmp34__length1;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
#line 173 "key-event.vala"
		_tmp8_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 173 "key-event.vala"
		elements = _tmp8_;
#line 174 "key-event.vala"
		_tmp9_ = self->priv->_modifiers;
#line 174 "key-event.vala"
		if ((_tmp9_ & SKK_MODIFIER_TYPE_CONTROL_MASK) != 0) {
#line 1409 "key-event.c"
			GeeArrayList* _tmp10_;
#line 175 "key-event.vala"
			_tmp10_ = elements;
#line 175 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, "control");
#line 1415 "key-event.c"
		}
#line 177 "key-event.vala"
		_tmp11_ = self->priv->_modifiers;
#line 177 "key-event.vala"
		if ((_tmp11_ & SKK_MODIFIER_TYPE_META_MASK) != 0) {
#line 1421 "key-event.c"
			GeeArrayList* _tmp12_;
#line 178 "key-event.vala"
			_tmp12_ = elements;
#line 178 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, "meta");
#line 1427 "key-event.c"
		}
#line 180 "key-event.vala"
		_tmp13_ = self->priv->_modifiers;
#line 180 "key-event.vala"
		if ((_tmp13_ & SKK_MODIFIER_TYPE_HYPER_MASK) != 0) {
#line 1433 "key-event.c"
			GeeArrayList* _tmp14_;
#line 181 "key-event.vala"
			_tmp14_ = elements;
#line 181 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, "hyper");
#line 1439 "key-event.c"
		}
#line 183 "key-event.vala"
		_tmp15_ = self->priv->_modifiers;
#line 183 "key-event.vala"
		if ((_tmp15_ & SKK_MODIFIER_TYPE_SUPER_MASK) != 0) {
#line 1445 "key-event.c"
			GeeArrayList* _tmp16_;
#line 184 "key-event.vala"
			_tmp16_ = elements;
#line 184 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, "super");
#line 1451 "key-event.c"
		}
#line 186 "key-event.vala"
		_tmp17_ = self->priv->_modifiers;
#line 186 "key-event.vala"
		if ((_tmp17_ & SKK_MODIFIER_TYPE_MOD1_MASK) != 0) {
#line 1457 "key-event.c"
			GeeArrayList* _tmp18_;
#line 187 "key-event.vala"
			_tmp18_ = elements;
#line 187 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, "alt");
#line 1463 "key-event.c"
		}
#line 189 "key-event.vala"
		_tmp19_ = self->priv->_modifiers;
#line 189 "key-event.vala"
		if ((_tmp19_ & SKK_MODIFIER_TYPE_LSHIFT_MASK) != 0) {
#line 1469 "key-event.c"
			GeeArrayList* _tmp20_;
#line 190 "key-event.vala"
			_tmp20_ = elements;
#line 190 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, "lshift");
#line 1475 "key-event.c"
		}
#line 192 "key-event.vala"
		_tmp21_ = self->priv->_modifiers;
#line 192 "key-event.vala"
		if ((_tmp21_ & SKK_MODIFIER_TYPE_RSHIFT_MASK) != 0) {
#line 1481 "key-event.c"
			GeeArrayList* _tmp22_;
#line 193 "key-event.vala"
			_tmp22_ = elements;
#line 193 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, "rshift");
#line 1487 "key-event.c"
		}
#line 195 "key-event.vala"
		_tmp23_ = self->priv->_modifiers;
#line 195 "key-event.vala"
		if ((_tmp23_ & SKK_MODIFIER_TYPE_USLEEP_MASK) != 0) {
#line 1493 "key-event.c"
			GeeArrayList* _tmp24_;
#line 196 "key-event.vala"
			_tmp24_ = elements;
#line 196 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, "usleep");
#line 1499 "key-event.c"
		}
#line 198 "key-event.vala"
		_tmp25_ = self->priv->_modifiers;
#line 198 "key-event.vala"
		if ((_tmp25_ & SKK_MODIFIER_TYPE_RELEASE_MASK) != 0) {
#line 1505 "key-event.c"
			GeeArrayList* _tmp26_;
#line 199 "key-event.vala"
			_tmp26_ = elements;
#line 199 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, "release");
#line 1511 "key-event.c"
		}
#line 201 "key-event.vala"
		_tmp27_ = elements;
#line 201 "key-event.vala"
		_tmp28_ = _base;
#line 201 "key-event.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp28_);
#line 202 "key-event.vala"
		_tmp29_ = elements;
#line 202 "key-event.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, NULL);
#line 205 "key-event.vala"
		_tmp30_ = elements;
#line 205 "key-event.vala"
		_tmp32_ = gee_collection_to_array ((GeeCollection*) _tmp30_, &_tmp31_);
#line 205 "key-event.vala"
		array = _tmp32_;
#line 205 "key-event.vala"
		array_length1 = _tmp31_;
#line 205 "key-event.vala"
		_array_size_ = array_length1;
#line 208 "key-event.vala"
		_tmp33_ = array;
#line 208 "key-event.vala"
		_tmp33__length1 = array_length1;
#line 208 "key-event.vala"
		old_length = _tmp33__length1;
#line 209 "key-event.vala"
		array_length1 = -1;
#line 210 "key-event.vala"
		_tmp34_ = array;
#line 210 "key-event.vala"
		_tmp34__length1 = array_length1;
#line 210 "key-event.vala"
		_tmp35_ = _vala_g_strjoinv (" ", _tmp34_, (gint) _tmp34__length1);
#line 210 "key-event.vala"
		_tmp36_ = _tmp35_;
#line 210 "key-event.vala"
		_tmp37_ = g_strconcat ("(", _tmp36_, NULL);
#line 210 "key-event.vala"
		_tmp38_ = _tmp37_;
#line 210 "key-event.vala"
		_tmp39_ = g_strconcat (_tmp38_, ")", NULL);
#line 210 "key-event.vala"
		_tmp40_ = _tmp39_;
#line 210 "key-event.vala"
		_g_free0 (_tmp38_);
#line 210 "key-event.vala"
		_g_free0 (_tmp36_);
#line 210 "key-event.vala"
		key_string = _tmp40_;
#line 211 "key-event.vala"
		array_length1 = old_length;
#line 212 "key-event.vala"
		result = key_string;
#line 212 "key-event.vala"
		array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_free), NULL);
#line 212 "key-event.vala"
		_g_object_unref0 (elements);
#line 212 "key-event.vala"
		_g_free0 (_base);
#line 212 "key-event.vala"
		_g_free0 (_tmp0_);
#line 212 "key-event.vala"
		return result;
#line 1577 "key-event.c"
	} else {
#line 214 "key-event.vala"
		result = _base;
#line 214 "key-event.vala"
		_g_free0 (_tmp0_);
#line 214 "key-event.vala"
		return result;
#line 1585 "key-event.c"
	}
}

/**
         * Create a key event from an X keysym and modifiers.
         *
         * @param keyval an X keysym
         * @param modifiers modifier mask
         *
         * @return a new KeyEvent
         */
SkkKeyEvent*
skk_key_event_construct_from_x_keysym (GType object_type,
                                       guint keyval,
                                       SkkModifierType modifiers,
                                       GError** error)
{
	SkkKeyEvent * self = NULL;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 257 "key-event.vala"
	self = (SkkKeyEvent*) g_object_new (object_type, NULL);
#line 1611 "key-event.c"
	{
		SkkKeyEventNameKeyvalEntry* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
#line 259 "key-event.vala"
		entry_collection = SKK_KEY_EVENT_NAME_KEYVALS;
#line 259 "key-event.vala"
		entry_collection_length1 = G_N_ELEMENTS (SKK_KEY_EVENT_NAME_KEYVALS);
#line 259 "key-event.vala"
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
#line 1623 "key-event.c"
			SkkKeyEventNameKeyvalEntry entry = {0};
#line 259 "key-event.vala"
			entry = entry_collection[entry_it];
#line 1627 "key-event.c"
			{
				SkkKeyEventNameKeyvalEntry _tmp0_;
#line 260 "key-event.vala"
				_tmp0_ = entry;
#line 260 "key-event.vala"
				if (_tmp0_.key == keyval) {
#line 1634 "key-event.c"
					SkkKeyEventNameKeyvalEntry _tmp1_;
					const gchar* _tmp2_;
#line 261 "key-event.vala"
					_tmp1_ = entry;
#line 261 "key-event.vala"
					_tmp2_ = _tmp1_.value;
#line 261 "key-event.vala"
					skk_key_event_set_name (self, _tmp2_);
#line 262 "key-event.vala"
					break;
#line 1645 "key-event.c"
				}
			}
		}
	}
	{
		SkkKeyEventCodeKeyvalEntry* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
#line 265 "key-event.vala"
		entry_collection = SKK_KEY_EVENT_CODE_KEYVALS;
#line 265 "key-event.vala"
		entry_collection_length1 = G_N_ELEMENTS (SKK_KEY_EVENT_CODE_KEYVALS);
#line 265 "key-event.vala"
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
#line 1661 "key-event.c"
			SkkKeyEventCodeKeyvalEntry entry = {0};
#line 265 "key-event.vala"
			entry = entry_collection[entry_it];
#line 1665 "key-event.c"
			{
				SkkKeyEventCodeKeyvalEntry _tmp3_;
#line 266 "key-event.vala"
				_tmp3_ = entry;
#line 266 "key-event.vala"
				if (_tmp3_.key == keyval) {
#line 1672 "key-event.c"
					SkkKeyEventCodeKeyvalEntry _tmp4_;
#line 267 "key-event.vala"
					_tmp4_ = entry;
#line 267 "key-event.vala"
					skk_key_event_set_code (self, _tmp4_.value);
#line 268 "key-event.vala"
					break;
#line 1680 "key-event.c"
				}
			}
		}
	}
#line 271 "key-event.vala"
	_tmp6_ = self->priv->_name;
#line 271 "key-event.vala"
	if (_tmp6_ == NULL) {
#line 271 "key-event.vala"
		_tmp5_ = TRUE;
#line 1691 "key-event.c"
	} else {
		gunichar _tmp7_;
#line 271 "key-event.vala"
		_tmp7_ = self->priv->_code;
#line 271 "key-event.vala"
		_tmp5_ = _tmp7_ == ((gunichar) '\0');
#line 1698 "key-event.c"
	}
#line 271 "key-event.vala"
	_vala_assert (_tmp5_, "name == null || code == '\\0'");
#line 272 "key-event.vala"
	_tmp9_ = self->priv->_name;
#line 272 "key-event.vala"
	if (_tmp9_ == NULL) {
#line 1706 "key-event.c"
		gunichar _tmp10_;
#line 272 "key-event.vala"
		_tmp10_ = self->priv->_code;
#line 272 "key-event.vala"
		_tmp8_ = _tmp10_ == ((gunichar) '\0');
#line 1712 "key-event.c"
	} else {
#line 272 "key-event.vala"
		_tmp8_ = FALSE;
#line 1716 "key-event.c"
	}
#line 272 "key-event.vala"
	if (_tmp8_) {
#line 1720 "key-event.c"
		gboolean _tmp11_ = FALSE;
#line 273 "key-event.vala"
		if (((guint) 0x20) <= keyval) {
#line 273 "key-event.vala"
			_tmp11_ = keyval < ((guint) 0x7F);
#line 1726 "key-event.c"
		} else {
#line 273 "key-event.vala"
			_tmp11_ = FALSE;
#line 1730 "key-event.c"
		}
#line 273 "key-event.vala"
		if (_tmp11_) {
#line 274 "key-event.vala"
			skk_key_event_set_code (self, (gunichar) keyval);
#line 1736 "key-event.c"
		} else {
			GError* _tmp12_;
#line 276 "key-event.vala"
			_tmp12_ = g_error_new (SKK_KEY_EVENT_FORMAT_ERROR, SKK_KEY_EVENT_FORMAT_ERROR_KEYSYM_NOT_FOUND, "unknown keysym %u", keyval);
#line 276 "key-event.vala"
			_inner_error0_ = _tmp12_;
#line 276 "key-event.vala"
			if (_inner_error0_->domain == SKK_KEY_EVENT_FORMAT_ERROR) {
#line 276 "key-event.vala"
				g_propagate_error (error, _inner_error0_);
#line 276 "key-event.vala"
				_g_object_unref0 (self);
#line 276 "key-event.vala"
				return NULL;
#line 1751 "key-event.c"
			} else {
#line 276 "key-event.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 276 "key-event.vala"
				g_clear_error (&_inner_error0_);
#line 276 "key-event.vala"
				return NULL;
#line 1759 "key-event.c"
			}
		}
	}
#line 280 "key-event.vala"
	skk_key_event_set_modifiers (self, modifiers);
#line 257 "key-event.vala"
	return self;
#line 1767 "key-event.c"
}

SkkKeyEvent*
skk_key_event_new_from_x_keysym (guint keyval,
                                 SkkModifierType modifiers,
                                 GError** error)
{
#line 257 "key-event.vala"
	return skk_key_event_construct_from_x_keysym (SKK_TYPE_KEY_EVENT, keyval, modifiers, error);
#line 1777 "key-event.c"
}

/**
         * Compare two key events ignoring modifiers.
         *
         * @param key a KeyEvent
         *
         * @return `true` if those base components are equal, `false` otherwise
         */
gboolean
skk_key_event_base_equal (SkkKeyEvent* self,
                          SkkKeyEvent* key)
{
	gboolean _tmp0_ = FALSE;
	gunichar _tmp1_;
	gunichar _tmp2_;
	gboolean result;
#line 290 "key-event.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 290 "key-event.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 291 "key-event.vala"
	_tmp1_ = self->priv->_code;
#line 291 "key-event.vala"
	_tmp2_ = key->priv->_code;
#line 291 "key-event.vala"
	if (_tmp1_ == _tmp2_) {
#line 1805 "key-event.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 291 "key-event.vala"
		_tmp3_ = self->priv->_name;
#line 291 "key-event.vala"
		_tmp4_ = key->priv->_name;
#line 291 "key-event.vala"
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
#line 1814 "key-event.c"
	} else {
#line 291 "key-event.vala"
		_tmp0_ = FALSE;
#line 1818 "key-event.c"
	}
#line 291 "key-event.vala"
	result = _tmp0_;
#line 291 "key-event.vala"
	return result;
#line 1824 "key-event.c"
}

const gchar*
skk_key_event_get_name (SkkKeyEvent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 61 "key-event.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "key-event.vala"
	_tmp0_ = self->priv->_name;
#line 61 "key-event.vala"
	result = _tmp0_;
#line 61 "key-event.vala"
	return result;
#line 1840 "key-event.c"
}

static void
skk_key_event_set_name (SkkKeyEvent* self,
                        const gchar* value)
{
	gchar* old_value;
#line 61 "key-event.vala"
	g_return_if_fail (self != NULL);
#line 61 "key-event.vala"
	old_value = skk_key_event_get_name (self);
#line 61 "key-event.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1854 "key-event.c"
		gchar* _tmp0_;
#line 61 "key-event.vala"
		_tmp0_ = g_strdup (value);
#line 61 "key-event.vala"
		_g_free0 (self->priv->_name);
#line 61 "key-event.vala"
		self->priv->_name = _tmp0_;
#line 61 "key-event.vala"
		g_object_notify_by_pspec ((GObject *) self, skk_key_event_properties[SKK_KEY_EVENT_NAME_PROPERTY]);
#line 1864 "key-event.c"
	}
}

gunichar
skk_key_event_get_code (SkkKeyEvent* self)
{
	gunichar result;
#line 68 "key-event.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 68 "key-event.vala"
	result = self->priv->_code;
#line 68 "key-event.vala"
	return result;
#line 1878 "key-event.c"
}

static void
skk_key_event_set_code (SkkKeyEvent* self,
                        gunichar value)
{
	gunichar old_value;
#line 68 "key-event.vala"
	g_return_if_fail (self != NULL);
#line 68 "key-event.vala"
	old_value = skk_key_event_get_code (self);
#line 68 "key-event.vala"
	if (old_value != value) {
#line 68 "key-event.vala"
		self->priv->_code = value;
#line 68 "key-event.vala"
		g_object_notify_by_pspec ((GObject *) self, skk_key_event_properties[SKK_KEY_EVENT_CODE_PROPERTY]);
#line 1896 "key-event.c"
	}
}

SkkModifierType
skk_key_event_get_modifiers (SkkKeyEvent* self)
{
	SkkModifierType result;
#line 73 "key-event.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 73 "key-event.vala"
	result = self->priv->_modifiers;
#line 73 "key-event.vala"
	return result;
#line 1910 "key-event.c"
}

void
skk_key_event_set_modifiers (SkkKeyEvent* self,
                             SkkModifierType value)
{
	SkkModifierType old_value;
#line 73 "key-event.vala"
	g_return_if_fail (self != NULL);
#line 73 "key-event.vala"
	old_value = skk_key_event_get_modifiers (self);
#line 73 "key-event.vala"
	if (old_value != value) {
#line 73 "key-event.vala"
		self->priv->_modifiers = value;
#line 73 "key-event.vala"
		g_object_notify_by_pspec ((GObject *) self, skk_key_event_properties[SKK_KEY_EVENT_MODIFIERS_PROPERTY]);
#line 1928 "key-event.c"
	}
}

static SkkKeyEventCodeKeyvalEntry*
skk_key_event_code_keyval_entry_dup (const SkkKeyEventCodeKeyvalEntry* self)
{
	SkkKeyEventCodeKeyvalEntry* dup;
#line 220 "key-event.vala"
	dup = g_new0 (SkkKeyEventCodeKeyvalEntry, 1);
#line 220 "key-event.vala"
	memcpy (dup, self, sizeof (SkkKeyEventCodeKeyvalEntry));
#line 220 "key-event.vala"
	return dup;
#line 1942 "key-event.c"
}

static void
skk_key_event_code_keyval_entry_free (SkkKeyEventCodeKeyvalEntry* self)
{
#line 220 "key-event.vala"
	g_free (self);
#line 1950 "key-event.c"
}

static GType
skk_key_event_code_keyval_entry_get_type_once (void)
{
	GType skk_key_event_code_keyval_entry_type_id;
	skk_key_event_code_keyval_entry_type_id = g_boxed_type_register_static ("SkkKeyEventCodeKeyvalEntry", (GBoxedCopyFunc) skk_key_event_code_keyval_entry_dup, (GBoxedFreeFunc) skk_key_event_code_keyval_entry_free);
	return skk_key_event_code_keyval_entry_type_id;
}

static GType
skk_key_event_code_keyval_entry_get_type (void)
{
	static volatile gsize skk_key_event_code_keyval_entry_type_id__once = 0;
	if (g_once_init_enter (&skk_key_event_code_keyval_entry_type_id__once)) {
		GType skk_key_event_code_keyval_entry_type_id;
		skk_key_event_code_keyval_entry_type_id = skk_key_event_code_keyval_entry_get_type_once ();
		g_once_init_leave (&skk_key_event_code_keyval_entry_type_id__once, skk_key_event_code_keyval_entry_type_id);
	}
	return skk_key_event_code_keyval_entry_type_id__once;
}

static void
skk_key_event_name_keyval_entry_copy (const SkkKeyEventNameKeyvalEntry* self,
                                      SkkKeyEventNameKeyvalEntry* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 231 "key-event.vala"
	(*dest).key = (*self).key;
#line 231 "key-event.vala"
	_tmp0_ = (*self).value;
#line 231 "key-event.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 231 "key-event.vala"
	_g_free0 ((*dest).value);
#line 231 "key-event.vala"
	(*dest).value = _tmp1_;
#line 1989 "key-event.c"
}

static void
skk_key_event_name_keyval_entry_destroy (SkkKeyEventNameKeyvalEntry* self)
{
#line 233 "key-event.vala"
	_g_free0 ((*self).value);
#line 1997 "key-event.c"
}

static SkkKeyEventNameKeyvalEntry*
skk_key_event_name_keyval_entry_dup (const SkkKeyEventNameKeyvalEntry* self)
{
	SkkKeyEventNameKeyvalEntry* dup;
#line 231 "key-event.vala"
	dup = g_new0 (SkkKeyEventNameKeyvalEntry, 1);
#line 231 "key-event.vala"
	skk_key_event_name_keyval_entry_copy (self, dup);
#line 231 "key-event.vala"
	return dup;
#line 2010 "key-event.c"
}

static void
skk_key_event_name_keyval_entry_free (SkkKeyEventNameKeyvalEntry* self)
{
#line 231 "key-event.vala"
	skk_key_event_name_keyval_entry_destroy (self);
#line 231 "key-event.vala"
	g_free (self);
#line 2020 "key-event.c"
}

static GType
skk_key_event_name_keyval_entry_get_type_once (void)
{
	GType skk_key_event_name_keyval_entry_type_id;
	skk_key_event_name_keyval_entry_type_id = g_boxed_type_register_static ("SkkKeyEventNameKeyvalEntry", (GBoxedCopyFunc) skk_key_event_name_keyval_entry_dup, (GBoxedFreeFunc) skk_key_event_name_keyval_entry_free);
	return skk_key_event_name_keyval_entry_type_id;
}

static GType
skk_key_event_name_keyval_entry_get_type (void)
{
	static volatile gsize skk_key_event_name_keyval_entry_type_id__once = 0;
	if (g_once_init_enter (&skk_key_event_name_keyval_entry_type_id__once)) {
		GType skk_key_event_name_keyval_entry_type_id;
		skk_key_event_name_keyval_entry_type_id = skk_key_event_name_keyval_entry_get_type_once ();
		g_once_init_leave (&skk_key_event_name_keyval_entry_type_id__once, skk_key_event_name_keyval_entry_type_id);
	}
	return skk_key_event_name_keyval_entry_type_id__once;
}

static void
skk_key_event_class_init (SkkKeyEventClass * klass,
                          gpointer klass_data)
{
#line 55 "key-event.vala"
	skk_key_event_parent_class = g_type_class_peek_parent (klass);
#line 55 "key-event.vala"
	g_type_class_adjust_private_offset (klass, &SkkKeyEvent_private_offset);
#line 55 "key-event.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_skk_key_event_get_property;
#line 55 "key-event.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_skk_key_event_set_property;
#line 55 "key-event.vala"
	G_OBJECT_CLASS (klass)->finalize = skk_key_event_finalize;
#line 2057 "key-event.c"
	/**
	         * The base name of the KeyEvent.
	         *
	         * This is exclusive to {@link code}.
	         */
#line 55 "key-event.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_KEY_EVENT_NAME_PROPERTY, skk_key_event_properties[SKK_KEY_EVENT_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2065 "key-event.c"
	/**
	         * The base code of the KeyEvent.
	         *
	         * This is exclusive to {@link name}.
	         */
#line 55 "key-event.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_KEY_EVENT_CODE_PROPERTY, skk_key_event_properties[SKK_KEY_EVENT_CODE_PROPERTY] = g_param_spec_uint ("code", "code", "code", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2073 "key-event.c"
	/**
	         * Modifier mask.
	         */
#line 55 "key-event.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_KEY_EVENT_MODIFIERS_PROPERTY, skk_key_event_properties[SKK_KEY_EVENT_MODIFIERS_PROPERTY] = g_param_spec_flags ("modifiers", "modifiers", "modifiers", SKK_TYPE_MODIFIER_TYPE, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2079 "key-event.c"
}

static void
skk_key_event_instance_init (SkkKeyEvent * self,
                             gpointer klass)
{
#line 55 "key-event.vala"
	self->priv = skk_key_event_get_instance_private (self);
#line 2088 "key-event.c"
}

static void
skk_key_event_finalize (GObject * obj)
{
	SkkKeyEvent * self;
#line 55 "key-event.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SKK_TYPE_KEY_EVENT, SkkKeyEvent);
#line 61 "key-event.vala"
	_g_free0 (self->priv->_name);
#line 55 "key-event.vala"
	G_OBJECT_CLASS (skk_key_event_parent_class)->finalize (obj);
#line 2101 "key-event.c"
}

/**
     * Object representing a key event.
     */
static GType
skk_key_event_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SkkKeyEventClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) skk_key_event_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SkkKeyEvent), 0, (GInstanceInitFunc) skk_key_event_instance_init, NULL };
	GType skk_key_event_type_id;
	skk_key_event_type_id = g_type_register_static (G_TYPE_OBJECT, "SkkKeyEvent", &g_define_type_info, 0);
	SkkKeyEvent_private_offset = g_type_add_instance_private (skk_key_event_type_id, sizeof (SkkKeyEventPrivate));
	return skk_key_event_type_id;
}

GType
skk_key_event_get_type (void)
{
	static volatile gsize skk_key_event_type_id__once = 0;
	if (g_once_init_enter (&skk_key_event_type_id__once)) {
		GType skk_key_event_type_id;
		skk_key_event_type_id = skk_key_event_get_type_once ();
		g_once_init_leave (&skk_key_event_type_id__once, skk_key_event_type_id);
	}
	return skk_key_event_type_id__once;
}

static void
_vala_skk_key_event_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	SkkKeyEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SKK_TYPE_KEY_EVENT, SkkKeyEvent);
#line 55 "key-event.vala"
	switch (property_id) {
#line 55 "key-event.vala"
		case SKK_KEY_EVENT_NAME_PROPERTY:
#line 55 "key-event.vala"
		g_value_set_string (value, skk_key_event_get_name (self));
#line 55 "key-event.vala"
		break;
#line 55 "key-event.vala"
		case SKK_KEY_EVENT_CODE_PROPERTY:
#line 55 "key-event.vala"
		g_value_set_uint (value, skk_key_event_get_code (self));
#line 55 "key-event.vala"
		break;
#line 55 "key-event.vala"
		case SKK_KEY_EVENT_MODIFIERS_PROPERTY:
#line 55 "key-event.vala"
		g_value_set_flags (value, skk_key_event_get_modifiers (self));
#line 55 "key-event.vala"
		break;
#line 2157 "key-event.c"
		default:
#line 55 "key-event.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 55 "key-event.vala"
		break;
#line 2163 "key-event.c"
	}
}

static void
_vala_skk_key_event_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	SkkKeyEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SKK_TYPE_KEY_EVENT, SkkKeyEvent);
#line 55 "key-event.vala"
	switch (property_id) {
#line 55 "key-event.vala"
		case SKK_KEY_EVENT_NAME_PROPERTY:
#line 55 "key-event.vala"
		skk_key_event_set_name (self, g_value_get_string (value));
#line 55 "key-event.vala"
		break;
#line 55 "key-event.vala"
		case SKK_KEY_EVENT_CODE_PROPERTY:
#line 55 "key-event.vala"
		skk_key_event_set_code (self, g_value_get_uint (value));
#line 55 "key-event.vala"
		break;
#line 55 "key-event.vala"
		case SKK_KEY_EVENT_MODIFIERS_PROPERTY:
#line 55 "key-event.vala"
		skk_key_event_set_modifiers (self, g_value_get_flags (value));
#line 55 "key-event.vala"
		break;
#line 2195 "key-event.c"
		default:
#line 55 "key-event.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 55 "key-event.vala"
		break;
#line 2201 "key-event.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

