/* skkserv.c generated by valac 0.56.17, the Vala compiler
 * generated from skkserv.vala, do not modify */

/*
 * Copyright (C) 2011-2018 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "libskk/libskk.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define SKK_TYPE_SKK_SERV_ERROR (skk_skk_serv_error_get_type ())

#define SKK_TYPE_ENCODING_CONVERTER (skk_encoding_converter_get_type ())
#define SKK_ENCODING_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverter))
#define SKK_ENCODING_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverterClass))
#define SKK_IS_ENCODING_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SKK_TYPE_ENCODING_CONVERTER))
#define SKK_IS_ENCODING_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SKK_TYPE_ENCODING_CONVERTER))
#define SKK_ENCODING_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverterClass))

typedef struct _SkkEncodingConverter SkkEncodingConverter;
typedef struct _SkkEncodingConverterClass SkkEncodingConverterClass;
enum  {
	SKK_SKK_SERV_0_PROPERTY,
	SKK_SKK_SERV_READ_ONLY_PROPERTY,
	SKK_SKK_SERV_NUM_PROPERTIES
};
static GParamSpec* skk_skk_serv_properties[SKK_SKK_SERV_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

typedef enum  {
	SKK_SKK_SERV_ERROR_NOT_READABLE,
	SKK_SKK_SERV_ERROR_INVALID_RESPONSE
} SkkSkkServError;
#define SKK_SKK_SERV_ERROR skk_skk_serv_error_quark ()

struct _SkkSkkServPrivate {
	GSocketConnection* connection;
	guint8 buffer[4096];
	gchar* host;
	guint16 port;
	SkkEncodingConverter* converter;
};

static gint SkkSkkServ_private_offset;
static gpointer skk_skk_serv_parent_class = NULL;

VALA_EXTERN GQuark skk_skk_serv_error_quark (void);
VALA_EXTERN GType skk_skk_serv_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType skk_encoding_converter_get_type (void) G_GNUC_CONST ;
static void skk_skk_serv_close_connection (SkkSkkServ* self);
static void skk_skk_serv_real_reload (SkkDict* base,
                               GError** error);
static gchar* skk_skk_serv_read_response (SkkSkkServ* self,
                                   GError** error);
static SkkCandidate** skk_skk_serv_real_lookup (SkkDict* base,
                                         const gchar* midasi,
                                         gboolean okuri,
                                         gint* result_length1);
VALA_EXTERN gchar* skk_encoding_converter_encode (SkkEncodingConverter* self,
                                      const gchar* internal_str,
                                      GError** error);
VALA_EXTERN gchar* skk_encoding_converter_decode (SkkEncodingConverter* self,
                                      const gchar* external_str,
                                      GError** error);
static gchar** skk_skk_serv_real_complete (SkkDict* base,
                                    const gchar* midasi,
                                    gint* result_length1);
VALA_EXTERN SkkEncodingConverter* skk_encoding_converter_new (const gchar* encoding,
                                                  GError** error);
VALA_EXTERN SkkEncodingConverter* skk_encoding_converter_construct (GType object_type,
                                                        const gchar* encoding,
                                                        GError** error);
static void skk_skk_serv_finalize (GObject * obj);
static GType skk_skk_serv_get_type_once (void);
static void _vala_skk_skk_serv_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GQuark
skk_skk_serv_error_quark (void)
{
	return g_quark_from_static_string ("skk-skk-serv-error-quark");
}

static GType
skk_skk_serv_error_get_type_once (void)
{
	static const GEnumValue values[] = {{SKK_SKK_SERV_ERROR_NOT_READABLE, "SKK_SKK_SERV_ERROR_NOT_READABLE", "not-readable"}, {SKK_SKK_SERV_ERROR_INVALID_RESPONSE, "SKK_SKK_SERV_ERROR_INVALID_RESPONSE", "invalid-response"}, {0, NULL, NULL}};
	GType skk_skk_serv_error_type_id;
	skk_skk_serv_error_type_id = g_enum_register_static ("SkkSkkServError", values);
	return skk_skk_serv_error_type_id;
}

GType
skk_skk_serv_error_get_type (void)
{
	static volatile gsize skk_skk_serv_error_type_id__once = 0;
	if (g_once_init_enter (&skk_skk_serv_error_type_id__once)) {
		GType skk_skk_serv_error_type_id;
		skk_skk_serv_error_type_id = skk_skk_serv_error_get_type_once ();
		g_once_init_leave (&skk_skk_serv_error_type_id__once, skk_skk_serv_error_type_id);
	}
	return skk_skk_serv_error_type_id__once;
}

static inline gpointer
skk_skk_serv_get_instance_private (SkkSkkServ* self)
{
	return G_STRUCT_MEMBER_P (self, SkkSkkServ_private_offset);
}

static void
skk_skk_serv_close_connection (SkkSkkServ* self)
{
	GSocketConnection* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 33 "skkserv.vala"
	g_return_if_fail (self != NULL);
#line 34 "skkserv.vala"
	_tmp0_ = self->priv->connection;
#line 34 "skkserv.vala"
	if (_tmp0_ != NULL) {
#line 158 "skkserv.c"
		{
			gsize bytes_written = 0UL;
			GSocketConnection* _tmp1_;
			GOutputStream* _tmp2_;
			GOutputStream* _tmp3_;
			gsize _tmp4_ = 0UL;
			GSocketConnection* _tmp5_;
			GOutputStream* _tmp6_;
			GOutputStream* _tmp7_;
			GSocketConnection* _tmp8_;
#line 36 "skkserv.vala"
			self->priv->buffer[0] = (guint8) '0';
#line 38 "skkserv.vala"
			_tmp1_ = self->priv->connection;
#line 38 "skkserv.vala"
			_tmp2_ = g_io_stream_get_output_stream ((GIOStream*) _tmp1_);
#line 38 "skkserv.vala"
			_tmp3_ = _tmp2_;
#line 38 "skkserv.vala"
			g_output_stream_write_all (_tmp3_, self->priv->buffer + 0, (gsize) (1 - 0), &_tmp4_, NULL, &_inner_error0_);
#line 38 "skkserv.vala"
			bytes_written = _tmp4_;
#line 38 "skkserv.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "skkserv.c"
				goto __catch0_g_error;
			}
#line 40 "skkserv.vala"
			_tmp5_ = self->priv->connection;
#line 40 "skkserv.vala"
			_tmp6_ = g_io_stream_get_output_stream ((GIOStream*) _tmp5_);
#line 40 "skkserv.vala"
			_tmp7_ = _tmp6_;
#line 40 "skkserv.vala"
			g_output_stream_flush (_tmp7_, NULL, &_inner_error0_);
#line 40 "skkserv.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "skkserv.c"
				goto __catch0_g_error;
			}
#line 41 "skkserv.vala"
			_tmp8_ = self->priv->connection;
#line 41 "skkserv.vala"
			g_io_stream_close ((GIOStream*) _tmp8_, NULL, &_inner_error0_);
#line 41 "skkserv.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 205 "skkserv.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 35 "skkserv.vala"
			e = _inner_error0_;
#line 35 "skkserv.vala"
			_inner_error0_ = NULL;
#line 43 "skkserv.vala"
			_tmp9_ = e;
#line 43 "skkserv.vala"
			_tmp10_ = _tmp9_->message;
#line 43 "skkserv.vala"
			g_warning ("skkserv.vala:43: can't close skkserv: %s", _tmp10_);
#line 35 "skkserv.vala"
			_g_error_free0 (e);
#line 227 "skkserv.c"
		}
		__finally0:
#line 35 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 35 "skkserv.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 35 "skkserv.vala"
			g_clear_error (&_inner_error0_);
#line 35 "skkserv.vala"
			return;
#line 238 "skkserv.c"
		}
#line 45 "skkserv.vala"
		_g_object_unref0 (self->priv->connection);
#line 45 "skkserv.vala"
		self->priv->connection = NULL;
#line 244 "skkserv.c"
	}
}

/**
         * {@inheritDoc}
         */
static void
skk_skk_serv_real_reload (SkkDict* base,
                          GError** error)
{
	SkkSkkServ * self;
	GError* _inner_error0_ = NULL;
#line 52 "skkserv.vala"
	self = (SkkSkkServ*) base;
#line 53 "skkserv.vala"
	skk_skk_serv_close_connection (self);
#line 261 "skkserv.c"
	{
		GSocketClient* client = NULL;
		GSocketClient* _tmp0_;
		GSocketConnection* _tmp1_ = NULL;
		GSocketClient* _tmp2_;
		const gchar* _tmp3_;
		GSocketConnection* _tmp4_;
		GSocketConnection* _tmp5_;
		gsize bytes_written = 0UL;
		GSocketConnection* _tmp6_;
		GOutputStream* _tmp7_;
		GOutputStream* _tmp8_;
		gsize _tmp9_ = 0UL;
		GSocketConnection* _tmp10_;
		GOutputStream* _tmp11_;
		GOutputStream* _tmp12_;
		gssize len = 0L;
		GSocketConnection* _tmp13_;
		GInputStream* _tmp14_;
		GInputStream* _tmp15_;
#line 55 "skkserv.vala"
		_tmp0_ = g_socket_client_new ();
#line 55 "skkserv.vala"
		client = _tmp0_;
#line 56 "skkserv.vala"
		_tmp2_ = client;
#line 56 "skkserv.vala"
		_tmp3_ = self->priv->host;
#line 56 "skkserv.vala"
		_tmp4_ = g_socket_client_connect_to_host (_tmp2_, _tmp3_, self->priv->port, NULL, &_inner_error0_);
#line 56 "skkserv.vala"
		_tmp1_ = _tmp4_;
#line 56 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "skkserv.vala"
			_g_object_unref0 (client);
#line 298 "skkserv.c"
			goto __catch0_g_error;
		}
#line 56 "skkserv.vala"
		_tmp5_ = _tmp1_;
#line 56 "skkserv.vala"
		_tmp1_ = NULL;
#line 56 "skkserv.vala"
		_g_object_unref0 (self->priv->connection);
#line 56 "skkserv.vala"
		self->priv->connection = _tmp5_;
#line 57 "skkserv.vala"
		self->priv->buffer[0] = (guint8) '2';
#line 59 "skkserv.vala"
		_tmp6_ = self->priv->connection;
#line 59 "skkserv.vala"
		_tmp7_ = g_io_stream_get_output_stream ((GIOStream*) _tmp6_);
#line 59 "skkserv.vala"
		_tmp8_ = _tmp7_;
#line 59 "skkserv.vala"
		g_output_stream_write_all (_tmp8_, self->priv->buffer + 0, (gsize) (1 - 0), &_tmp9_, NULL, &_inner_error0_);
#line 59 "skkserv.vala"
		bytes_written = _tmp9_;
#line 59 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 59 "skkserv.vala"
			_g_object_unref0 (_tmp1_);
#line 59 "skkserv.vala"
			_g_object_unref0 (client);
#line 327 "skkserv.c"
			goto __catch0_g_error;
		}
#line 61 "skkserv.vala"
		_tmp10_ = self->priv->connection;
#line 61 "skkserv.vala"
		_tmp11_ = g_io_stream_get_output_stream ((GIOStream*) _tmp10_);
#line 61 "skkserv.vala"
		_tmp12_ = _tmp11_;
#line 61 "skkserv.vala"
		g_output_stream_flush (_tmp12_, NULL, &_inner_error0_);
#line 61 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 61 "skkserv.vala"
			_g_object_unref0 (_tmp1_);
#line 61 "skkserv.vala"
			_g_object_unref0 (client);
#line 344 "skkserv.c"
			goto __catch0_g_error;
		}
#line 62 "skkserv.vala"
		_tmp13_ = self->priv->connection;
#line 62 "skkserv.vala"
		_tmp14_ = g_io_stream_get_input_stream ((GIOStream*) _tmp13_);
#line 62 "skkserv.vala"
		_tmp15_ = _tmp14_;
#line 62 "skkserv.vala"
		len = g_input_stream_read (_tmp15_, self->priv->buffer, (gsize) 4096, NULL, &_inner_error0_);
#line 62 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 62 "skkserv.vala"
			_g_object_unref0 (_tmp1_);
#line 62 "skkserv.vala"
			_g_object_unref0 (client);
#line 361 "skkserv.c"
			goto __catch0_g_error;
		}
#line 63 "skkserv.vala"
		if (len <= ((gssize) 0)) {
#line 64 "skkserv.vala"
			skk_skk_serv_close_connection (self);
#line 368 "skkserv.c"
		}
#line 54 "skkserv.vala"
		_g_object_unref0 (_tmp1_);
#line 54 "skkserv.vala"
		_g_object_unref0 (client);
#line 374 "skkserv.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 54 "skkserv.vala"
		e = _inner_error0_;
#line 54 "skkserv.vala"
		_inner_error0_ = NULL;
#line 67 "skkserv.vala"
		_tmp16_ = self->priv->host;
#line 67 "skkserv.vala"
		_tmp17_ = e;
#line 67 "skkserv.vala"
		_tmp18_ = _tmp17_->message;
#line 67 "skkserv.vala"
		g_warning ("skkserv.vala:67: can't open skkserv at %s:%u: %s", _tmp16_, (guint) self->priv->port, _tmp18_);
#line 69 "skkserv.vala"
		skk_skk_serv_close_connection (self);
#line 54 "skkserv.vala"
		_g_error_free0 (e);
#line 399 "skkserv.c"
	}
	__finally0:
#line 54 "skkserv.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 54 "skkserv.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 54 "skkserv.vala"
		g_clear_error (&_inner_error0_);
#line 54 "skkserv.vala"
		return;
#line 410 "skkserv.c"
	}
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1204 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1205 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1205 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1207 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1207 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 433 "skkserv.c"
		gchar* _tmp2_;
#line 1208 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1208 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1208 "glib-2.0.vapi"
		return result;
#line 441 "skkserv.c"
	} else {
#line 1210 "glib-2.0.vapi"
		result = -1;
#line 1210 "glib-2.0.vapi"
		return result;
#line 447 "skkserv.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 475 "skkserv.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 481 "skkserv.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 487 "skkserv.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 491 "skkserv.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 499 "skkserv.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 503 "skkserv.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 515 "skkserv.c"
}

static gchar*
skk_skk_serv_read_response (SkkSkkServ* self,
                            GError** error)
{
	GString* builder = NULL;
	GString* _tmp0_;
	gint index = 0;
	GString* _tmp14_;
	const gchar* _tmp15_;
	GString* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 73 "skkserv.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "skkserv.vala"
	_tmp0_ = g_string_new ("");
#line 74 "skkserv.vala"
	builder = _tmp0_;
#line 77 "skkserv.vala"
	while (TRUE) {
#line 540 "skkserv.c"
		GString* _tmp1_;
		const gchar* _tmp2_;
		gssize len = 0L;
		GSocketConnection* _tmp3_;
		GInputStream* _tmp4_;
		GInputStream* _tmp5_;
#line 77 "skkserv.vala"
		_tmp1_ = builder;
#line 77 "skkserv.vala"
		_tmp2_ = _tmp1_->str;
#line 77 "skkserv.vala"
		if (!(string_index_of_char (_tmp2_, (gunichar) '\n', 0) < 0)) {
#line 77 "skkserv.vala"
			break;
#line 555 "skkserv.c"
		}
#line 78 "skkserv.vala"
		_tmp3_ = self->priv->connection;
#line 78 "skkserv.vala"
		_tmp4_ = g_io_stream_get_input_stream ((GIOStream*) _tmp3_);
#line 78 "skkserv.vala"
		_tmp5_ = _tmp4_;
#line 78 "skkserv.vala"
		len = g_input_stream_read (_tmp5_, self->priv->buffer, (gsize) 4096, NULL, &_inner_error0_);
#line 78 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "skkserv.vala"
			if ((_inner_error0_->domain == SKK_SKK_SERV_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 78 "skkserv.vala"
				g_propagate_error (error, _inner_error0_);
#line 78 "skkserv.vala"
				_g_string_free0 (builder);
#line 78 "skkserv.vala"
				return NULL;
#line 575 "skkserv.c"
			} else {
#line 78 "skkserv.vala"
				_g_string_free0 (builder);
#line 78 "skkserv.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 78 "skkserv.vala"
				g_clear_error (&_inner_error0_);
#line 78 "skkserv.vala"
				return NULL;
#line 585 "skkserv.c"
			}
		}
#line 79 "skkserv.vala"
		if (len < ((gssize) 0)) {
#line 590 "skkserv.c"
			GError* _tmp6_;
#line 80 "skkserv.vala"
			_tmp6_ = g_error_new_literal (SKK_SKK_SERV_ERROR, SKK_SKK_SERV_ERROR_NOT_READABLE, "read error");
#line 80 "skkserv.vala"
			_inner_error0_ = _tmp6_;
#line 80 "skkserv.vala"
			if ((_inner_error0_->domain == SKK_SKK_SERV_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 80 "skkserv.vala"
				g_propagate_error (error, _inner_error0_);
#line 80 "skkserv.vala"
				_g_string_free0 (builder);
#line 80 "skkserv.vala"
				return NULL;
#line 604 "skkserv.c"
			} else {
#line 80 "skkserv.vala"
				_g_string_free0 (builder);
#line 80 "skkserv.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 80 "skkserv.vala"
				g_clear_error (&_inner_error0_);
#line 80 "skkserv.vala"
				return NULL;
#line 614 "skkserv.c"
			}
		} else {
#line 82 "skkserv.vala"
			if (len == ((gssize) 0)) {
#line 83 "skkserv.vala"
				break;
#line 621 "skkserv.c"
			} else {
#line 85 "skkserv.vala"
				if (len > ((gssize) 0)) {
#line 625 "skkserv.c"
					guint8 _tmp7_;
					gchar* data = NULL;
					gchar* _tmp9_;
					gint data_length1;
					gint _data_size_;
					gchar* _tmp10_;
					gint _tmp10__length1;
					gint _tmp11_;
					GString* _tmp12_;
					gchar* _tmp13_;
					gint _tmp13__length1;
#line 86 "skkserv.vala"
					_tmp7_ = self->priv->buffer[0];
#line 86 "skkserv.vala"
					if (_tmp7_ != ((guint8) '1')) {
#line 641 "skkserv.c"
						GError* _tmp8_;
#line 87 "skkserv.vala"
						_tmp8_ = g_error_new_literal (SKK_SKK_SERV_ERROR, SKK_SKK_SERV_ERROR_INVALID_RESPONSE, "invalid response code");
#line 87 "skkserv.vala"
						_inner_error0_ = _tmp8_;
#line 87 "skkserv.vala"
						if ((_inner_error0_->domain == SKK_SKK_SERV_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 87 "skkserv.vala"
							g_propagate_error (error, _inner_error0_);
#line 87 "skkserv.vala"
							_g_string_free0 (builder);
#line 87 "skkserv.vala"
							return NULL;
#line 655 "skkserv.c"
						} else {
#line 87 "skkserv.vala"
							_g_string_free0 (builder);
#line 87 "skkserv.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 87 "skkserv.vala"
							g_clear_error (&_inner_error0_);
#line 87 "skkserv.vala"
							return NULL;
#line 665 "skkserv.c"
						}
					}
#line 91 "skkserv.vala"
					_tmp9_ = g_new0 (gchar, len + 1);
#line 91 "skkserv.vala"
					data = _tmp9_;
#line 91 "skkserv.vala"
					data_length1 = len + 1;
#line 91 "skkserv.vala"
					_data_size_ = data_length1;
#line 92 "skkserv.vala"
					_tmp10_ = data;
#line 92 "skkserv.vala"
					_tmp10__length1 = data_length1;
#line 92 "skkserv.vala"
					memcpy (_tmp10_, self->priv->buffer, (gsize) len);
#line 93 "skkserv.vala"
					_tmp11_ = data_length1;
#line 93 "skkserv.vala"
					data_length1 = _tmp11_ - 1;
#line 94 "skkserv.vala"
					_tmp12_ = builder;
#line 94 "skkserv.vala"
					_tmp13_ = data;
#line 94 "skkserv.vala"
					_tmp13__length1 = data_length1;
#line 94 "skkserv.vala"
					g_string_append (_tmp12_, (const gchar*) _tmp13_);
#line 85 "skkserv.vala"
					data = (g_free (data), NULL);
#line 696 "skkserv.c"
				}
			}
		}
	}
#line 97 "skkserv.vala"
	_tmp14_ = builder;
#line 97 "skkserv.vala"
	_tmp15_ = _tmp14_->str;
#line 97 "skkserv.vala"
	index = string_index_of_char (_tmp15_, (gunichar) '\n', 0);
#line 98 "skkserv.vala"
	if (index < 0) {
#line 709 "skkserv.c"
		GError* _tmp16_;
#line 99 "skkserv.vala"
		_tmp16_ = g_error_new_literal (SKK_SKK_SERV_ERROR, SKK_SKK_SERV_ERROR_INVALID_RESPONSE, "missing newline");
#line 99 "skkserv.vala"
		_inner_error0_ = _tmp16_;
#line 99 "skkserv.vala"
		if ((_inner_error0_->domain == SKK_SKK_SERV_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 99 "skkserv.vala"
			g_propagate_error (error, _inner_error0_);
#line 99 "skkserv.vala"
			_g_string_free0 (builder);
#line 99 "skkserv.vala"
			return NULL;
#line 723 "skkserv.c"
		} else {
#line 99 "skkserv.vala"
			_g_string_free0 (builder);
#line 99 "skkserv.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "skkserv.vala"
			g_clear_error (&_inner_error0_);
#line 99 "skkserv.vala"
			return NULL;
#line 733 "skkserv.c"
		}
	}
#line 101 "skkserv.vala"
	_tmp17_ = builder;
#line 101 "skkserv.vala"
	_tmp18_ = _tmp17_->str;
#line 101 "skkserv.vala"
	_tmp19_ = string_slice (_tmp18_, (glong) 0, (glong) index);
#line 101 "skkserv.vala"
	result = _tmp19_;
#line 101 "skkserv.vala"
	_g_string_free0 (builder);
#line 101 "skkserv.vala"
	return result;
#line 748 "skkserv.c"
}

/**
         * {@inheritDoc}
         */
static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 788 "skkserv.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 794 "skkserv.c"
}

static SkkCandidate**
skk_skk_serv_real_lookup (SkkDict* base,
                          const gchar* midasi,
                          gboolean okuri,
                          gint* result_length1)
{
	SkkSkkServ * self;
	GSocketConnection* _tmp0_;
	gchar* _midasi = NULL;
	GError* _inner_error0_ = NULL;
	SkkCandidate** result;
#line 107 "skkserv.vala"
	self = (SkkSkkServ*) base;
#line 107 "skkserv.vala"
	g_return_val_if_fail (midasi != NULL, NULL);
#line 108 "skkserv.vala"
	_tmp0_ = self->priv->connection;
#line 108 "skkserv.vala"
	if (_tmp0_ == NULL) {
#line 816 "skkserv.c"
		SkkCandidate** _tmp1_;
		SkkCandidate** _tmp2_;
		gint _tmp2__length1;
#line 109 "skkserv.vala"
		_tmp1_ = g_new0 (SkkCandidate*, 0 + 1);
#line 109 "skkserv.vala"
		_tmp2_ = _tmp1_;
#line 109 "skkserv.vala"
		_tmp2__length1 = 0;
#line 109 "skkserv.vala"
		if (result_length1) {
#line 109 "skkserv.vala"
			*result_length1 = _tmp2__length1;
#line 830 "skkserv.c"
		}
#line 109 "skkserv.vala"
		result = _tmp2_;
#line 109 "skkserv.vala"
		return result;
#line 836 "skkserv.c"
	}
	{
		gchar* _tmp3_ = NULL;
		SkkEncodingConverter* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 112 "skkserv.vala"
		_tmp4_ = self->priv->converter;
#line 112 "skkserv.vala"
		_tmp5_ = skk_encoding_converter_encode (_tmp4_, midasi, &_inner_error0_);
#line 112 "skkserv.vala"
		_tmp3_ = _tmp5_;
#line 112 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 851 "skkserv.c"
			goto __catch0_g_error;
		}
#line 112 "skkserv.vala"
		_tmp6_ = _tmp3_;
#line 112 "skkserv.vala"
		_tmp3_ = NULL;
#line 112 "skkserv.vala"
		_g_free0 (_midasi);
#line 112 "skkserv.vala"
		_midasi = _tmp6_;
#line 111 "skkserv.vala"
		_g_free0 (_tmp3_);
#line 864 "skkserv.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		SkkCandidate** _tmp7_;
		SkkCandidate** _tmp8_;
		gint _tmp8__length1;
#line 111 "skkserv.vala"
		g_clear_error (&_inner_error0_);
#line 114 "skkserv.vala"
		_tmp7_ = g_new0 (SkkCandidate*, 0 + 1);
#line 114 "skkserv.vala"
		_tmp8_ = _tmp7_;
#line 114 "skkserv.vala"
		_tmp8__length1 = 0;
#line 114 "skkserv.vala"
		if (result_length1) {
#line 114 "skkserv.vala"
			*result_length1 = _tmp8__length1;
#line 884 "skkserv.c"
		}
#line 114 "skkserv.vala"
		result = _tmp8_;
#line 114 "skkserv.vala"
		_g_free0 (_midasi);
#line 114 "skkserv.vala"
		return result;
#line 892 "skkserv.c"
	}
	__finally0:
#line 111 "skkserv.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "skkserv.vala"
		_g_free0 (_midasi);
#line 111 "skkserv.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 111 "skkserv.vala"
		g_clear_error (&_inner_error0_);
#line 111 "skkserv.vala"
		return NULL;
#line 905 "skkserv.c"
	}
	{
		gsize bytes_written = 0UL;
		GSocketConnection* _tmp9_;
		GOutputStream* _tmp10_;
		GOutputStream* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		guint8* _tmp15_;
		gint _tmp15__length1;
		gint _tmp16_ = 0;
		guint8* _tmp17_;
		gint _tmp17__length1;
		gsize _tmp18_ = 0UL;
		GSocketConnection* _tmp19_;
		GOutputStream* _tmp20_;
		GOutputStream* _tmp21_;
		gchar* response = NULL;
		gchar* _tmp22_;
		const gchar* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gchar* _tmp28_ = NULL;
		SkkEncodingConverter* _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		gint _tmp32_;
		gint _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gint _tmp38_ = 0;
		SkkCandidate** _tmp39_;
		SkkCandidate** _tmp40_;
		gint _tmp40__length1;
#line 118 "skkserv.vala"
		_tmp9_ = self->priv->connection;
#line 118 "skkserv.vala"
		_tmp10_ = g_io_stream_get_output_stream ((GIOStream*) _tmp9_);
#line 118 "skkserv.vala"
		_tmp11_ = _tmp10_;
#line 118 "skkserv.vala"
		_tmp12_ = _midasi;
#line 118 "skkserv.vala"
		_tmp13_ = g_strdup_printf ("1%s ", _tmp12_);
#line 118 "skkserv.vala"
		_tmp14_ = _tmp13_;
#line 118 "skkserv.vala"
		_tmp15_ = string_get_data (_tmp14_, &_tmp16_);
#line 118 "skkserv.vala"
		_tmp15__length1 = _tmp16_;
#line 118 "skkserv.vala"
		_tmp17_ = _tmp15_;
#line 118 "skkserv.vala"
		_tmp17__length1 = _tmp15__length1;
#line 118 "skkserv.vala"
		g_output_stream_write_all (_tmp11_, _tmp17_, (gsize) _tmp17__length1, &_tmp18_, NULL, &_inner_error0_);
#line 118 "skkserv.vala"
		bytes_written = _tmp18_;
#line 118 "skkserv.vala"
		_g_free0 (_tmp14_);
#line 118 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "skkserv.vala"
			if (_inner_error0_->domain == SKK_SKK_SERV_ERROR) {
#line 973 "skkserv.c"
				goto __catch1_skk_skk_serv_error;
			}
			goto __catch1_g_error;
		}
#line 120 "skkserv.vala"
		_tmp19_ = self->priv->connection;
#line 120 "skkserv.vala"
		_tmp20_ = g_io_stream_get_output_stream ((GIOStream*) _tmp19_);
#line 120 "skkserv.vala"
		_tmp21_ = _tmp20_;
#line 120 "skkserv.vala"
		g_output_stream_flush (_tmp21_, NULL, &_inner_error0_);
#line 120 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 120 "skkserv.vala"
			if (_inner_error0_->domain == SKK_SKK_SERV_ERROR) {
#line 990 "skkserv.c"
				goto __catch1_skk_skk_serv_error;
			}
			goto __catch1_g_error;
		}
#line 121 "skkserv.vala"
		_tmp22_ = skk_skk_serv_read_response (self, &_inner_error0_);
#line 121 "skkserv.vala"
		response = _tmp22_;
#line 121 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 121 "skkserv.vala"
			if (_inner_error0_->domain == SKK_SKK_SERV_ERROR) {
#line 1003 "skkserv.c"
				goto __catch1_skk_skk_serv_error;
			}
			goto __catch1_g_error;
		}
#line 122 "skkserv.vala"
		_tmp23_ = response;
#line 122 "skkserv.vala"
		_tmp24_ = strlen (_tmp23_);
#line 122 "skkserv.vala"
		_tmp25_ = _tmp24_;
#line 122 "skkserv.vala"
		if (_tmp25_ == 0) {
#line 1016 "skkserv.c"
			SkkCandidate** _tmp26_;
			SkkCandidate** _tmp27_;
			gint _tmp27__length1;
#line 123 "skkserv.vala"
			_tmp26_ = g_new0 (SkkCandidate*, 0 + 1);
#line 123 "skkserv.vala"
			_tmp27_ = _tmp26_;
#line 123 "skkserv.vala"
			_tmp27__length1 = 0;
#line 123 "skkserv.vala"
			if (result_length1) {
#line 123 "skkserv.vala"
				*result_length1 = _tmp27__length1;
#line 1030 "skkserv.c"
			}
#line 123 "skkserv.vala"
			result = _tmp27_;
#line 123 "skkserv.vala"
			_g_free0 (response);
#line 123 "skkserv.vala"
			_g_free0 (_midasi);
#line 123 "skkserv.vala"
			return result;
#line 1040 "skkserv.c"
		}
#line 126 "skkserv.vala"
		_tmp29_ = self->priv->converter;
#line 126 "skkserv.vala"
		_tmp30_ = response;
#line 126 "skkserv.vala"
		_tmp31_ = response;
#line 126 "skkserv.vala"
		_tmp32_ = strlen (_tmp31_);
#line 126 "skkserv.vala"
		_tmp33_ = _tmp32_;
#line 126 "skkserv.vala"
		_tmp34_ = string_slice (_tmp30_, (glong) 1, (glong) _tmp33_);
#line 126 "skkserv.vala"
		_tmp35_ = _tmp34_;
#line 126 "skkserv.vala"
		_tmp36_ = skk_encoding_converter_decode (_tmp29_, _tmp35_, &_inner_error0_);
#line 126 "skkserv.vala"
		_tmp37_ = _tmp36_;
#line 126 "skkserv.vala"
		_g_free0 (_tmp35_);
#line 126 "skkserv.vala"
		_tmp28_ = _tmp37_;
#line 126 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 126 "skkserv.vala"
			_g_free0 (response);
#line 126 "skkserv.vala"
			if (_inner_error0_->domain == SKK_SKK_SERV_ERROR) {
#line 1070 "skkserv.c"
				goto __catch1_skk_skk_serv_error;
			}
			goto __catch1_g_error;
		}
#line 124 "skkserv.vala"
		_tmp39_ = skk_dict_split_candidates ((SkkDict*) self, midasi, okuri, _tmp28_, &_tmp38_);
#line 124 "skkserv.vala"
		_tmp40_ = _tmp39_;
#line 124 "skkserv.vala"
		_tmp40__length1 = _tmp38_;
#line 124 "skkserv.vala"
		if (result_length1) {
#line 124 "skkserv.vala"
			*result_length1 = _tmp40__length1;
#line 1085 "skkserv.c"
		}
#line 124 "skkserv.vala"
		result = _tmp40_;
#line 124 "skkserv.vala"
		_g_free0 (_tmp28_);
#line 124 "skkserv.vala"
		_g_free0 (response);
#line 124 "skkserv.vala"
		_g_free0 (_midasi);
#line 124 "skkserv.vala"
		return result;
#line 1097 "skkserv.c"
	}
	goto __finally1;
	__catch1_skk_skk_serv_error:
	{
		SkkCandidate** _tmp41_;
		SkkCandidate** _tmp42_;
		gint _tmp42__length1;
#line 116 "skkserv.vala"
		g_clear_error (&_inner_error0_);
#line 129 "skkserv.vala"
		_tmp41_ = g_new0 (SkkCandidate*, 0 + 1);
#line 129 "skkserv.vala"
		_tmp42_ = _tmp41_;
#line 129 "skkserv.vala"
		_tmp42__length1 = 0;
#line 129 "skkserv.vala"
		if (result_length1) {
#line 129 "skkserv.vala"
			*result_length1 = _tmp42__length1;
#line 1117 "skkserv.c"
		}
#line 129 "skkserv.vala"
		result = _tmp42_;
#line 129 "skkserv.vala"
		_g_free0 (_midasi);
#line 129 "skkserv.vala"
		return result;
#line 1125 "skkserv.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		SkkCandidate** _tmp43_;
		SkkCandidate** _tmp44_;
		gint _tmp44__length1;
#line 116 "skkserv.vala"
		g_clear_error (&_inner_error0_);
#line 131 "skkserv.vala"
		_tmp43_ = g_new0 (SkkCandidate*, 0 + 1);
#line 131 "skkserv.vala"
		_tmp44_ = _tmp43_;
#line 131 "skkserv.vala"
		_tmp44__length1 = 0;
#line 131 "skkserv.vala"
		if (result_length1) {
#line 131 "skkserv.vala"
			*result_length1 = _tmp44__length1;
#line 1145 "skkserv.c"
		}
#line 131 "skkserv.vala"
		result = _tmp44_;
#line 131 "skkserv.vala"
		_g_free0 (_midasi);
#line 131 "skkserv.vala"
		return result;
#line 1153 "skkserv.c"
	}
	__finally1:
#line 116 "skkserv.vala"
	_g_free0 (_midasi);
#line 116 "skkserv.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 116 "skkserv.vala"
	g_clear_error (&_inner_error0_);
#line 116 "skkserv.vala"
	return NULL;
#line 1164 "skkserv.c"
}

/**
         * {@inheritDoc}
         */
static gchar**
skk_skk_serv_real_complete (SkkDict* base,
                            const gchar* midasi,
                            gint* result_length1)
{
	SkkSkkServ * self;
	GSocketConnection* _tmp0_;
	gchar* _midasi = NULL;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 138 "skkserv.vala"
	self = (SkkSkkServ*) base;
#line 138 "skkserv.vala"
	g_return_val_if_fail (midasi != NULL, NULL);
#line 139 "skkserv.vala"
	_tmp0_ = self->priv->connection;
#line 139 "skkserv.vala"
	if (_tmp0_ == NULL) {
#line 1188 "skkserv.c"
		gchar** _tmp1_;
		gchar** _tmp2_;
		gint _tmp2__length1;
#line 140 "skkserv.vala"
		_tmp1_ = g_new0 (gchar*, 0 + 1);
#line 140 "skkserv.vala"
		_tmp2_ = _tmp1_;
#line 140 "skkserv.vala"
		_tmp2__length1 = 0;
#line 140 "skkserv.vala"
		if (result_length1) {
#line 140 "skkserv.vala"
			*result_length1 = _tmp2__length1;
#line 1202 "skkserv.c"
		}
#line 140 "skkserv.vala"
		result = _tmp2_;
#line 140 "skkserv.vala"
		return result;
#line 1208 "skkserv.c"
	}
	{
		gchar* _tmp3_ = NULL;
		SkkEncodingConverter* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 143 "skkserv.vala"
		_tmp4_ = self->priv->converter;
#line 143 "skkserv.vala"
		_tmp5_ = skk_encoding_converter_encode (_tmp4_, midasi, &_inner_error0_);
#line 143 "skkserv.vala"
		_tmp3_ = _tmp5_;
#line 143 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1223 "skkserv.c"
			goto __catch0_g_error;
		}
#line 143 "skkserv.vala"
		_tmp6_ = _tmp3_;
#line 143 "skkserv.vala"
		_tmp3_ = NULL;
#line 143 "skkserv.vala"
		_g_free0 (_midasi);
#line 143 "skkserv.vala"
		_midasi = _tmp6_;
#line 142 "skkserv.vala"
		_g_free0 (_tmp3_);
#line 1236 "skkserv.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
#line 142 "skkserv.vala"
		g_clear_error (&_inner_error0_);
#line 145 "skkserv.vala"
		_tmp7_ = g_new0 (gchar*, 0 + 1);
#line 145 "skkserv.vala"
		_tmp8_ = _tmp7_;
#line 145 "skkserv.vala"
		_tmp8__length1 = 0;
#line 145 "skkserv.vala"
		if (result_length1) {
#line 145 "skkserv.vala"
			*result_length1 = _tmp8__length1;
#line 1256 "skkserv.c"
		}
#line 145 "skkserv.vala"
		result = _tmp8_;
#line 145 "skkserv.vala"
		_g_free0 (_midasi);
#line 145 "skkserv.vala"
		return result;
#line 1264 "skkserv.c"
	}
	__finally0:
#line 142 "skkserv.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 142 "skkserv.vala"
		_g_free0 (_midasi);
#line 142 "skkserv.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 142 "skkserv.vala"
		g_clear_error (&_inner_error0_);
#line 142 "skkserv.vala"
		return NULL;
#line 1277 "skkserv.c"
	}
	{
		gsize bytes_written = 0UL;
		GSocketConnection* _tmp9_;
		GOutputStream* _tmp10_;
		GOutputStream* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		guint8* _tmp15_;
		gint _tmp15__length1;
		gint _tmp16_ = 0;
		guint8* _tmp17_;
		gint _tmp17__length1;
		gsize _tmp18_ = 0UL;
		GSocketConnection* _tmp19_;
		GOutputStream* _tmp20_;
		GOutputStream* _tmp21_;
		gchar* response = NULL;
		gchar* _tmp22_;
		const gchar* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gchar* _tmp28_ = NULL;
		SkkEncodingConverter* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar** _tmp35_;
		gchar** _tmp36_;
		gchar** _tmp37_;
		gint _tmp37__length1;
#line 149 "skkserv.vala"
		_tmp9_ = self->priv->connection;
#line 149 "skkserv.vala"
		_tmp10_ = g_io_stream_get_output_stream ((GIOStream*) _tmp9_);
#line 149 "skkserv.vala"
		_tmp11_ = _tmp10_;
#line 149 "skkserv.vala"
		_tmp12_ = _midasi;
#line 149 "skkserv.vala"
		_tmp13_ = g_strdup_printf ("4%s ", _tmp12_);
#line 149 "skkserv.vala"
		_tmp14_ = _tmp13_;
#line 149 "skkserv.vala"
		_tmp15_ = string_get_data (_tmp14_, &_tmp16_);
#line 149 "skkserv.vala"
		_tmp15__length1 = _tmp16_;
#line 149 "skkserv.vala"
		_tmp17_ = _tmp15_;
#line 149 "skkserv.vala"
		_tmp17__length1 = _tmp15__length1;
#line 149 "skkserv.vala"
		g_output_stream_write_all (_tmp11_, _tmp17_, (gsize) _tmp17__length1, &_tmp18_, NULL, &_inner_error0_);
#line 149 "skkserv.vala"
		bytes_written = _tmp18_;
#line 149 "skkserv.vala"
		_g_free0 (_tmp14_);
#line 149 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "skkserv.vala"
			if (_inner_error0_->domain == SKK_SKK_SERV_ERROR) {
#line 1342 "skkserv.c"
				goto __catch1_skk_skk_serv_error;
			}
			goto __catch1_g_error;
		}
#line 151 "skkserv.vala"
		_tmp19_ = self->priv->connection;
#line 151 "skkserv.vala"
		_tmp20_ = g_io_stream_get_output_stream ((GIOStream*) _tmp19_);
#line 151 "skkserv.vala"
		_tmp21_ = _tmp20_;
#line 151 "skkserv.vala"
		g_output_stream_flush (_tmp21_, NULL, &_inner_error0_);
#line 151 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 151 "skkserv.vala"
			if (_inner_error0_->domain == SKK_SKK_SERV_ERROR) {
#line 1359 "skkserv.c"
				goto __catch1_skk_skk_serv_error;
			}
			goto __catch1_g_error;
		}
#line 152 "skkserv.vala"
		_tmp22_ = skk_skk_serv_read_response (self, &_inner_error0_);
#line 152 "skkserv.vala"
		response = _tmp22_;
#line 152 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 152 "skkserv.vala"
			if (_inner_error0_->domain == SKK_SKK_SERV_ERROR) {
#line 1372 "skkserv.c"
				goto __catch1_skk_skk_serv_error;
			}
			goto __catch1_g_error;
		}
#line 153 "skkserv.vala"
		_tmp23_ = response;
#line 153 "skkserv.vala"
		_tmp24_ = strlen (_tmp23_);
#line 153 "skkserv.vala"
		_tmp25_ = _tmp24_;
#line 153 "skkserv.vala"
		if (_tmp25_ < 2) {
#line 1385 "skkserv.c"
			gchar** _tmp26_;
			gchar** _tmp27_;
			gint _tmp27__length1;
#line 154 "skkserv.vala"
			_tmp26_ = g_new0 (gchar*, 0 + 1);
#line 154 "skkserv.vala"
			_tmp27_ = _tmp26_;
#line 154 "skkserv.vala"
			_tmp27__length1 = 0;
#line 154 "skkserv.vala"
			if (result_length1) {
#line 154 "skkserv.vala"
				*result_length1 = _tmp27__length1;
#line 1399 "skkserv.c"
			}
#line 154 "skkserv.vala"
			result = _tmp27_;
#line 154 "skkserv.vala"
			_g_free0 (response);
#line 154 "skkserv.vala"
			_g_free0 (_midasi);
#line 154 "skkserv.vala"
			return result;
#line 1409 "skkserv.c"
		}
#line 155 "skkserv.vala"
		_tmp29_ = self->priv->converter;
#line 155 "skkserv.vala"
		_tmp30_ = response;
#line 155 "skkserv.vala"
		_tmp31_ = string_slice (_tmp30_, (glong) 2, (glong) -1);
#line 155 "skkserv.vala"
		_tmp32_ = _tmp31_;
#line 155 "skkserv.vala"
		_tmp33_ = skk_encoding_converter_decode (_tmp29_, _tmp32_, &_inner_error0_);
#line 155 "skkserv.vala"
		_tmp34_ = _tmp33_;
#line 155 "skkserv.vala"
		_g_free0 (_tmp32_);
#line 155 "skkserv.vala"
		_tmp28_ = _tmp34_;
#line 155 "skkserv.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 155 "skkserv.vala"
			_g_free0 (response);
#line 155 "skkserv.vala"
			if (_inner_error0_->domain == SKK_SKK_SERV_ERROR) {
#line 1433 "skkserv.c"
				goto __catch1_skk_skk_serv_error;
			}
			goto __catch1_g_error;
		}
#line 155 "skkserv.vala"
		_tmp36_ = _tmp35_ = g_strsplit (_tmp28_, "/", 0);
#line 155 "skkserv.vala"
		_tmp37_ = _tmp36_;
#line 155 "skkserv.vala"
		_tmp37__length1 = _vala_array_length (_tmp35_);
#line 155 "skkserv.vala"
		if (result_length1) {
#line 155 "skkserv.vala"
			*result_length1 = _tmp37__length1;
#line 1448 "skkserv.c"
		}
#line 155 "skkserv.vala"
		result = _tmp37_;
#line 155 "skkserv.vala"
		_g_free0 (_tmp28_);
#line 155 "skkserv.vala"
		_g_free0 (response);
#line 155 "skkserv.vala"
		_g_free0 (_midasi);
#line 155 "skkserv.vala"
		return result;
#line 1460 "skkserv.c"
	}
	goto __finally1;
	__catch1_skk_skk_serv_error:
	{
		GError* e = NULL;
		GError* _tmp38_;
		const gchar* _tmp39_;
		gchar** _tmp40_;
		gchar** _tmp41_;
		gint _tmp41__length1;
#line 147 "skkserv.vala"
		e = _inner_error0_;
#line 147 "skkserv.vala"
		_inner_error0_ = NULL;
#line 158 "skkserv.vala"
		_tmp38_ = e;
#line 158 "skkserv.vala"
		_tmp39_ = _tmp38_->message;
#line 158 "skkserv.vala"
		g_warning ("skkserv.vala:158: server completion failed %s", _tmp39_);
#line 159 "skkserv.vala"
		_tmp40_ = g_new0 (gchar*, 0 + 1);
#line 159 "skkserv.vala"
		_tmp41_ = _tmp40_;
#line 159 "skkserv.vala"
		_tmp41__length1 = 0;
#line 159 "skkserv.vala"
		if (result_length1) {
#line 159 "skkserv.vala"
			*result_length1 = _tmp41__length1;
#line 1491 "skkserv.c"
		}
#line 159 "skkserv.vala"
		result = _tmp41_;
#line 159 "skkserv.vala"
		_g_error_free0 (e);
#line 159 "skkserv.vala"
		_g_free0 (_midasi);
#line 159 "skkserv.vala"
		return result;
#line 1501 "skkserv.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp42_;
		const gchar* _tmp43_;
		gchar** _tmp44_;
		gchar** _tmp45_;
		gint _tmp45__length1;
#line 147 "skkserv.vala"
		e = _inner_error0_;
#line 147 "skkserv.vala"
		_inner_error0_ = NULL;
#line 161 "skkserv.vala"
		_tmp42_ = e;
#line 161 "skkserv.vala"
		_tmp43_ = _tmp42_->message;
#line 161 "skkserv.vala"
		g_warning ("skkserv.vala:161: server completion failed %s", _tmp43_);
#line 162 "skkserv.vala"
		_tmp44_ = g_new0 (gchar*, 0 + 1);
#line 162 "skkserv.vala"
		_tmp45_ = _tmp44_;
#line 162 "skkserv.vala"
		_tmp45__length1 = 0;
#line 162 "skkserv.vala"
		if (result_length1) {
#line 162 "skkserv.vala"
			*result_length1 = _tmp45__length1;
#line 1532 "skkserv.c"
		}
#line 162 "skkserv.vala"
		result = _tmp45_;
#line 162 "skkserv.vala"
		_g_error_free0 (e);
#line 162 "skkserv.vala"
		_g_free0 (_midasi);
#line 162 "skkserv.vala"
		return result;
#line 1542 "skkserv.c"
	}
	__finally1:
#line 147 "skkserv.vala"
	_g_free0 (_midasi);
#line 147 "skkserv.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "skkserv.vala"
	g_clear_error (&_inner_error0_);
#line 147 "skkserv.vala"
	return NULL;
#line 1553 "skkserv.c"
}

/**
         * Create a new SkkServ.
         *
         * @param host host to connect
         * @param port port at the host
         * @param encoding encoding to convert text over network traffic
         *
         * @return a new SkkServ.
         * @throws GLib.Error if opening a connection is failed
         */
SkkSkkServ*
skk_skk_serv_construct (GType object_type,
                        const gchar* host,
                        guint16 port,
                        const gchar* encoding,
                        GError** error)
{
	SkkSkkServ * self = NULL;
	gchar* _tmp0_;
	SkkEncodingConverter* _tmp1_ = NULL;
	SkkEncodingConverter* _tmp2_;
	SkkEncodingConverter* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 187 "skkserv.vala"
	g_return_val_if_fail (host != NULL, NULL);
#line 187 "skkserv.vala"
	g_return_val_if_fail (encoding != NULL, NULL);
#line 187 "skkserv.vala"
	self = (SkkSkkServ*) skk_dict_construct (object_type);
#line 188 "skkserv.vala"
	_tmp0_ = g_strdup (host);
#line 188 "skkserv.vala"
	_g_free0 (self->priv->host);
#line 188 "skkserv.vala"
	self->priv->host = _tmp0_;
#line 189 "skkserv.vala"
	self->priv->port = port;
#line 190 "skkserv.vala"
	_tmp2_ = skk_encoding_converter_new (encoding, &_inner_error0_);
#line 190 "skkserv.vala"
	_tmp1_ = _tmp2_;
#line 190 "skkserv.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 190 "skkserv.vala"
		g_propagate_error (error, _inner_error0_);
#line 190 "skkserv.vala"
		_g_object_unref0 (self);
#line 190 "skkserv.vala"
		return NULL;
#line 1605 "skkserv.c"
	}
#line 190 "skkserv.vala"
	_tmp3_ = _tmp1_;
#line 190 "skkserv.vala"
	_tmp1_ = NULL;
#line 190 "skkserv.vala"
	_g_object_unref0 (self->priv->converter);
#line 190 "skkserv.vala"
	self->priv->converter = _tmp3_;
#line 191 "skkserv.vala"
	skk_dict_reload ((SkkDict*) self, &_inner_error0_);
#line 191 "skkserv.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 191 "skkserv.vala"
		g_propagate_error (error, _inner_error0_);
#line 191 "skkserv.vala"
		_g_object_unref0 (_tmp1_);
#line 191 "skkserv.vala"
		_g_object_unref0 (self);
#line 191 "skkserv.vala"
		return NULL;
#line 1627 "skkserv.c"
	}
#line 187 "skkserv.vala"
	_g_object_unref0 (_tmp1_);
#line 187 "skkserv.vala"
	return self;
#line 1633 "skkserv.c"
}

SkkSkkServ*
skk_skk_serv_new (const gchar* host,
                  guint16 port,
                  const gchar* encoding,
                  GError** error)
{
#line 187 "skkserv.vala"
	return skk_skk_serv_construct (SKK_TYPE_SKK_SERV, host, port, encoding, error);
#line 1644 "skkserv.c"
}

static gboolean
skk_skk_serv_real_get_read_only (SkkDict* base)
{
	gboolean result;
	SkkSkkServ* self;
#line 170 "skkserv.vala"
	self = (SkkSkkServ*) base;
#line 171 "skkserv.vala"
	result = TRUE;
#line 171 "skkserv.vala"
	return result;
#line 1658 "skkserv.c"
}

static void
skk_skk_serv_class_init (SkkSkkServClass * klass,
                         gpointer klass_data)
{
#line 27 "skkserv.vala"
	skk_skk_serv_parent_class = g_type_class_peek_parent (klass);
#line 27 "skkserv.vala"
	g_type_class_adjust_private_offset (klass, &SkkSkkServ_private_offset);
#line 27 "skkserv.vala"
	((SkkDictClass *) klass)->reload = (void (*) (SkkDict*, GError**)) skk_skk_serv_real_reload;
#line 27 "skkserv.vala"
	((SkkDictClass *) klass)->lookup = (SkkCandidate** (*) (SkkDict*, const gchar*, gboolean, gint*)) skk_skk_serv_real_lookup;
#line 27 "skkserv.vala"
	((SkkDictClass *) klass)->complete = (gchar** (*) (SkkDict*, const gchar*, gint*)) skk_skk_serv_real_complete;
#line 27 "skkserv.vala"
	SKK_DICT_CLASS (klass)->get_read_only = (gboolean (*) (SkkDict*)) skk_skk_serv_real_get_read_only;
#line 27 "skkserv.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_skk_skk_serv_get_property;
#line 27 "skkserv.vala"
	G_OBJECT_CLASS (klass)->finalize = skk_skk_serv_finalize;
#line 1681 "skkserv.c"
	/**
	         * {@inheritDoc}
	         */
#line 27 "skkserv.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_SKK_SERV_READ_ONLY_PROPERTY, skk_skk_serv_properties[SKK_SKK_SERV_READ_ONLY_PROPERTY] = g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1687 "skkserv.c"
}

static void
skk_skk_serv_instance_init (SkkSkkServ * self,
                            gpointer klass)
{
#line 27 "skkserv.vala"
	self->priv = skk_skk_serv_get_instance_private (self);
#line 1696 "skkserv.c"
}

static void
skk_skk_serv_finalize (GObject * obj)
{
	SkkSkkServ * self;
#line 27 "skkserv.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SKK_TYPE_SKK_SERV, SkkSkkServ);
#line 195 "skkserv.vala"
	skk_skk_serv_close_connection (self);
#line 28 "skkserv.vala"
	_g_object_unref0 (self->priv->connection);
#line 30 "skkserv.vala"
	_g_free0 (self->priv->host);
#line 175 "skkserv.vala"
	_g_object_unref0 (self->priv->converter);
#line 27 "skkserv.vala"
	G_OBJECT_CLASS (skk_skk_serv_parent_class)->finalize (obj);
#line 1715 "skkserv.c"
}

/**
     * Network based Implementation of Dict.
     */
static GType
skk_skk_serv_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SkkSkkServClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) skk_skk_serv_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SkkSkkServ), 0, (GInstanceInitFunc) skk_skk_serv_instance_init, NULL };
	GType skk_skk_serv_type_id;
	skk_skk_serv_type_id = g_type_register_static (SKK_TYPE_DICT, "SkkSkkServ", &g_define_type_info, 0);
	SkkSkkServ_private_offset = g_type_add_instance_private (skk_skk_serv_type_id, sizeof (SkkSkkServPrivate));
	return skk_skk_serv_type_id;
}

GType
skk_skk_serv_get_type (void)
{
	static volatile gsize skk_skk_serv_type_id__once = 0;
	if (g_once_init_enter (&skk_skk_serv_type_id__once)) {
		GType skk_skk_serv_type_id;
		skk_skk_serv_type_id = skk_skk_serv_get_type_once ();
		g_once_init_leave (&skk_skk_serv_type_id__once, skk_skk_serv_type_id);
	}
	return skk_skk_serv_type_id__once;
}

static void
_vala_skk_skk_serv_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	SkkSkkServ * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SKK_TYPE_SKK_SERV, SkkSkkServ);
#line 27 "skkserv.vala"
	switch (property_id) {
#line 27 "skkserv.vala"
		case SKK_SKK_SERV_READ_ONLY_PROPERTY:
#line 27 "skkserv.vala"
		g_value_set_boolean (value, skk_dict_get_read_only ((SkkDict*) self));
#line 27 "skkserv.vala"
		break;
#line 1759 "skkserv.c"
		default:
#line 27 "skkserv.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "skkserv.vala"
		break;
#line 1765 "skkserv.c"
	}
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

