/* user-dict.c generated by valac 0.56.17, the Vala compiler
 * generated from user-dict.vala, do not modify */

/*
 * Copyright (C) 2011-2018 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "libskk/libskk.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define SKK_TYPE_ENCODING_CONVERTER (skk_encoding_converter_get_type ())
#define SKK_ENCODING_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverter))
#define SKK_ENCODING_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverterClass))
#define SKK_IS_ENCODING_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SKK_TYPE_ENCODING_CONVERTER))
#define SKK_IS_ENCODING_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SKK_TYPE_ENCODING_CONVERTER))
#define SKK_ENCODING_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverterClass))

typedef struct _SkkEncodingConverter SkkEncodingConverter;
typedef struct _SkkEncodingConverterClass SkkEncodingConverterClass;
enum  {
	SKK_USER_DICT_0_PROPERTY,
	SKK_USER_DICT_READ_ONLY_PROPERTY,
	SKK_USER_DICT_NUM_PROPERTIES
};
static GParamSpec* skk_user_dict_properties[SKK_USER_DICT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define SKK_TYPE_SKK_DICT_ERROR (skk_skk_dict_error_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _SkkUserDictPrivate {
	GFile* file;
	gchar* etag;
	SkkEncodingConverter* converter;
	GeeMap* okuri_ari_entries;
	GeeMap* okuri_nasi_entries;
};

typedef enum  {
	SKK_SKK_DICT_ERROR_NOT_READABLE,
	SKK_SKK_DICT_ERROR_MALFORMED_INPUT
} SkkSkkDictError;
#define SKK_SKK_DICT_ERROR skk_skk_dict_error_quark ()

static gint SkkUserDict_private_offset;
static gpointer skk_user_dict_parent_class = NULL;

VALA_EXTERN GType skk_encoding_converter_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GQuark skk_skk_dict_error_quark (void);
VALA_EXTERN GType skk_skk_dict_error_get_type (void) G_GNUC_CONST ;
static void skk_user_dict_load (SkkUserDict* self,
                         GError** error);
static guint8* _vala_array_dup2 (guint8* self,
                          gssize length);
VALA_EXTERN gchar* skk_encoding_converter_extract_coding_system (const gchar* line);
VALA_EXTERN SkkEncodingConverter* skk_encoding_converter_new_from_coding_system (const gchar* coding,
                                                                     GError** error);
VALA_EXTERN SkkEncodingConverter* skk_encoding_converter_construct_from_coding_system (GType object_type,
                                                                           const gchar* coding,
                                                                           GError** error);
VALA_EXTERN gchar* skk_encoding_converter_decode (SkkEncodingConverter* self,
                                      const gchar* external_str,
                                      GError** error);
static void skk_user_dict_real_reload (SkkDict* base,
                                GError** error);
static gint skk_user_dict_compare_entry_asc (GeeMapEntry* a,
                                      GeeMapEntry* b);
static gint skk_user_dict_compare_entry_dsc (GeeMapEntry* a,
                                      GeeMapEntry* b);
static void skk_user_dict_write_entries (SkkUserDict* self,
                                  GString* builder,
                                  GeeList* entries);
static void skk_user_dict_real_save (SkkDict* base,
                              GError** error);
VALA_EXTERN gchar* skk_encoding_converter_get_coding_system (SkkEncodingConverter* self);
VALA_EXTERN gchar* skk_encoding_converter_encode (SkkEncodingConverter* self,
                                      const gchar* internal_str,
                                      GError** error);
static GeeMap* skk_user_dict_get_entries (SkkUserDict* self,
                                   gboolean okuri);
static SkkCandidate** skk_user_dict_real_lookup (SkkDict* base,
                                          const gchar* midasi,
                                          gboolean okuri,
                                          gint* result_length1);
static gchar** skk_user_dict_real_complete (SkkDict* base,
                                     const gchar* midasi,
                                     gint* result_length1);
static gboolean skk_user_dict_real_select_candidate (SkkDict* base,
                                              SkkCandidate* candidate);
static gboolean skk_user_dict_real_purge_candidate (SkkDict* base,
                                             SkkCandidate* candidate);
VALA_EXTERN SkkEncodingConverter* skk_encoding_converter_new (const gchar* encoding,
                                                  GError** error);
VALA_EXTERN SkkEncodingConverter* skk_encoding_converter_construct (GType object_type,
                                                        const gchar* encoding,
                                                        GError** error);
static void skk_user_dict_finalize (GObject * obj);
static GType skk_user_dict_get_type_once (void);
static void _vala_skk_user_dict_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
skk_user_dict_get_instance_private (SkkUserDict* self)
{
	return G_STRUCT_MEMBER_P (self, SkkUserDict_private_offset);
}

static guint8*
_vala_array_dup2 (guint8* self,
                  gssize length)
{
#line 32 "user-dict.vala"
	if (length > 0) {
#line 32 "user-dict.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 158 "user-dict.c"
	}
#line 32 "user-dict.vala"
	return NULL;
#line 162 "user-dict.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 48 "user-dict.vala"
	return self ? g_object_ref (self) : NULL;
#line 170 "user-dict.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1185 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1185 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1187 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1187 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 194 "user-dict.c"
		gchar* _tmp2_;
#line 1188 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1188 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1188 "glib-2.0.vapi"
		return result;
#line 202 "user-dict.c"
	} else {
#line 1190 "glib-2.0.vapi"
		result = -1;
#line 1190 "glib-2.0.vapi"
		return result;
#line 208 "user-dict.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 236 "user-dict.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 242 "user-dict.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 248 "user-dict.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 252 "user-dict.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 260 "user-dict.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 264 "user-dict.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 276 "user-dict.c"
}

static void
skk_user_dict_load (SkkUserDict* self,
                    GError** error)
{
	guint8* contents = NULL;
	gint contents_length1 = 0;
	gint _contents_size_ = 0;
	GMemoryInputStream* memory = NULL;
	guint8* _tmp5_;
	gint _tmp5__length1;
	guint8* _tmp6_;
	gint _tmp6__length1;
	GDestroyNotify _tmp7_;
	GMemoryInputStream* _tmp8_;
	GDataInputStream* data = NULL;
	GMemoryInputStream* _tmp9_;
	GDataInputStream* _tmp10_;
	gchar* line = NULL;
	gsize length = 0UL;
	gchar* _tmp11_ = NULL;
	GDataInputStream* _tmp12_;
	gsize _tmp13_ = 0UL;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* coding = NULL;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	GeeMap* entries = NULL;
	GeeMap* _tmp44_;
	gboolean okuri = FALSE;
	GError* _inner_error0_ = NULL;
#line 25 "user-dict.vala"
	g_return_if_fail (self != NULL);
#line 314 "user-dict.c"
	{
		GFile* _tmp0_;
		guint8* _tmp1_ = NULL;
		gsize _tmp2_ = 0;
		gchar* _tmp3_ = NULL;
#line 28 "user-dict.vala"
		_tmp0_ = self->priv->file;
#line 28 "user-dict.vala"
		g_file_load_contents (_tmp0_, NULL, &_tmp1_, &_tmp2_, &_tmp3_, &_inner_error0_);
#line 28 "user-dict.vala"
		contents = (g_free (contents), NULL);
#line 28 "user-dict.vala"
		contents = _tmp1_;
#line 28 "user-dict.vala"
		contents_length1 = _tmp2_;
#line 28 "user-dict.vala"
		_contents_size_ = contents_length1;
#line 28 "user-dict.vala"
		_g_free0 (self->priv->etag);
#line 28 "user-dict.vala"
		self->priv->etag = _tmp3_;
#line 28 "user-dict.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 338 "user-dict.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _tmp4_;
#line 27 "user-dict.vala"
		g_clear_error (&_inner_error0_);
#line 30 "user-dict.vala"
		_tmp4_ = g_error_new_literal (SKK_SKK_DICT_ERROR, SKK_SKK_DICT_ERROR_NOT_READABLE, "can't load contents");
#line 30 "user-dict.vala"
		_inner_error0_ = _tmp4_;
#line 352 "user-dict.c"
		goto __finally0;
	}
	__finally0:
#line 27 "user-dict.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27 "user-dict.vala"
		if ((_inner_error0_->domain == SKK_SKK_DICT_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 27 "user-dict.vala"
			g_propagate_error (error, _inner_error0_);
#line 27 "user-dict.vala"
			contents = (g_free (contents), NULL);
#line 27 "user-dict.vala"
			return;
#line 366 "user-dict.c"
		} else {
#line 27 "user-dict.vala"
			contents = (g_free (contents), NULL);
#line 27 "user-dict.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 27 "user-dict.vala"
			g_clear_error (&_inner_error0_);
#line 27 "user-dict.vala"
			return;
#line 376 "user-dict.c"
		}
	}
#line 32 "user-dict.vala"
	_tmp5_ = contents;
#line 32 "user-dict.vala"
	_tmp5__length1 = contents_length1;
#line 32 "user-dict.vala"
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup2 (_tmp5_, _tmp5__length1) : _tmp5_;
#line 32 "user-dict.vala"
	_tmp6__length1 = _tmp5__length1;
#line 32 "user-dict.vala"
	_tmp7_ = g_free;
#line 32 "user-dict.vala"
	_tmp8_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp6_, _tmp6__length1, _tmp7_);
#line 32 "user-dict.vala"
	memory = _tmp8_;
#line 33 "user-dict.vala"
	_tmp9_ = memory;
#line 33 "user-dict.vala"
	_tmp10_ = g_data_input_stream_new ((GInputStream*) _tmp9_);
#line 33 "user-dict.vala"
	data = _tmp10_;
#line 35 "user-dict.vala"
	line = NULL;
#line 37 "user-dict.vala"
	_tmp12_ = data;
#line 37 "user-dict.vala"
	_tmp14_ = g_data_input_stream_read_line (_tmp12_, &_tmp13_, NULL, &_inner_error0_);
#line 37 "user-dict.vala"
	length = _tmp13_;
#line 37 "user-dict.vala"
	_tmp11_ = _tmp14_;
#line 37 "user-dict.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 37 "user-dict.vala"
		if ((_inner_error0_->domain == SKK_SKK_DICT_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 37 "user-dict.vala"
			g_propagate_error (error, _inner_error0_);
#line 37 "user-dict.vala"
			_g_free0 (line);
#line 37 "user-dict.vala"
			_g_object_unref0 (data);
#line 37 "user-dict.vala"
			_g_object_unref0 (memory);
#line 37 "user-dict.vala"
			contents = (g_free (contents), NULL);
#line 37 "user-dict.vala"
			return;
#line 425 "user-dict.c"
		} else {
#line 37 "user-dict.vala"
			_g_free0 (line);
#line 37 "user-dict.vala"
			_g_object_unref0 (data);
#line 37 "user-dict.vala"
			_g_object_unref0 (memory);
#line 37 "user-dict.vala"
			contents = (g_free (contents), NULL);
#line 37 "user-dict.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 37 "user-dict.vala"
			g_clear_error (&_inner_error0_);
#line 37 "user-dict.vala"
			return;
#line 441 "user-dict.c"
		}
	}
#line 37 "user-dict.vala"
	_tmp15_ = _tmp11_;
#line 37 "user-dict.vala"
	_tmp11_ = NULL;
#line 37 "user-dict.vala"
	_g_free0 (line);
#line 37 "user-dict.vala"
	line = _tmp15_;
#line 38 "user-dict.vala"
	_tmp16_ = line;
#line 38 "user-dict.vala"
	if (_tmp16_ == NULL) {
#line 39 "user-dict.vala"
		_g_free0 (_tmp11_);
#line 39 "user-dict.vala"
		_g_free0 (line);
#line 39 "user-dict.vala"
		_g_object_unref0 (data);
#line 39 "user-dict.vala"
		_g_object_unref0 (memory);
#line 39 "user-dict.vala"
		contents = (g_free (contents), NULL);
#line 39 "user-dict.vala"
		return;
#line 468 "user-dict.c"
	}
#line 42 "user-dict.vala"
	_tmp17_ = line;
#line 42 "user-dict.vala"
	_tmp18_ = skk_encoding_converter_extract_coding_system (_tmp17_);
#line 42 "user-dict.vala"
	coding = _tmp18_;
#line 43 "user-dict.vala"
	_tmp19_ = coding;
#line 43 "user-dict.vala"
	if (_tmp19_ != NULL) {
#line 480 "user-dict.c"
		gchar* _tmp28_ = NULL;
		GDataInputStream* _tmp29_;
		gsize _tmp30_ = 0UL;
		gchar* _tmp31_;
		gchar* _tmp32_;
		const gchar* _tmp33_;
		{
			SkkEncodingConverter* _converter = NULL;
			const gchar* _tmp20_;
			SkkEncodingConverter* _tmp21_;
			SkkEncodingConverter* _tmp22_;
#line 45 "user-dict.vala"
			_tmp20_ = coding;
#line 45 "user-dict.vala"
			_tmp21_ = skk_encoding_converter_new_from_coding_system (_tmp20_, &_inner_error0_);
#line 45 "user-dict.vala"
			_converter = _tmp21_;
#line 45 "user-dict.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 500 "user-dict.c"
				goto __catch1_g_error;
			}
#line 47 "user-dict.vala"
			_tmp22_ = _converter;
#line 47 "user-dict.vala"
			if (_tmp22_ != NULL) {
#line 507 "user-dict.c"
				SkkEncodingConverter* _tmp23_;
				SkkEncodingConverter* _tmp24_;
#line 48 "user-dict.vala"
				_tmp23_ = _converter;
#line 48 "user-dict.vala"
				_tmp24_ = _g_object_ref0 (_tmp23_);
#line 48 "user-dict.vala"
				_g_object_unref0 (self->priv->converter);
#line 48 "user-dict.vala"
				self->priv->converter = _tmp24_;
#line 518 "user-dict.c"
			}
#line 44 "user-dict.vala"
			_g_object_unref0 (_converter);
#line 522 "user-dict.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp25_;
			GError* _tmp26_;
			const gchar* _tmp27_;
#line 44 "user-dict.vala"
			e = _inner_error0_;
#line 44 "user-dict.vala"
			_inner_error0_ = NULL;
#line 51 "user-dict.vala"
			_tmp25_ = coding;
#line 51 "user-dict.vala"
			_tmp26_ = e;
#line 51 "user-dict.vala"
			_tmp27_ = _tmp26_->message;
#line 51 "user-dict.vala"
			g_warning ("user-dict.vala:51: can't create converter from coding system %s: %s", _tmp25_, _tmp27_);
#line 44 "user-dict.vala"
			_g_error_free0 (e);
#line 545 "user-dict.c"
		}
		__finally1:
#line 44 "user-dict.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 44 "user-dict.vala"
			if ((_inner_error0_->domain == SKK_SKK_DICT_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 44 "user-dict.vala"
				g_propagate_error (error, _inner_error0_);
#line 44 "user-dict.vala"
				_g_free0 (coding);
#line 44 "user-dict.vala"
				_g_free0 (_tmp11_);
#line 44 "user-dict.vala"
				_g_free0 (line);
#line 44 "user-dict.vala"
				_g_object_unref0 (data);
#line 44 "user-dict.vala"
				_g_object_unref0 (memory);
#line 44 "user-dict.vala"
				contents = (g_free (contents), NULL);
#line 44 "user-dict.vala"
				return;
#line 568 "user-dict.c"
			} else {
#line 44 "user-dict.vala"
				_g_free0 (coding);
#line 44 "user-dict.vala"
				_g_free0 (_tmp11_);
#line 44 "user-dict.vala"
				_g_free0 (line);
#line 44 "user-dict.vala"
				_g_object_unref0 (data);
#line 44 "user-dict.vala"
				_g_object_unref0 (memory);
#line 44 "user-dict.vala"
				contents = (g_free (contents), NULL);
#line 44 "user-dict.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 44 "user-dict.vala"
				g_clear_error (&_inner_error0_);
#line 44 "user-dict.vala"
				return;
#line 588 "user-dict.c"
			}
		}
#line 55 "user-dict.vala"
		_tmp29_ = data;
#line 55 "user-dict.vala"
		_tmp31_ = g_data_input_stream_read_line (_tmp29_, &_tmp30_, NULL, &_inner_error0_);
#line 55 "user-dict.vala"
		length = _tmp30_;
#line 55 "user-dict.vala"
		_tmp28_ = _tmp31_;
#line 55 "user-dict.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 55 "user-dict.vala"
			if ((_inner_error0_->domain == SKK_SKK_DICT_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 55 "user-dict.vala"
				g_propagate_error (error, _inner_error0_);
#line 55 "user-dict.vala"
				_g_free0 (coding);
#line 55 "user-dict.vala"
				_g_free0 (_tmp11_);
#line 55 "user-dict.vala"
				_g_free0 (line);
#line 55 "user-dict.vala"
				_g_object_unref0 (data);
#line 55 "user-dict.vala"
				_g_object_unref0 (memory);
#line 55 "user-dict.vala"
				contents = (g_free (contents), NULL);
#line 55 "user-dict.vala"
				return;
#line 619 "user-dict.c"
			} else {
#line 55 "user-dict.vala"
				_g_free0 (coding);
#line 55 "user-dict.vala"
				_g_free0 (_tmp11_);
#line 55 "user-dict.vala"
				_g_free0 (line);
#line 55 "user-dict.vala"
				_g_object_unref0 (data);
#line 55 "user-dict.vala"
				_g_object_unref0 (memory);
#line 55 "user-dict.vala"
				contents = (g_free (contents), NULL);
#line 55 "user-dict.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 55 "user-dict.vala"
				g_clear_error (&_inner_error0_);
#line 55 "user-dict.vala"
				return;
#line 639 "user-dict.c"
			}
		}
#line 55 "user-dict.vala"
		_tmp32_ = _tmp28_;
#line 55 "user-dict.vala"
		_tmp28_ = NULL;
#line 55 "user-dict.vala"
		_g_free0 (line);
#line 55 "user-dict.vala"
		line = _tmp32_;
#line 56 "user-dict.vala"
		_tmp33_ = line;
#line 56 "user-dict.vala"
		if (_tmp33_ == NULL) {
#line 57 "user-dict.vala"
			_g_free0 (_tmp28_);
#line 57 "user-dict.vala"
			_g_free0 (coding);
#line 57 "user-dict.vala"
			_g_free0 (_tmp11_);
#line 57 "user-dict.vala"
			_g_free0 (line);
#line 57 "user-dict.vala"
			_g_object_unref0 (data);
#line 57 "user-dict.vala"
			_g_object_unref0 (memory);
#line 57 "user-dict.vala"
			contents = (g_free (contents), NULL);
#line 57 "user-dict.vala"
			return;
#line 670 "user-dict.c"
		}
#line 43 "user-dict.vala"
		_g_free0 (_tmp28_);
#line 674 "user-dict.c"
	}
#line 61 "user-dict.vala"
	entries = NULL;
#line 62 "user-dict.vala"
	while (TRUE) {
#line 680 "user-dict.c"
		const gchar* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp38_ = NULL;
		GDataInputStream* _tmp39_;
		gsize _tmp40_ = 0UL;
		gchar* _tmp41_;
		gchar* _tmp42_;
		const gchar* _tmp43_;
#line 62 "user-dict.vala"
		_tmp34_ = line;
#line 62 "user-dict.vala"
		if (!(_tmp34_ != NULL)) {
#line 62 "user-dict.vala"
			break;
#line 695 "user-dict.c"
		}
#line 63 "user-dict.vala"
		_tmp35_ = line;
#line 63 "user-dict.vala"
		if (g_str_has_prefix (_tmp35_, ";; okuri-ari entries.")) {
#line 701 "user-dict.c"
			GeeMap* _tmp36_;
			GeeMap* _tmp37_;
#line 64 "user-dict.vala"
			_tmp36_ = self->priv->okuri_ari_entries;
#line 64 "user-dict.vala"
			_tmp37_ = _g_object_ref0 (_tmp36_);
#line 64 "user-dict.vala"
			_g_object_unref0 (entries);
#line 64 "user-dict.vala"
			entries = _tmp37_;
#line 65 "user-dict.vala"
			break;
#line 714 "user-dict.c"
		}
#line 67 "user-dict.vala"
		_tmp39_ = data;
#line 67 "user-dict.vala"
		_tmp41_ = g_data_input_stream_read_line (_tmp39_, &_tmp40_, NULL, &_inner_error0_);
#line 67 "user-dict.vala"
		length = _tmp40_;
#line 67 "user-dict.vala"
		_tmp38_ = _tmp41_;
#line 67 "user-dict.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 67 "user-dict.vala"
			if ((_inner_error0_->domain == SKK_SKK_DICT_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 67 "user-dict.vala"
				g_propagate_error (error, _inner_error0_);
#line 67 "user-dict.vala"
				_g_object_unref0 (entries);
#line 67 "user-dict.vala"
				_g_free0 (coding);
#line 67 "user-dict.vala"
				_g_free0 (_tmp11_);
#line 67 "user-dict.vala"
				_g_free0 (line);
#line 67 "user-dict.vala"
				_g_object_unref0 (data);
#line 67 "user-dict.vala"
				_g_object_unref0 (memory);
#line 67 "user-dict.vala"
				contents = (g_free (contents), NULL);
#line 67 "user-dict.vala"
				return;
#line 746 "user-dict.c"
			} else {
#line 67 "user-dict.vala"
				_g_object_unref0 (entries);
#line 67 "user-dict.vala"
				_g_free0 (coding);
#line 67 "user-dict.vala"
				_g_free0 (_tmp11_);
#line 67 "user-dict.vala"
				_g_free0 (line);
#line 67 "user-dict.vala"
				_g_object_unref0 (data);
#line 67 "user-dict.vala"
				_g_object_unref0 (memory);
#line 67 "user-dict.vala"
				contents = (g_free (contents), NULL);
#line 67 "user-dict.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 67 "user-dict.vala"
				g_clear_error (&_inner_error0_);
#line 67 "user-dict.vala"
				return;
#line 768 "user-dict.c"
			}
		}
#line 67 "user-dict.vala"
		_tmp42_ = _tmp38_;
#line 67 "user-dict.vala"
		_tmp38_ = NULL;
#line 67 "user-dict.vala"
		_g_free0 (line);
#line 67 "user-dict.vala"
		line = _tmp42_;
#line 68 "user-dict.vala"
		_tmp43_ = line;
#line 68 "user-dict.vala"
		if (_tmp43_ == NULL) {
#line 69 "user-dict.vala"
			_g_free0 (_tmp38_);
#line 69 "user-dict.vala"
			break;
#line 787 "user-dict.c"
		}
#line 62 "user-dict.vala"
		_g_free0 (_tmp38_);
#line 791 "user-dict.c"
	}
#line 72 "user-dict.vala"
	_tmp44_ = entries;
#line 72 "user-dict.vala"
	if (_tmp44_ == NULL) {
#line 797 "user-dict.c"
		GError* _tmp45_;
#line 73 "user-dict.vala"
		_tmp45_ = g_error_new_literal (SKK_SKK_DICT_ERROR, SKK_SKK_DICT_ERROR_MALFORMED_INPUT, "no okuri-ari boundary");
#line 73 "user-dict.vala"
		_inner_error0_ = _tmp45_;
#line 73 "user-dict.vala"
		if ((_inner_error0_->domain == SKK_SKK_DICT_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 73 "user-dict.vala"
			g_propagate_error (error, _inner_error0_);
#line 73 "user-dict.vala"
			_g_object_unref0 (entries);
#line 73 "user-dict.vala"
			_g_free0 (coding);
#line 73 "user-dict.vala"
			_g_free0 (_tmp11_);
#line 73 "user-dict.vala"
			_g_free0 (line);
#line 73 "user-dict.vala"
			_g_object_unref0 (data);
#line 73 "user-dict.vala"
			_g_object_unref0 (memory);
#line 73 "user-dict.vala"
			contents = (g_free (contents), NULL);
#line 73 "user-dict.vala"
			return;
#line 823 "user-dict.c"
		} else {
#line 73 "user-dict.vala"
			_g_object_unref0 (entries);
#line 73 "user-dict.vala"
			_g_free0 (coding);
#line 73 "user-dict.vala"
			_g_free0 (_tmp11_);
#line 73 "user-dict.vala"
			_g_free0 (line);
#line 73 "user-dict.vala"
			_g_object_unref0 (data);
#line 73 "user-dict.vala"
			_g_object_unref0 (memory);
#line 73 "user-dict.vala"
			contents = (g_free (contents), NULL);
#line 73 "user-dict.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 73 "user-dict.vala"
			g_clear_error (&_inner_error0_);
#line 73 "user-dict.vala"
			return;
#line 845 "user-dict.c"
		}
	}
#line 77 "user-dict.vala"
	okuri = TRUE;
#line 78 "user-dict.vala"
	while (TRUE) {
#line 852 "user-dict.c"
		const gchar* _tmp46_;
		gchar* _tmp47_ = NULL;
		GDataInputStream* _tmp48_;
		gsize _tmp49_ = 0UL;
		gchar* _tmp50_;
		gchar* _tmp51_;
		const gchar* _tmp52_;
		const gchar* _tmp53_;
		gint index = 0;
		const gchar* _tmp65_;
		gchar* midasi = NULL;
		const gchar* _tmp68_;
		gchar* _tmp69_;
		gchar* candidates_str = NULL;
		const gchar* _tmp70_;
		const gchar* _tmp71_;
		gint _tmp72_;
		gint _tmp73_;
		gchar* _tmp74_;
		gboolean _tmp75_ = FALSE;
		const gchar* _tmp76_;
		SkkCandidate** candidates = NULL;
		const gchar* _tmp80_;
		const gchar* _tmp81_;
		gint _tmp82_ = 0;
		SkkCandidate** _tmp83_;
		gint candidates_length1;
		gint _candidates_size_;
		GeeArrayList* list = NULL;
		GeeArrayList* _tmp84_;
		SkkCandidate** _tmp85_;
		gint _tmp85__length1;
		GeeMap* _tmp89_;
		const gchar* _tmp90_;
		GeeArrayList* _tmp91_;
#line 78 "user-dict.vala"
		_tmp46_ = line;
#line 78 "user-dict.vala"
		if (!(_tmp46_ != NULL)) {
#line 78 "user-dict.vala"
			break;
#line 894 "user-dict.c"
		}
#line 79 "user-dict.vala"
		_tmp48_ = data;
#line 79 "user-dict.vala"
		_tmp50_ = g_data_input_stream_read_line (_tmp48_, &_tmp49_, NULL, &_inner_error0_);
#line 79 "user-dict.vala"
		length = _tmp49_;
#line 79 "user-dict.vala"
		_tmp47_ = _tmp50_;
#line 79 "user-dict.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "user-dict.vala"
			if ((_inner_error0_->domain == SKK_SKK_DICT_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 79 "user-dict.vala"
				g_propagate_error (error, _inner_error0_);
#line 79 "user-dict.vala"
				_g_object_unref0 (entries);
#line 79 "user-dict.vala"
				_g_free0 (coding);
#line 79 "user-dict.vala"
				_g_free0 (_tmp11_);
#line 79 "user-dict.vala"
				_g_free0 (line);
#line 79 "user-dict.vala"
				_g_object_unref0 (data);
#line 79 "user-dict.vala"
				_g_object_unref0 (memory);
#line 79 "user-dict.vala"
				contents = (g_free (contents), NULL);
#line 79 "user-dict.vala"
				return;
#line 926 "user-dict.c"
			} else {
#line 79 "user-dict.vala"
				_g_object_unref0 (entries);
#line 79 "user-dict.vala"
				_g_free0 (coding);
#line 79 "user-dict.vala"
				_g_free0 (_tmp11_);
#line 79 "user-dict.vala"
				_g_free0 (line);
#line 79 "user-dict.vala"
				_g_object_unref0 (data);
#line 79 "user-dict.vala"
				_g_object_unref0 (memory);
#line 79 "user-dict.vala"
				contents = (g_free (contents), NULL);
#line 79 "user-dict.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 79 "user-dict.vala"
				g_clear_error (&_inner_error0_);
#line 79 "user-dict.vala"
				return;
#line 948 "user-dict.c"
			}
		}
#line 79 "user-dict.vala"
		_tmp51_ = _tmp47_;
#line 79 "user-dict.vala"
		_tmp47_ = NULL;
#line 79 "user-dict.vala"
		_g_free0 (line);
#line 79 "user-dict.vala"
		line = _tmp51_;
#line 80 "user-dict.vala"
		_tmp52_ = line;
#line 80 "user-dict.vala"
		if (_tmp52_ == NULL) {
#line 81 "user-dict.vala"
			_g_free0 (_tmp47_);
#line 81 "user-dict.vala"
			break;
#line 967 "user-dict.c"
		}
#line 83 "user-dict.vala"
		_tmp53_ = line;
#line 83 "user-dict.vala"
		if (g_str_has_prefix (_tmp53_, ";; okuri-nasi entries.")) {
#line 973 "user-dict.c"
			GeeMap* _tmp54_;
			GeeMap* _tmp55_;
#line 84 "user-dict.vala"
			_tmp54_ = self->priv->okuri_nasi_entries;
#line 84 "user-dict.vala"
			_tmp55_ = _g_object_ref0 (_tmp54_);
#line 84 "user-dict.vala"
			_g_object_unref0 (entries);
#line 84 "user-dict.vala"
			entries = _tmp55_;
#line 85 "user-dict.vala"
			okuri = FALSE;
#line 86 "user-dict.vala"
			_g_free0 (_tmp47_);
#line 86 "user-dict.vala"
			continue;
#line 990 "user-dict.c"
		}
		{
			gchar* _tmp56_ = NULL;
			SkkEncodingConverter* _tmp57_;
			const gchar* _tmp58_;
			gchar* _tmp59_;
			gchar* _tmp60_;
#line 89 "user-dict.vala"
			_tmp57_ = self->priv->converter;
#line 89 "user-dict.vala"
			_tmp58_ = line;
#line 89 "user-dict.vala"
			_tmp59_ = skk_encoding_converter_decode (_tmp57_, _tmp58_, &_inner_error0_);
#line 89 "user-dict.vala"
			_tmp56_ = _tmp59_;
#line 89 "user-dict.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1008 "user-dict.c"
				goto __catch2_g_error;
			}
#line 89 "user-dict.vala"
			_tmp60_ = _tmp56_;
#line 89 "user-dict.vala"
			_tmp56_ = NULL;
#line 89 "user-dict.vala"
			_g_free0 (line);
#line 89 "user-dict.vala"
			line = _tmp60_;
#line 88 "user-dict.vala"
			_g_free0 (_tmp56_);
#line 1021 "user-dict.c"
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp61_;
			GError* _tmp62_;
			const gchar* _tmp63_;
			GError* _tmp64_;
#line 88 "user-dict.vala"
			e = _inner_error0_;
#line 88 "user-dict.vala"
			_inner_error0_ = NULL;
#line 91 "user-dict.vala"
			_tmp61_ = line;
#line 91 "user-dict.vala"
			_tmp62_ = e;
#line 91 "user-dict.vala"
			_tmp63_ = _tmp62_->message;
#line 91 "user-dict.vala"
			_tmp64_ = g_error_new (SKK_SKK_DICT_ERROR, SKK_SKK_DICT_ERROR_MALFORMED_INPUT, "can't decode line %s: %s", _tmp61_, _tmp63_);
#line 91 "user-dict.vala"
			_inner_error0_ = _tmp64_;
#line 91 "user-dict.vala"
			_g_error_free0 (e);
#line 1047 "user-dict.c"
			goto __finally2;
		}
		__finally2:
#line 88 "user-dict.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 88 "user-dict.vala"
			if ((_inner_error0_->domain == SKK_SKK_DICT_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 88 "user-dict.vala"
				g_propagate_error (error, _inner_error0_);
#line 88 "user-dict.vala"
				_g_free0 (_tmp47_);
#line 88 "user-dict.vala"
				_g_object_unref0 (entries);
#line 88 "user-dict.vala"
				_g_free0 (coding);
#line 88 "user-dict.vala"
				_g_free0 (_tmp11_);
#line 88 "user-dict.vala"
				_g_free0 (line);
#line 88 "user-dict.vala"
				_g_object_unref0 (data);
#line 88 "user-dict.vala"
				_g_object_unref0 (memory);
#line 88 "user-dict.vala"
				contents = (g_free (contents), NULL);
#line 88 "user-dict.vala"
				return;
#line 1075 "user-dict.c"
			} else {
#line 88 "user-dict.vala"
				_g_free0 (_tmp47_);
#line 88 "user-dict.vala"
				_g_object_unref0 (entries);
#line 88 "user-dict.vala"
				_g_free0 (coding);
#line 88 "user-dict.vala"
				_g_free0 (_tmp11_);
#line 88 "user-dict.vala"
				_g_free0 (line);
#line 88 "user-dict.vala"
				_g_object_unref0 (data);
#line 88 "user-dict.vala"
				_g_object_unref0 (memory);
#line 88 "user-dict.vala"
				contents = (g_free (contents), NULL);
#line 88 "user-dict.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 88 "user-dict.vala"
				g_clear_error (&_inner_error0_);
#line 88 "user-dict.vala"
				return;
#line 1099 "user-dict.c"
			}
		}
#line 94 "user-dict.vala"
		_tmp65_ = line;
#line 94 "user-dict.vala"
		index = string_index_of (_tmp65_, " ", 0);
#line 95 "user-dict.vala"
		if (index < 1) {
#line 1108 "user-dict.c"
			const gchar* _tmp66_;
			GError* _tmp67_;
#line 96 "user-dict.vala"
			_tmp66_ = line;
#line 96 "user-dict.vala"
			_tmp67_ = g_error_new (SKK_SKK_DICT_ERROR, SKK_SKK_DICT_ERROR_MALFORMED_INPUT, "can't extract midasi from line %s", _tmp66_);
#line 96 "user-dict.vala"
			_inner_error0_ = _tmp67_;
#line 96 "user-dict.vala"
			if ((_inner_error0_->domain == SKK_SKK_DICT_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 96 "user-dict.vala"
				g_propagate_error (error, _inner_error0_);
#line 96 "user-dict.vala"
				_g_free0 (_tmp47_);
#line 96 "user-dict.vala"
				_g_object_unref0 (entries);
#line 96 "user-dict.vala"
				_g_free0 (coding);
#line 96 "user-dict.vala"
				_g_free0 (_tmp11_);
#line 96 "user-dict.vala"
				_g_free0 (line);
#line 96 "user-dict.vala"
				_g_object_unref0 (data);
#line 96 "user-dict.vala"
				_g_object_unref0 (memory);
#line 96 "user-dict.vala"
				contents = (g_free (contents), NULL);
#line 96 "user-dict.vala"
				return;
#line 1139 "user-dict.c"
			} else {
#line 96 "user-dict.vala"
				_g_free0 (_tmp47_);
#line 96 "user-dict.vala"
				_g_object_unref0 (entries);
#line 96 "user-dict.vala"
				_g_free0 (coding);
#line 96 "user-dict.vala"
				_g_free0 (_tmp11_);
#line 96 "user-dict.vala"
				_g_free0 (line);
#line 96 "user-dict.vala"
				_g_object_unref0 (data);
#line 96 "user-dict.vala"
				_g_object_unref0 (memory);
#line 96 "user-dict.vala"
				contents = (g_free (contents), NULL);
#line 96 "user-dict.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 96 "user-dict.vala"
				g_clear_error (&_inner_error0_);
#line 96 "user-dict.vala"
				return;
#line 1163 "user-dict.c"
			}
		}
#line 101 "user-dict.vala"
		_tmp68_ = line;
#line 101 "user-dict.vala"
		_tmp69_ = string_slice (_tmp68_, (glong) 0, (glong) index);
#line 101 "user-dict.vala"
		midasi = _tmp69_;
#line 102 "user-dict.vala"
		_tmp70_ = line;
#line 102 "user-dict.vala"
		_tmp71_ = line;
#line 102 "user-dict.vala"
		_tmp72_ = strlen (_tmp71_);
#line 102 "user-dict.vala"
		_tmp73_ = _tmp72_;
#line 102 "user-dict.vala"
		_tmp74_ = string_slice (_tmp70_, (glong) (index + 1), (glong) _tmp73_);
#line 102 "user-dict.vala"
		candidates_str = _tmp74_;
#line 103 "user-dict.vala"
		_tmp76_ = candidates_str;
#line 103 "user-dict.vala"
		if (!g_str_has_prefix (_tmp76_, "/")) {
#line 103 "user-dict.vala"
			_tmp75_ = TRUE;
#line 1190 "user-dict.c"
		} else {
			const gchar* _tmp77_;
#line 104 "user-dict.vala"
			_tmp77_ = candidates_str;
#line 104 "user-dict.vala"
			_tmp75_ = !g_str_has_suffix (_tmp77_, "/");
#line 1197 "user-dict.c"
		}
#line 103 "user-dict.vala"
		if (_tmp75_) {
#line 1201 "user-dict.c"
			const gchar* _tmp78_;
			GError* _tmp79_;
#line 105 "user-dict.vala"
			_tmp78_ = candidates_str;
#line 105 "user-dict.vala"
			_tmp79_ = g_error_new (SKK_SKK_DICT_ERROR, SKK_SKK_DICT_ERROR_MALFORMED_INPUT, "can't parse candidates list %s", _tmp78_);
#line 105 "user-dict.vala"
			_inner_error0_ = _tmp79_;
#line 105 "user-dict.vala"
			if ((_inner_error0_->domain == SKK_SKK_DICT_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 105 "user-dict.vala"
				g_propagate_error (error, _inner_error0_);
#line 105 "user-dict.vala"
				_g_free0 (candidates_str);
#line 105 "user-dict.vala"
				_g_free0 (midasi);
#line 105 "user-dict.vala"
				_g_free0 (_tmp47_);
#line 105 "user-dict.vala"
				_g_object_unref0 (entries);
#line 105 "user-dict.vala"
				_g_free0 (coding);
#line 105 "user-dict.vala"
				_g_free0 (_tmp11_);
#line 105 "user-dict.vala"
				_g_free0 (line);
#line 105 "user-dict.vala"
				_g_object_unref0 (data);
#line 105 "user-dict.vala"
				_g_object_unref0 (memory);
#line 105 "user-dict.vala"
				contents = (g_free (contents), NULL);
#line 105 "user-dict.vala"
				return;
#line 1236 "user-dict.c"
			} else {
#line 105 "user-dict.vala"
				_g_free0 (candidates_str);
#line 105 "user-dict.vala"
				_g_free0 (midasi);
#line 105 "user-dict.vala"
				_g_free0 (_tmp47_);
#line 105 "user-dict.vala"
				_g_object_unref0 (entries);
#line 105 "user-dict.vala"
				_g_free0 (coding);
#line 105 "user-dict.vala"
				_g_free0 (_tmp11_);
#line 105 "user-dict.vala"
				_g_free0 (line);
#line 105 "user-dict.vala"
				_g_object_unref0 (data);
#line 105 "user-dict.vala"
				_g_object_unref0 (memory);
#line 105 "user-dict.vala"
				contents = (g_free (contents), NULL);
#line 105 "user-dict.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 105 "user-dict.vala"
				g_clear_error (&_inner_error0_);
#line 105 "user-dict.vala"
				return;
#line 1264 "user-dict.c"
			}
		}
#line 110 "user-dict.vala"
		_tmp80_ = midasi;
#line 110 "user-dict.vala"
		_tmp81_ = candidates_str;
#line 110 "user-dict.vala"
		_tmp83_ = skk_dict_split_candidates ((SkkDict*) self, _tmp80_, okuri, _tmp81_, &_tmp82_);
#line 110 "user-dict.vala"
		candidates = _tmp83_;
#line 110 "user-dict.vala"
		candidates_length1 = _tmp82_;
#line 110 "user-dict.vala"
		_candidates_size_ = candidates_length1;
#line 113 "user-dict.vala"
		_tmp84_ = gee_array_list_new (SKK_TYPE_CANDIDATE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 113 "user-dict.vala"
		list = _tmp84_;
#line 114 "user-dict.vala"
		_tmp85_ = candidates;
#line 114 "user-dict.vala"
		_tmp85__length1 = candidates_length1;
#line 1287 "user-dict.c"
		{
			SkkCandidate** c_collection = NULL;
			gint c_collection_length1 = 0;
			gint _c_collection_size_ = 0;
			gint c_it = 0;
#line 114 "user-dict.vala"
			c_collection = _tmp85_;
#line 114 "user-dict.vala"
			c_collection_length1 = _tmp85__length1;
#line 114 "user-dict.vala"
			for (c_it = 0; c_it < c_collection_length1; c_it = c_it + 1) {
#line 1299 "user-dict.c"
				SkkCandidate* _tmp86_;
				SkkCandidate* c = NULL;
#line 114 "user-dict.vala"
				_tmp86_ = _g_object_ref0 (c_collection[c_it]);
#line 114 "user-dict.vala"
				c = _tmp86_;
#line 1306 "user-dict.c"
				{
					GeeArrayList* _tmp87_;
					SkkCandidate* _tmp88_;
#line 115 "user-dict.vala"
					_tmp87_ = list;
#line 115 "user-dict.vala"
					_tmp88_ = c;
#line 115 "user-dict.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp87_, _tmp88_);
#line 114 "user-dict.vala"
					_g_object_unref0 (c);
#line 1318 "user-dict.c"
				}
			}
		}
#line 117 "user-dict.vala"
		_tmp89_ = entries;
#line 117 "user-dict.vala"
		_tmp90_ = midasi;
#line 117 "user-dict.vala"
		_tmp91_ = list;
#line 117 "user-dict.vala"
		gee_map_set (_tmp89_, _tmp90_, (GeeList*) _tmp91_);
#line 78 "user-dict.vala"
		_g_object_unref0 (list);
#line 78 "user-dict.vala"
		candidates = (_vala_array_free (candidates, candidates_length1, (GDestroyNotify) g_object_unref), NULL);
#line 78 "user-dict.vala"
		_g_free0 (candidates_str);
#line 78 "user-dict.vala"
		_g_free0 (midasi);
#line 78 "user-dict.vala"
		_g_free0 (_tmp47_);
#line 1340 "user-dict.c"
	}
#line 25 "user-dict.vala"
	_g_object_unref0 (entries);
#line 25 "user-dict.vala"
	_g_free0 (coding);
#line 25 "user-dict.vala"
	_g_free0 (_tmp11_);
#line 25 "user-dict.vala"
	_g_free0 (line);
#line 25 "user-dict.vala"
	_g_object_unref0 (data);
#line 25 "user-dict.vala"
	_g_object_unref0 (memory);
#line 25 "user-dict.vala"
	contents = (g_free (contents), NULL);
#line 1356 "user-dict.c"
}

/**
         * {@inheritDoc}
         */
static void
skk_user_dict_real_reload (SkkDict* base,
                           GError** error)
{
	SkkUserDict * self;
	gchar* attributes = NULL;
	gchar* _tmp0_;
	GFileInfo* info = NULL;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 124 "user-dict.vala"
	self = (SkkUserDict*) base;
#line 126 "user-dict.vala"
	_tmp0_ = g_strdup (G_FILE_ATTRIBUTE_ETAG_VALUE);
#line 126 "user-dict.vala"
	attributes = _tmp0_;
#line 130 "user-dict.vala"
	_tmp1_ = self->priv->file;
#line 130 "user-dict.vala"
	_tmp2_ = g_file_query_info (_tmp1_, attributes, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 130 "user-dict.vala"
	info = _tmp2_;
#line 130 "user-dict.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 130 "user-dict.vala"
		g_propagate_error (error, _inner_error0_);
#line 130 "user-dict.vala"
		_g_free0 (attributes);
#line 130 "user-dict.vala"
		return;
#line 1395 "user-dict.c"
	}
#line 132 "user-dict.vala"
	_tmp3_ = g_file_info_get_etag (info);
#line 132 "user-dict.vala"
	_tmp4_ = self->priv->etag;
#line 132 "user-dict.vala"
	if (g_strcmp0 (_tmp3_, _tmp4_) != 0) {
#line 1403 "user-dict.c"
		GeeMap* _tmp5_;
		GeeMap* _tmp6_;
#line 133 "user-dict.vala"
		_tmp5_ = self->priv->okuri_ari_entries;
#line 133 "user-dict.vala"
		gee_map_clear (_tmp5_);
#line 134 "user-dict.vala"
		_tmp6_ = self->priv->okuri_nasi_entries;
#line 134 "user-dict.vala"
		gee_map_clear (_tmp6_);
#line 1414 "user-dict.c"
		{
#line 136 "user-dict.vala"
			skk_user_dict_load (self, &_inner_error0_);
#line 136 "user-dict.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 136 "user-dict.vala"
				if (_inner_error0_->domain == SKK_SKK_DICT_ERROR) {
#line 1422 "user-dict.c"
					goto __catch0_skk_skk_dict_error;
				}
#line 136 "user-dict.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 1427 "user-dict.c"
					goto __catch0_g_io_error;
				}
#line 136 "user-dict.vala"
				_g_object_unref0 (info);
#line 136 "user-dict.vala"
				_g_free0 (attributes);
#line 136 "user-dict.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 136 "user-dict.vala"
				g_clear_error (&_inner_error0_);
#line 136 "user-dict.vala"
				return;
#line 1440 "user-dict.c"
			}
		}
		goto __finally0;
		__catch0_skk_skk_dict_error:
		{
			GError* e = NULL;
			GFile* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			GError* _tmp10_;
			const gchar* _tmp11_;
#line 135 "user-dict.vala"
			e = _inner_error0_;
#line 135 "user-dict.vala"
			_inner_error0_ = NULL;
#line 138 "user-dict.vala"
			_tmp7_ = self->priv->file;
#line 138 "user-dict.vala"
			_tmp8_ = g_file_get_path (_tmp7_);
#line 138 "user-dict.vala"
			_tmp9_ = _tmp8_;
#line 138 "user-dict.vala"
			_tmp10_ = e;
#line 138 "user-dict.vala"
			_tmp11_ = _tmp10_->message;
#line 138 "user-dict.vala"
			g_warning ("user-dict.vala:138: error parsing user dictionary %s: %s", _tmp9_, _tmp11_);
#line 138 "user-dict.vala"
			_g_free0 (_tmp9_);
#line 135 "user-dict.vala"
			_g_error_free0 (e);
#line 1472 "user-dict.c"
		}
		goto __finally0;
		__catch0_g_io_error:
		{
			GError* e = NULL;
			GFile* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			GError* _tmp15_;
			const gchar* _tmp16_;
#line 135 "user-dict.vala"
			e = _inner_error0_;
#line 135 "user-dict.vala"
			_inner_error0_ = NULL;
#line 141 "user-dict.vala"
			_tmp12_ = self->priv->file;
#line 141 "user-dict.vala"
			_tmp13_ = g_file_get_path (_tmp12_);
#line 141 "user-dict.vala"
			_tmp14_ = _tmp13_;
#line 141 "user-dict.vala"
			_tmp15_ = e;
#line 141 "user-dict.vala"
			_tmp16_ = _tmp15_->message;
#line 141 "user-dict.vala"
			g_warning ("user-dict.vala:141: error reading user dictionary %s: %s", _tmp14_, _tmp16_);
#line 141 "user-dict.vala"
			_g_free0 (_tmp14_);
#line 135 "user-dict.vala"
			_g_error_free0 (e);
#line 1503 "user-dict.c"
		}
		__finally0:
#line 135 "user-dict.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 135 "user-dict.vala"
			g_propagate_error (error, _inner_error0_);
#line 135 "user-dict.vala"
			_g_object_unref0 (info);
#line 135 "user-dict.vala"
			_g_free0 (attributes);
#line 135 "user-dict.vala"
			return;
#line 1516 "user-dict.c"
		}
	}
#line 124 "user-dict.vala"
	_g_object_unref0 (info);
#line 124 "user-dict.vala"
	_g_free0 (attributes);
#line 1523 "user-dict.c"
}

static gint
skk_user_dict_compare_entry_asc (GeeMapEntry* a,
                                 GeeMapEntry* b)
{
	GCompareFunc _tmp0_;
	gconstpointer _tmp1_;
	gconstpointer _tmp2_;
	gconstpointer _tmp3_;
	gconstpointer _tmp4_;
	gint result;
#line 147 "user-dict.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 147 "user-dict.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 150 "user-dict.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 150 "user-dict.vala"
	_tmp1_ = gee_map_entry_get_key (a);
#line 150 "user-dict.vala"
	_tmp2_ = _tmp1_;
#line 150 "user-dict.vala"
	_tmp3_ = gee_map_entry_get_key (b);
#line 150 "user-dict.vala"
	_tmp4_ = _tmp3_;
#line 150 "user-dict.vala"
	result = _tmp0_ ((const gchar*) _tmp2_, (const gchar*) _tmp4_);
#line 150 "user-dict.vala"
	return result;
#line 1554 "user-dict.c"
}

static gint
skk_user_dict_compare_entry_dsc (GeeMapEntry* a,
                                 GeeMapEntry* b)
{
	GCompareFunc _tmp0_;
	gconstpointer _tmp1_;
	gconstpointer _tmp2_;
	gconstpointer _tmp3_;
	gconstpointer _tmp4_;
	gint result;
#line 153 "user-dict.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 153 "user-dict.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 156 "user-dict.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 156 "user-dict.vala"
	_tmp1_ = gee_map_entry_get_key (b);
#line 156 "user-dict.vala"
	_tmp2_ = _tmp1_;
#line 156 "user-dict.vala"
	_tmp3_ = gee_map_entry_get_key (a);
#line 156 "user-dict.vala"
	_tmp4_ = _tmp3_;
#line 156 "user-dict.vala"
	result = _tmp0_ ((const gchar*) _tmp2_, (const gchar*) _tmp4_);
#line 156 "user-dict.vala"
	return result;
#line 1585 "user-dict.c"
}

static void
skk_user_dict_write_entries (SkkUserDict* self,
                             GString* builder,
                             GeeList* entries)
{
	GeeIterator* iter = NULL;
	GeeIterator* _tmp0_;
#line 159 "user-dict.vala"
	g_return_if_fail (self != NULL);
#line 159 "user-dict.vala"
	g_return_if_fail (builder != NULL);
#line 159 "user-dict.vala"
	g_return_if_fail (entries != NULL);
#line 162 "user-dict.vala"
	_tmp0_ = gee_iterable_iterator ((GeeIterable*) entries);
#line 162 "user-dict.vala"
	iter = _tmp0_;
#line 163 "user-dict.vala"
	while (TRUE) {
#line 1607 "user-dict.c"
		GeeIterator* _tmp1_;
		GeeMapEntry* entry = NULL;
		GeeIterator* _tmp2_;
		gpointer _tmp3_;
		gchar* line = NULL;
		GeeMapEntry* _tmp4_;
		gconstpointer _tmp5_;
		gconstpointer _tmp6_;
		GeeMapEntry* _tmp7_;
		gconstpointer _tmp8_;
		gconstpointer _tmp9_;
		gint _tmp10_ = 0;
		gpointer* _tmp11_;
		SkkCandidate** _tmp12_;
		gint _tmp12__length1;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
#line 163 "user-dict.vala"
		_tmp1_ = iter;
#line 163 "user-dict.vala"
		if (!gee_iterator_next (_tmp1_)) {
#line 163 "user-dict.vala"
			break;
#line 1634 "user-dict.c"
		}
#line 164 "user-dict.vala"
		_tmp2_ = iter;
#line 164 "user-dict.vala"
		_tmp3_ = gee_iterator_get (_tmp2_);
#line 164 "user-dict.vala"
		entry = (GeeMapEntry*) _tmp3_;
#line 165 "user-dict.vala"
		_tmp4_ = entry;
#line 165 "user-dict.vala"
		_tmp5_ = gee_map_entry_get_key (_tmp4_);
#line 165 "user-dict.vala"
		_tmp6_ = _tmp5_;
#line 165 "user-dict.vala"
		_tmp7_ = entry;
#line 165 "user-dict.vala"
		_tmp8_ = gee_map_entry_get_value (_tmp7_);
#line 165 "user-dict.vala"
		_tmp9_ = _tmp8_;
#line 165 "user-dict.vala"
		_tmp11_ = gee_collection_to_array ((GeeCollection*) ((GeeList*) _tmp9_), &_tmp10_);
#line 165 "user-dict.vala"
		_tmp12_ = _tmp11_;
#line 165 "user-dict.vala"
		_tmp12__length1 = _tmp10_;
#line 165 "user-dict.vala"
		_tmp13_ = skk_dict_join_candidates ((SkkDict*) self, _tmp12_, (gint) _tmp10_);
#line 165 "user-dict.vala"
		_tmp14_ = _tmp13_;
#line 165 "user-dict.vala"
		_tmp15_ = g_strdup_printf ("%s %s\n", (const gchar*) _tmp6_, _tmp14_);
#line 165 "user-dict.vala"
		_tmp16_ = _tmp15_;
#line 165 "user-dict.vala"
		_g_free0 (_tmp14_);
#line 165 "user-dict.vala"
		_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_object_unref), NULL);
#line 165 "user-dict.vala"
		line = _tmp16_;
#line 168 "user-dict.vala"
		_tmp17_ = line;
#line 168 "user-dict.vala"
		g_string_append (builder, _tmp17_);
#line 163 "user-dict.vala"
		_g_free0 (line);
#line 163 "user-dict.vala"
		_g_object_unref0 (entry);
#line 1682 "user-dict.c"
	}
#line 159 "user-dict.vala"
	_g_object_unref0 (iter);
#line 1686 "user-dict.c"
}

/**
         * {@inheritDoc}
         */
static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 1726 "user-dict.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 1732 "user-dict.c"
}

static void
skk_user_dict_real_save (SkkDict* base,
                         GError** error)
{
	SkkUserDict * self;
	GString* builder = NULL;
	GString* _tmp0_;
	gchar* coding = NULL;
	SkkEncodingConverter* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	GString* _tmp8_;
	GeeArrayList* entries = NULL;
	GeeArrayList* _tmp9_;
	GeeArrayList* _tmp10_;
	GeeMap* _tmp11_;
	GeeSet* _tmp12_;
	GeeSet* _tmp13_;
	GeeSet* _tmp14_;
	GeeArrayList* _tmp15_;
	GString* _tmp16_;
	GeeArrayList* _tmp17_;
	GeeArrayList* _tmp18_;
	GString* _tmp19_;
	GeeArrayList* _tmp20_;
	GeeMap* _tmp21_;
	GeeSet* _tmp22_;
	GeeSet* _tmp23_;
	GeeSet* _tmp24_;
	GeeArrayList* _tmp25_;
	GString* _tmp26_;
	GeeArrayList* _tmp27_;
	GeeArrayList* _tmp28_;
	gchar* contents = NULL;
	SkkEncodingConverter* _tmp29_;
	GString* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	GFile* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	GFile* _tmp38_;
	const gchar* _tmp39_;
	guint8* _tmp40_;
	gint _tmp40__length1;
	gint _tmp41_ = 0;
	guint8* _tmp42_;
	gint _tmp42__length1;
	const gchar* _tmp43_;
	gchar* _tmp44_ = NULL;
	GError* _inner_error0_ = NULL;
#line 175 "user-dict.vala"
	self = (SkkUserDict*) base;
#line 176 "user-dict.vala"
	_tmp0_ = g_string_new ("");
#line 176 "user-dict.vala"
	builder = _tmp0_;
#line 177 "user-dict.vala"
	_tmp1_ = self->priv->converter;
#line 177 "user-dict.vala"
	_tmp2_ = skk_encoding_converter_get_coding_system (_tmp1_);
#line 177 "user-dict.vala"
	coding = _tmp2_;
#line 178 "user-dict.vala"
	_tmp3_ = coding;
#line 178 "user-dict.vala"
	if (_tmp3_ != NULL) {
#line 1804 "user-dict.c"
		GString* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 179 "user-dict.vala"
		_tmp4_ = builder;
#line 179 "user-dict.vala"
		_tmp5_ = coding;
#line 179 "user-dict.vala"
		_tmp6_ = g_strdup_printf (";;; -*- coding: %s -*-\n", _tmp5_);
#line 179 "user-dict.vala"
		_tmp7_ = _tmp6_;
#line 179 "user-dict.vala"
		g_string_append (_tmp4_, _tmp7_);
#line 179 "user-dict.vala"
		_g_free0 (_tmp7_);
#line 1821 "user-dict.c"
	}
#line 182 "user-dict.vala"
	_tmp8_ = builder;
#line 182 "user-dict.vala"
	g_string_append (_tmp8_, ";; okuri-ari entries.\n");
#line 183 "user-dict.vala"
	_tmp9_ = gee_array_list_new (GEE_MAP_TYPE_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 183 "user-dict.vala"
	entries = _tmp9_;
#line 184 "user-dict.vala"
	_tmp10_ = entries;
#line 184 "user-dict.vala"
	_tmp11_ = self->priv->okuri_ari_entries;
#line 184 "user-dict.vala"
	_tmp12_ = gee_map_get_entries (_tmp11_);
#line 184 "user-dict.vala"
	_tmp13_ = _tmp12_;
#line 184 "user-dict.vala"
	_tmp14_ = _tmp13_;
#line 184 "user-dict.vala"
	gee_array_list_add_all (_tmp10_, (GeeCollection*) _tmp14_);
#line 184 "user-dict.vala"
	_g_object_unref0 (_tmp14_);
#line 185 "user-dict.vala"
	_tmp15_ = entries;
#line 185 "user-dict.vala"
	gee_list_sort ((GeeList*) _tmp15_, (GCompareDataFunc) skk_user_dict_compare_entry_dsc, NULL, NULL);
#line 186 "user-dict.vala"
	_tmp16_ = builder;
#line 186 "user-dict.vala"
	_tmp17_ = entries;
#line 186 "user-dict.vala"
	skk_user_dict_write_entries (self, _tmp16_, (GeeList*) _tmp17_);
#line 187 "user-dict.vala"
	_tmp18_ = entries;
#line 187 "user-dict.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp18_);
#line 189 "user-dict.vala"
	_tmp19_ = builder;
#line 189 "user-dict.vala"
	g_string_append (_tmp19_, ";; okuri-nasi entries.\n");
#line 190 "user-dict.vala"
	_tmp20_ = entries;
#line 190 "user-dict.vala"
	_tmp21_ = self->priv->okuri_nasi_entries;
#line 190 "user-dict.vala"
	_tmp22_ = gee_map_get_entries (_tmp21_);
#line 190 "user-dict.vala"
	_tmp23_ = _tmp22_;
#line 190 "user-dict.vala"
	_tmp24_ = _tmp23_;
#line 190 "user-dict.vala"
	gee_array_list_add_all (_tmp20_, (GeeCollection*) _tmp24_);
#line 190 "user-dict.vala"
	_g_object_unref0 (_tmp24_);
#line 191 "user-dict.vala"
	_tmp25_ = entries;
#line 191 "user-dict.vala"
	gee_list_sort ((GeeList*) _tmp25_, (GCompareDataFunc) skk_user_dict_compare_entry_asc, NULL, NULL);
#line 192 "user-dict.vala"
	_tmp26_ = builder;
#line 192 "user-dict.vala"
	_tmp27_ = entries;
#line 192 "user-dict.vala"
	skk_user_dict_write_entries (self, _tmp26_, (GeeList*) _tmp27_);
#line 193 "user-dict.vala"
	_tmp28_ = entries;
#line 193 "user-dict.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp28_);
#line 195 "user-dict.vala"
	_tmp29_ = self->priv->converter;
#line 195 "user-dict.vala"
	_tmp30_ = builder;
#line 195 "user-dict.vala"
	_tmp31_ = _tmp30_->str;
#line 195 "user-dict.vala"
	_tmp32_ = skk_encoding_converter_encode (_tmp29_, _tmp31_, &_inner_error0_);
#line 195 "user-dict.vala"
	contents = _tmp32_;
#line 195 "user-dict.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 195 "user-dict.vala"
		g_propagate_error (error, _inner_error0_);
#line 195 "user-dict.vala"
		_g_object_unref0 (entries);
#line 195 "user-dict.vala"
		_g_free0 (coding);
#line 195 "user-dict.vala"
		_g_string_free0 (builder);
#line 195 "user-dict.vala"
		return;
#line 1913 "user-dict.c"
	}
#line 196 "user-dict.vala"
	_tmp33_ = self->priv->file;
#line 196 "user-dict.vala"
	_tmp34_ = g_file_get_path (_tmp33_);
#line 196 "user-dict.vala"
	_tmp35_ = _tmp34_;
#line 196 "user-dict.vala"
	_tmp36_ = g_path_get_dirname (_tmp35_);
#line 196 "user-dict.vala"
	_tmp37_ = _tmp36_;
#line 196 "user-dict.vala"
	g_mkdir_with_parents (_tmp37_, 448);
#line 196 "user-dict.vala"
	_g_free0 (_tmp37_);
#line 196 "user-dict.vala"
	_g_free0 (_tmp35_);
#line 199 "user-dict.vala"
	_tmp38_ = self->priv->file;
#line 199 "user-dict.vala"
	_tmp39_ = contents;
#line 199 "user-dict.vala"
	_tmp40_ = string_get_data (_tmp39_, &_tmp41_);
#line 199 "user-dict.vala"
	_tmp40__length1 = _tmp41_;
#line 199 "user-dict.vala"
	_tmp42_ = _tmp40_;
#line 199 "user-dict.vala"
	_tmp42__length1 = _tmp40__length1;
#line 199 "user-dict.vala"
	_tmp43_ = self->priv->etag;
#line 199 "user-dict.vala"
	g_file_replace_contents (_tmp38_, (const char*) _tmp42_, (gsize) _tmp42__length1, _tmp43_, FALSE, G_FILE_CREATE_PRIVATE, &_tmp44_, NULL, &_inner_error0_);
#line 199 "user-dict.vala"
	_g_free0 (self->priv->etag);
#line 199 "user-dict.vala"
	self->priv->etag = _tmp44_;
#line 199 "user-dict.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "user-dict.vala"
		g_propagate_error (error, _inner_error0_);
#line 199 "user-dict.vala"
		_g_free0 (contents);
#line 199 "user-dict.vala"
		_g_object_unref0 (entries);
#line 199 "user-dict.vala"
		_g_free0 (coding);
#line 199 "user-dict.vala"
		_g_string_free0 (builder);
#line 199 "user-dict.vala"
		return;
#line 1965 "user-dict.c"
	}
#line 175 "user-dict.vala"
	_g_free0 (contents);
#line 175 "user-dict.vala"
	_g_object_unref0 (entries);
#line 175 "user-dict.vala"
	_g_free0 (coding);
#line 175 "user-dict.vala"
	_g_string_free0 (builder);
#line 1975 "user-dict.c"
}

static GeeMap*
skk_user_dict_get_entries (SkkUserDict* self,
                           gboolean okuri)
{
	GeeMap* result;
#line 214 "user-dict.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 215 "user-dict.vala"
	if (okuri) {
#line 1987 "user-dict.c"
		GeeMap* _tmp0_;
		GeeMap* _tmp1_;
#line 216 "user-dict.vala"
		_tmp0_ = self->priv->okuri_ari_entries;
#line 216 "user-dict.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 216 "user-dict.vala"
		result = _tmp1_;
#line 216 "user-dict.vala"
		return result;
#line 1998 "user-dict.c"
	} else {
		GeeMap* _tmp2_;
		GeeMap* _tmp3_;
#line 218 "user-dict.vala"
		_tmp2_ = self->priv->okuri_nasi_entries;
#line 218 "user-dict.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 218 "user-dict.vala"
		result = _tmp3_;
#line 218 "user-dict.vala"
		return result;
#line 2010 "user-dict.c"
	}
}

/**
         * {@inheritDoc}
         */
static SkkCandidate**
skk_user_dict_real_lookup (SkkDict* base,
                           const gchar* midasi,
                           gboolean okuri,
                           gint* result_length1)
{
	SkkUserDict * self;
	GeeMap* entries = NULL;
	GeeMap* _tmp0_;
	GeeMap* _tmp1_;
	SkkCandidate** result;
#line 225 "user-dict.vala"
	self = (SkkUserDict*) base;
#line 225 "user-dict.vala"
	g_return_val_if_fail (midasi != NULL, NULL);
#line 226 "user-dict.vala"
	_tmp0_ = skk_user_dict_get_entries (self, okuri);
#line 226 "user-dict.vala"
	entries = _tmp0_;
#line 227 "user-dict.vala"
	_tmp1_ = entries;
#line 227 "user-dict.vala"
	if (gee_map_has_key (_tmp1_, midasi)) {
#line 2040 "user-dict.c"
		GeeMap* _tmp2_;
		gpointer _tmp3_;
		GeeList* _tmp4_;
		gint _tmp5_ = 0;
		gpointer* _tmp6_;
		SkkCandidate** _tmp7_;
		gint _tmp7__length1;
		SkkCandidate** _tmp8_;
		gint _tmp8__length1;
#line 228 "user-dict.vala"
		_tmp2_ = entries;
#line 228 "user-dict.vala"
		_tmp3_ = gee_map_get (_tmp2_, midasi);
#line 228 "user-dict.vala"
		_tmp4_ = (GeeList*) _tmp3_;
#line 228 "user-dict.vala"
		_tmp6_ = gee_collection_to_array ((GeeCollection*) _tmp4_, &_tmp5_);
#line 228 "user-dict.vala"
		_tmp7_ = _tmp6_;
#line 228 "user-dict.vala"
		_tmp7__length1 = _tmp5_;
#line 228 "user-dict.vala"
		_g_object_unref0 (_tmp4_);
#line 228 "user-dict.vala"
		_tmp8_ = _tmp7_;
#line 228 "user-dict.vala"
		_tmp8__length1 = _tmp7__length1;
#line 228 "user-dict.vala"
		if (result_length1) {
#line 228 "user-dict.vala"
			*result_length1 = _tmp8__length1;
#line 2072 "user-dict.c"
		}
#line 228 "user-dict.vala"
		result = _tmp8_;
#line 228 "user-dict.vala"
		_g_object_unref0 (entries);
#line 228 "user-dict.vala"
		return result;
#line 2080 "user-dict.c"
	} else {
		SkkCandidate** _tmp9_;
		SkkCandidate** _tmp10_;
		gint _tmp10__length1;
#line 230 "user-dict.vala"
		_tmp9_ = g_new0 (SkkCandidate*, 0 + 1);
#line 230 "user-dict.vala"
		_tmp10_ = _tmp9_;
#line 230 "user-dict.vala"
		_tmp10__length1 = 0;
#line 230 "user-dict.vala"
		if (result_length1) {
#line 230 "user-dict.vala"
			*result_length1 = _tmp10__length1;
#line 2095 "user-dict.c"
		}
#line 230 "user-dict.vala"
		result = _tmp10_;
#line 230 "user-dict.vala"
		_g_object_unref0 (entries);
#line 230 "user-dict.vala"
		return result;
#line 2103 "user-dict.c"
	}
}

/**
         * {@inheritDoc}
         */
static gchar**
skk_user_dict_real_complete (SkkDict* base,
                             const gchar* midasi,
                             gint* result_length1)
{
	SkkUserDict * self;
	GeeList* completion = NULL;
	GeeArrayList* _tmp0_;
	GeeList* keys = NULL;
	GeeArrayList* _tmp1_;
	GeeList* _tmp2_;
	GeeMap* _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
	GeeSet* _tmp6_;
	GeeList* _tmp7_;
	GeeIterator* iter = NULL;
	GeeList* _tmp8_;
	GeeIterator* _tmp9_;
	GeeList* _tmp24_;
	gint _tmp25_ = 0;
	gpointer* _tmp26_;
	gchar** _tmp27_;
	gint _tmp27__length1;
	gchar** result;
#line 237 "user-dict.vala"
	self = (SkkUserDict*) base;
#line 237 "user-dict.vala"
	g_return_val_if_fail (midasi != NULL, NULL);
#line 238 "user-dict.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 238 "user-dict.vala"
	completion = (GeeList*) _tmp0_;
#line 239 "user-dict.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 239 "user-dict.vala"
	keys = (GeeList*) _tmp1_;
#line 240 "user-dict.vala"
	_tmp2_ = keys;
#line 240 "user-dict.vala"
	_tmp3_ = self->priv->okuri_nasi_entries;
#line 240 "user-dict.vala"
	_tmp4_ = gee_map_get_keys (_tmp3_);
#line 240 "user-dict.vala"
	_tmp5_ = _tmp4_;
#line 240 "user-dict.vala"
	_tmp6_ = _tmp5_;
#line 240 "user-dict.vala"
	gee_collection_add_all ((GeeCollection*) _tmp2_, (GeeCollection*) _tmp6_);
#line 240 "user-dict.vala"
	_g_object_unref0 (_tmp6_);
#line 241 "user-dict.vala"
	_tmp7_ = keys;
#line 241 "user-dict.vala"
	gee_list_sort (_tmp7_, NULL, NULL, NULL);
#line 242 "user-dict.vala"
	_tmp8_ = keys;
#line 242 "user-dict.vala"
	_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
#line 242 "user-dict.vala"
	iter = _tmp9_;
#line 244 "user-dict.vala"
	while (TRUE) {
#line 2173 "user-dict.c"
		GeeIterator* _tmp10_;
		gchar* key = NULL;
		GeeIterator* _tmp11_;
		gpointer _tmp12_;
		const gchar* _tmp13_;
#line 244 "user-dict.vala"
		_tmp10_ = iter;
#line 244 "user-dict.vala"
		if (!gee_iterator_next (_tmp10_)) {
#line 244 "user-dict.vala"
			break;
#line 2185 "user-dict.c"
		}
#line 245 "user-dict.vala"
		_tmp11_ = iter;
#line 245 "user-dict.vala"
		_tmp12_ = gee_iterator_get (_tmp11_);
#line 245 "user-dict.vala"
		key = (gchar*) _tmp12_;
#line 246 "user-dict.vala"
		_tmp13_ = key;
#line 246 "user-dict.vala"
		if (g_str_has_prefix (_tmp13_, midasi)) {
#line 2197 "user-dict.c"
			const gchar* _tmp14_;
#line 248 "user-dict.vala"
			_tmp14_ = key;
#line 248 "user-dict.vala"
			if (g_strcmp0 (_tmp14_, midasi) != 0) {
#line 2203 "user-dict.c"
				GeeList* _tmp15_;
				const gchar* _tmp16_;
#line 249 "user-dict.vala"
				_tmp15_ = completion;
#line 249 "user-dict.vala"
				_tmp16_ = key;
#line 249 "user-dict.vala"
				gee_collection_add ((GeeCollection*) _tmp15_, _tmp16_);
#line 2212 "user-dict.c"
			}
#line 251 "user-dict.vala"
			_g_free0 (key);
#line 251 "user-dict.vala"
			break;
#line 2218 "user-dict.c"
		}
#line 244 "user-dict.vala"
		_g_free0 (key);
#line 2222 "user-dict.c"
	}
#line 255 "user-dict.vala"
	while (TRUE) {
#line 2226 "user-dict.c"
		GeeIterator* _tmp17_;
		gchar* key = NULL;
		GeeIterator* _tmp18_;
		gpointer _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
#line 255 "user-dict.vala"
		_tmp17_ = iter;
#line 255 "user-dict.vala"
		if (!gee_iterator_next (_tmp17_)) {
#line 255 "user-dict.vala"
			break;
#line 2239 "user-dict.c"
		}
#line 256 "user-dict.vala"
		_tmp18_ = iter;
#line 256 "user-dict.vala"
		_tmp19_ = gee_iterator_get (_tmp18_);
#line 256 "user-dict.vala"
		key = (gchar*) _tmp19_;
#line 257 "user-dict.vala"
		_tmp20_ = key;
#line 257 "user-dict.vala"
		if (!g_str_has_prefix (_tmp20_, midasi)) {
#line 258 "user-dict.vala"
			_g_free0 (key);
#line 258 "user-dict.vala"
			break;
#line 2255 "user-dict.c"
		}
#line 261 "user-dict.vala"
		_tmp21_ = key;
#line 261 "user-dict.vala"
		if (g_strcmp0 (_tmp21_, midasi) != 0) {
#line 2261 "user-dict.c"
			GeeList* _tmp22_;
			const gchar* _tmp23_;
#line 262 "user-dict.vala"
			_tmp22_ = completion;
#line 262 "user-dict.vala"
			_tmp23_ = key;
#line 262 "user-dict.vala"
			gee_collection_add ((GeeCollection*) _tmp22_, _tmp23_);
#line 2270 "user-dict.c"
		}
#line 255 "user-dict.vala"
		_g_free0 (key);
#line 2274 "user-dict.c"
	}
#line 265 "user-dict.vala"
	_tmp24_ = completion;
#line 265 "user-dict.vala"
	_tmp26_ = gee_collection_to_array ((GeeCollection*) _tmp24_, &_tmp25_);
#line 265 "user-dict.vala"
	_tmp27_ = _tmp26_;
#line 265 "user-dict.vala"
	_tmp27__length1 = _tmp25_;
#line 265 "user-dict.vala"
	if (result_length1) {
#line 265 "user-dict.vala"
		*result_length1 = _tmp27__length1;
#line 2288 "user-dict.c"
	}
#line 265 "user-dict.vala"
	result = _tmp27_;
#line 265 "user-dict.vala"
	_g_object_unref0 (iter);
#line 265 "user-dict.vala"
	_g_object_unref0 (keys);
#line 265 "user-dict.vala"
	_g_object_unref0 (completion);
#line 265 "user-dict.vala"
	return result;
#line 2300 "user-dict.c"
}

/**
         * {@inheritDoc}
         */
static gboolean
skk_user_dict_real_select_candidate (SkkDict* base,
                                     SkkCandidate* candidate)
{
	SkkUserDict * self;
	GeeMap* entries = NULL;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GeeMap* _tmp2_;
	GeeMap* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gint index = 0;
	GeeList* candidates = NULL;
	GeeMap* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gpointer _tmp14_;
	GeeList* _tmp37_;
	gboolean result;
#line 271 "user-dict.vala"
	self = (SkkUserDict*) base;
#line 271 "user-dict.vala"
	g_return_val_if_fail (candidate != NULL, FALSE);
#line 272 "user-dict.vala"
	_tmp0_ = skk_candidate_get_okuri (candidate);
#line 272 "user-dict.vala"
	_tmp1_ = _tmp0_;
#line 272 "user-dict.vala"
	_tmp2_ = skk_user_dict_get_entries (self, _tmp1_);
#line 272 "user-dict.vala"
	entries = _tmp2_;
#line 273 "user-dict.vala"
	_tmp3_ = entries;
#line 273 "user-dict.vala"
	_tmp4_ = skk_candidate_get_midasi (candidate);
#line 273 "user-dict.vala"
	_tmp5_ = _tmp4_;
#line 273 "user-dict.vala"
	if (!gee_map_has_key (_tmp3_, _tmp5_)) {
#line 2346 "user-dict.c"
		GeeMap* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		GeeArrayList* _tmp9_;
		GeeArrayList* _tmp10_;
#line 274 "user-dict.vala"
		_tmp6_ = entries;
#line 274 "user-dict.vala"
		_tmp7_ = skk_candidate_get_midasi (candidate);
#line 274 "user-dict.vala"
		_tmp8_ = _tmp7_;
#line 274 "user-dict.vala"
		_tmp9_ = gee_array_list_new (SKK_TYPE_CANDIDATE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 274 "user-dict.vala"
		_tmp10_ = _tmp9_;
#line 274 "user-dict.vala"
		gee_map_set (_tmp6_, _tmp8_, (GeeList*) _tmp10_);
#line 274 "user-dict.vala"
		_g_object_unref0 (_tmp10_);
#line 2366 "user-dict.c"
	}
#line 276 "user-dict.vala"
	index = 0;
#line 277 "user-dict.vala"
	_tmp11_ = entries;
#line 277 "user-dict.vala"
	_tmp12_ = skk_candidate_get_midasi (candidate);
#line 277 "user-dict.vala"
	_tmp13_ = _tmp12_;
#line 277 "user-dict.vala"
	_tmp14_ = gee_map_get (_tmp11_, _tmp13_);
#line 277 "user-dict.vala"
	candidates = (GeeList*) _tmp14_;
#line 2380 "user-dict.c"
	{
		GeeList* _c_list = NULL;
		GeeList* _tmp15_;
		gint _c_size = 0;
		GeeList* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint _c_index = 0;
#line 278 "user-dict.vala"
		_tmp15_ = candidates;
#line 278 "user-dict.vala"
		_c_list = _tmp15_;
#line 278 "user-dict.vala"
		_tmp16_ = _c_list;
#line 278 "user-dict.vala"
		_tmp17_ = gee_collection_get_size ((GeeCollection*) _tmp16_);
#line 278 "user-dict.vala"
		_tmp18_ = _tmp17_;
#line 278 "user-dict.vala"
		_c_size = _tmp18_;
#line 278 "user-dict.vala"
		_c_index = -1;
#line 278 "user-dict.vala"
		while (TRUE) {
#line 2405 "user-dict.c"
			gint _tmp19_;
			gint _tmp20_;
			SkkCandidate* c = NULL;
			GeeList* _tmp21_;
			gpointer _tmp22_;
			SkkCandidate* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			gint _tmp36_;
#line 278 "user-dict.vala"
			_c_index = _c_index + 1;
#line 278 "user-dict.vala"
			_tmp19_ = _c_index;
#line 278 "user-dict.vala"
			_tmp20_ = _c_size;
#line 278 "user-dict.vala"
			if (!(_tmp19_ < _tmp20_)) {
#line 278 "user-dict.vala"
				break;
#line 2427 "user-dict.c"
			}
#line 278 "user-dict.vala"
			_tmp21_ = _c_list;
#line 278 "user-dict.vala"
			_tmp22_ = gee_list_get (_tmp21_, _c_index);
#line 278 "user-dict.vala"
			c = (SkkCandidate*) _tmp22_;
#line 279 "user-dict.vala"
			_tmp23_ = c;
#line 279 "user-dict.vala"
			_tmp24_ = skk_candidate_get_text (_tmp23_);
#line 279 "user-dict.vala"
			_tmp25_ = _tmp24_;
#line 279 "user-dict.vala"
			_tmp26_ = skk_candidate_get_text (candidate);
#line 279 "user-dict.vala"
			_tmp27_ = _tmp26_;
#line 279 "user-dict.vala"
			if (g_strcmp0 (_tmp25_, _tmp27_) == 0) {
#line 280 "user-dict.vala"
				if (index > 0) {
#line 2449 "user-dict.c"
					SkkCandidate* first = NULL;
					GeeList* _tmp28_;
					gpointer _tmp29_;
					GeeList* _tmp30_;
					GeeList* _tmp31_;
					gpointer _tmp32_;
					SkkCandidate* _tmp33_;
					GeeList* _tmp34_;
					SkkCandidate* _tmp35_;
#line 281 "user-dict.vala"
					_tmp28_ = candidates;
#line 281 "user-dict.vala"
					_tmp29_ = gee_list_get (_tmp28_, 0);
#line 281 "user-dict.vala"
					first = (SkkCandidate*) _tmp29_;
#line 282 "user-dict.vala"
					_tmp30_ = candidates;
#line 282 "user-dict.vala"
					_tmp31_ = candidates;
#line 282 "user-dict.vala"
					_tmp32_ = gee_list_get (_tmp31_, index);
#line 282 "user-dict.vala"
					_tmp33_ = (SkkCandidate*) _tmp32_;
#line 282 "user-dict.vala"
					gee_list_set (_tmp30_, 0, _tmp33_);
#line 282 "user-dict.vala"
					_g_object_unref0 (_tmp33_);
#line 283 "user-dict.vala"
					_tmp34_ = candidates;
#line 283 "user-dict.vala"
					_tmp35_ = first;
#line 283 "user-dict.vala"
					gee_list_set (_tmp34_, index, _tmp35_);
#line 284 "user-dict.vala"
					result = TRUE;
#line 284 "user-dict.vala"
					_g_object_unref0 (first);
#line 284 "user-dict.vala"
					_g_object_unref0 (c);
#line 284 "user-dict.vala"
					_g_object_unref0 (candidates);
#line 284 "user-dict.vala"
					_g_object_unref0 (entries);
#line 284 "user-dict.vala"
					return result;
#line 2495 "user-dict.c"
				}
#line 286 "user-dict.vala"
				result = FALSE;
#line 286 "user-dict.vala"
				_g_object_unref0 (c);
#line 286 "user-dict.vala"
				_g_object_unref0 (candidates);
#line 286 "user-dict.vala"
				_g_object_unref0 (entries);
#line 286 "user-dict.vala"
				return result;
#line 2507 "user-dict.c"
			}
#line 288 "user-dict.vala"
			_tmp36_ = index;
#line 288 "user-dict.vala"
			index = _tmp36_ + 1;
#line 278 "user-dict.vala"
			_g_object_unref0 (c);
#line 2515 "user-dict.c"
		}
	}
#line 290 "user-dict.vala"
	_tmp37_ = candidates;
#line 290 "user-dict.vala"
	gee_list_insert (_tmp37_, 0, candidate);
#line 291 "user-dict.vala"
	result = TRUE;
#line 291 "user-dict.vala"
	_g_object_unref0 (candidates);
#line 291 "user-dict.vala"
	_g_object_unref0 (entries);
#line 291 "user-dict.vala"
	return result;
#line 2530 "user-dict.c"
}

/**
         * {@inheritDoc}
         */
static gboolean
skk_user_dict_real_purge_candidate (SkkDict* base,
                                    SkkCandidate* candidate)
{
	SkkUserDict * self;
	gboolean modified = FALSE;
	GeeMap* entries = NULL;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GeeMap* _tmp2_;
	GeeMap* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gboolean result;
#line 297 "user-dict.vala"
	self = (SkkUserDict*) base;
#line 297 "user-dict.vala"
	g_return_val_if_fail (candidate != NULL, FALSE);
#line 299 "user-dict.vala"
	modified = FALSE;
#line 300 "user-dict.vala"
	_tmp0_ = skk_candidate_get_okuri (candidate);
#line 300 "user-dict.vala"
	_tmp1_ = _tmp0_;
#line 300 "user-dict.vala"
	_tmp2_ = skk_user_dict_get_entries (self, _tmp1_);
#line 300 "user-dict.vala"
	entries = _tmp2_;
#line 301 "user-dict.vala"
	_tmp3_ = entries;
#line 301 "user-dict.vala"
	_tmp4_ = skk_candidate_get_midasi (candidate);
#line 301 "user-dict.vala"
	_tmp5_ = _tmp4_;
#line 301 "user-dict.vala"
	if (gee_map_has_key (_tmp3_, _tmp5_)) {
#line 2572 "user-dict.c"
		GeeList* candidates = NULL;
		GeeMap* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gpointer _tmp9_;
		GeeList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 302 "user-dict.vala"
		_tmp6_ = entries;
#line 302 "user-dict.vala"
		_tmp7_ = skk_candidate_get_midasi (candidate);
#line 302 "user-dict.vala"
		_tmp8_ = _tmp7_;
#line 302 "user-dict.vala"
		_tmp9_ = gee_map_get (_tmp6_, _tmp8_);
#line 302 "user-dict.vala"
		candidates = (GeeList*) _tmp9_;
#line 303 "user-dict.vala"
		_tmp10_ = candidates;
#line 303 "user-dict.vala"
		_tmp11_ = gee_collection_get_size ((GeeCollection*) _tmp10_);
#line 303 "user-dict.vala"
		_tmp12_ = _tmp11_;
#line 303 "user-dict.vala"
		if (_tmp12_ > 0) {
#line 2599 "user-dict.c"
			GeeIterator* iter = NULL;
			GeeList* _tmp13_;
			GeeIterator* _tmp14_;
			GeeList* _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
#line 304 "user-dict.vala"
			_tmp13_ = candidates;
#line 304 "user-dict.vala"
			_tmp14_ = gee_iterable_iterator ((GeeIterable*) _tmp13_);
#line 304 "user-dict.vala"
			iter = _tmp14_;
#line 305 "user-dict.vala"
			while (TRUE) {
#line 2614 "user-dict.c"
				GeeIterator* _tmp15_;
				SkkCandidate* c = NULL;
				GeeIterator* _tmp16_;
				gpointer _tmp17_;
				SkkCandidate* _tmp18_;
				const gchar* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				const gchar* _tmp22_;
#line 305 "user-dict.vala"
				_tmp15_ = iter;
#line 305 "user-dict.vala"
				if (!gee_iterator_next (_tmp15_)) {
#line 305 "user-dict.vala"
					break;
#line 2630 "user-dict.c"
				}
#line 306 "user-dict.vala"
				_tmp16_ = iter;
#line 306 "user-dict.vala"
				_tmp17_ = gee_iterator_get (_tmp16_);
#line 306 "user-dict.vala"
				c = (SkkCandidate*) _tmp17_;
#line 307 "user-dict.vala"
				_tmp18_ = c;
#line 307 "user-dict.vala"
				_tmp19_ = skk_candidate_get_text (_tmp18_);
#line 307 "user-dict.vala"
				_tmp20_ = _tmp19_;
#line 307 "user-dict.vala"
				_tmp21_ = skk_candidate_get_text (candidate);
#line 307 "user-dict.vala"
				_tmp22_ = _tmp21_;
#line 307 "user-dict.vala"
				if (g_strcmp0 (_tmp20_, _tmp22_) == 0) {
#line 2650 "user-dict.c"
					GeeIterator* _tmp23_;
#line 308 "user-dict.vala"
					_tmp23_ = iter;
#line 308 "user-dict.vala"
					gee_iterator_remove (_tmp23_);
#line 309 "user-dict.vala"
					modified = TRUE;
#line 2658 "user-dict.c"
				}
#line 305 "user-dict.vala"
				_g_object_unref0 (c);
#line 2662 "user-dict.c"
			}
#line 312 "user-dict.vala"
			_tmp24_ = candidates;
#line 312 "user-dict.vala"
			_tmp25_ = gee_collection_get_size ((GeeCollection*) _tmp24_);
#line 312 "user-dict.vala"
			_tmp26_ = _tmp25_;
#line 312 "user-dict.vala"
			if (_tmp26_ == 0) {
#line 2672 "user-dict.c"
				GeeMap* _tmp27_;
				const gchar* _tmp28_;
				const gchar* _tmp29_;
#line 313 "user-dict.vala"
				_tmp27_ = entries;
#line 313 "user-dict.vala"
				_tmp28_ = skk_candidate_get_midasi (candidate);
#line 313 "user-dict.vala"
				_tmp29_ = _tmp28_;
#line 313 "user-dict.vala"
				gee_map_unset (_tmp27_, _tmp29_, NULL);
#line 2684 "user-dict.c"
			}
#line 303 "user-dict.vala"
			_g_object_unref0 (iter);
#line 2688 "user-dict.c"
		}
#line 301 "user-dict.vala"
		_g_object_unref0 (candidates);
#line 2692 "user-dict.c"
	}
#line 317 "user-dict.vala"
	result = modified;
#line 317 "user-dict.vala"
	_g_object_unref0 (entries);
#line 317 "user-dict.vala"
	return result;
#line 2700 "user-dict.c"
}

/**
         * Create a new UserDict.
         *
         * @param path a path to the file
         * @param encoding encoding of the file (default UTF-8)
         *
         * @return a new UserDict
         * @throws GLib.Error if opening the file is failed
         */
SkkUserDict*
skk_user_dict_construct (GType object_type,
                         const gchar* path,
                         const gchar* encoding,
                         GError** error)
{
	SkkUserDict * self = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	SkkEncodingConverter* _tmp2_ = NULL;
	SkkEncodingConverter* _tmp3_;
	SkkEncodingConverter* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 346 "user-dict.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 346 "user-dict.vala"
	g_return_val_if_fail (encoding != NULL, NULL);
#line 346 "user-dict.vala"
	self = (SkkUserDict*) skk_dict_construct (object_type);
#line 349 "user-dict.vala"
	_tmp0_ = g_file_new_for_path (path);
#line 349 "user-dict.vala"
	_g_object_unref0 (self->priv->file);
#line 349 "user-dict.vala"
	self->priv->file = _tmp0_;
#line 350 "user-dict.vala"
	_tmp1_ = g_strdup ("");
#line 350 "user-dict.vala"
	_g_free0 (self->priv->etag);
#line 350 "user-dict.vala"
	self->priv->etag = _tmp1_;
#line 351 "user-dict.vala"
	_tmp3_ = skk_encoding_converter_new (encoding, &_inner_error0_);
#line 351 "user-dict.vala"
	_tmp2_ = _tmp3_;
#line 351 "user-dict.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 351 "user-dict.vala"
		g_propagate_error (error, _inner_error0_);
#line 351 "user-dict.vala"
		_g_object_unref0 (self);
#line 351 "user-dict.vala"
		return NULL;
#line 2755 "user-dict.c"
	}
#line 351 "user-dict.vala"
	_tmp4_ = _tmp2_;
#line 351 "user-dict.vala"
	_tmp2_ = NULL;
#line 351 "user-dict.vala"
	_g_object_unref0 (self->priv->converter);
#line 351 "user-dict.vala"
	self->priv->converter = _tmp4_;
#line 353 "user-dict.vala"
	if (g_file_test (path, G_FILE_TEST_EXISTS)) {
#line 354 "user-dict.vala"
		skk_dict_reload ((SkkDict*) self, &_inner_error0_);
#line 354 "user-dict.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 354 "user-dict.vala"
			g_propagate_error (error, _inner_error0_);
#line 354 "user-dict.vala"
			_g_object_unref0 (_tmp2_);
#line 354 "user-dict.vala"
			_g_object_unref0 (self);
#line 354 "user-dict.vala"
			return NULL;
#line 2779 "user-dict.c"
		}
	}
#line 346 "user-dict.vala"
	_g_object_unref0 (_tmp2_);
#line 346 "user-dict.vala"
	return self;
#line 2786 "user-dict.c"
}

SkkUserDict*
skk_user_dict_new (const gchar* path,
                   const gchar* encoding,
                   GError** error)
{
#line 346 "user-dict.vala"
	return skk_user_dict_construct (SKK_TYPE_USER_DICT, path, encoding, error);
#line 2796 "user-dict.c"
}

static gboolean
skk_user_dict_real_get_read_only (SkkDict* base)
{
	gboolean result;
	SkkUserDict* self;
#line 324 "user-dict.vala"
	self = (SkkUserDict*) base;
#line 325 "user-dict.vala"
	result = FALSE;
#line 325 "user-dict.vala"
	return result;
#line 2810 "user-dict.c"
}

static void
skk_user_dict_class_init (SkkUserDictClass * klass,
                          gpointer klass_data)
{
#line 24 "user-dict.vala"
	skk_user_dict_parent_class = g_type_class_peek_parent (klass);
#line 24 "user-dict.vala"
	g_type_class_adjust_private_offset (klass, &SkkUserDict_private_offset);
#line 24 "user-dict.vala"
	((SkkDictClass *) klass)->reload = (void (*) (SkkDict*, GError**)) skk_user_dict_real_reload;
#line 24 "user-dict.vala"
	((SkkDictClass *) klass)->save = (void (*) (SkkDict*, GError**)) skk_user_dict_real_save;
#line 24 "user-dict.vala"
	((SkkDictClass *) klass)->lookup = (SkkCandidate** (*) (SkkDict*, const gchar*, gboolean, gint*)) skk_user_dict_real_lookup;
#line 24 "user-dict.vala"
	((SkkDictClass *) klass)->complete = (gchar** (*) (SkkDict*, const gchar*, gint*)) skk_user_dict_real_complete;
#line 24 "user-dict.vala"
	((SkkDictClass *) klass)->select_candidate = (gboolean (*) (SkkDict*, SkkCandidate*)) skk_user_dict_real_select_candidate;
#line 24 "user-dict.vala"
	((SkkDictClass *) klass)->purge_candidate = (gboolean (*) (SkkDict*, SkkCandidate*)) skk_user_dict_real_purge_candidate;
#line 24 "user-dict.vala"
	SKK_DICT_CLASS (klass)->get_read_only = (gboolean (*) (SkkDict*)) skk_user_dict_real_get_read_only;
#line 24 "user-dict.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_skk_user_dict_get_property;
#line 24 "user-dict.vala"
	G_OBJECT_CLASS (klass)->finalize = skk_user_dict_finalize;
#line 2839 "user-dict.c"
	/**
	         * {@inheritDoc}
	         */
#line 24 "user-dict.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_USER_DICT_READ_ONLY_PROPERTY, skk_user_dict_properties[SKK_USER_DICT_READ_ONLY_PROPERTY] = g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2845 "user-dict.c"
}

static void
skk_user_dict_instance_init (SkkUserDict * self,
                             gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 24 "user-dict.vala"
	self->priv = skk_user_dict_get_instance_private (self);
#line 332 "user-dict.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 332 "user-dict.vala"
	self->priv->okuri_ari_entries = (GeeMap*) _tmp0_;
#line 334 "user-dict.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 334 "user-dict.vala"
	self->priv->okuri_nasi_entries = (GeeMap*) _tmp1_;
#line 2864 "user-dict.c"
}

static void
skk_user_dict_finalize (GObject * obj)
{
	SkkUserDict * self;
	GeeMapIterator* okuri_ari_iter = NULL;
	GeeMap* _tmp0_;
	GeeMapIterator* _tmp1_;
	GeeMap* _tmp6_;
	GeeMapIterator* okuri_nasi_iter = NULL;
	GeeMap* _tmp7_;
	GeeMapIterator* _tmp8_;
	GeeMap* _tmp13_;
#line 24 "user-dict.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SKK_TYPE_USER_DICT, SkkUserDict);
#line 359 "user-dict.vala"
	_tmp0_ = self->priv->okuri_ari_entries;
#line 359 "user-dict.vala"
	_tmp1_ = gee_map_map_iterator (_tmp0_);
#line 359 "user-dict.vala"
	okuri_ari_iter = _tmp1_;
#line 360 "user-dict.vala"
	while (TRUE) {
#line 2889 "user-dict.c"
		GeeMapIterator* _tmp2_;
		GeeMapIterator* _tmp3_;
		gpointer _tmp4_;
		GeeList* _tmp5_;
#line 360 "user-dict.vala"
		_tmp2_ = okuri_ari_iter;
#line 360 "user-dict.vala"
		if (!gee_map_iterator_next (_tmp2_)) {
#line 360 "user-dict.vala"
			break;
#line 2900 "user-dict.c"
		}
#line 361 "user-dict.vala"
		_tmp3_ = okuri_ari_iter;
#line 361 "user-dict.vala"
		_tmp4_ = gee_map_iterator_get_value (_tmp3_);
#line 361 "user-dict.vala"
		_tmp5_ = (GeeList*) _tmp4_;
#line 361 "user-dict.vala"
		gee_collection_clear ((GeeCollection*) _tmp5_);
#line 361 "user-dict.vala"
		_g_object_unref0 (_tmp5_);
#line 2912 "user-dict.c"
	}
#line 363 "user-dict.vala"
	_tmp6_ = self->priv->okuri_ari_entries;
#line 363 "user-dict.vala"
	gee_map_clear (_tmp6_);
#line 364 "user-dict.vala"
	_tmp7_ = self->priv->okuri_nasi_entries;
#line 364 "user-dict.vala"
	_tmp8_ = gee_map_map_iterator (_tmp7_);
#line 364 "user-dict.vala"
	okuri_nasi_iter = _tmp8_;
#line 365 "user-dict.vala"
	while (TRUE) {
#line 2926 "user-dict.c"
		GeeMapIterator* _tmp9_;
		GeeMapIterator* _tmp10_;
		gpointer _tmp11_;
		GeeList* _tmp12_;
#line 365 "user-dict.vala"
		_tmp9_ = okuri_nasi_iter;
#line 365 "user-dict.vala"
		if (!gee_map_iterator_next (_tmp9_)) {
#line 365 "user-dict.vala"
			break;
#line 2937 "user-dict.c"
		}
#line 366 "user-dict.vala"
		_tmp10_ = okuri_nasi_iter;
#line 366 "user-dict.vala"
		_tmp11_ = gee_map_iterator_get_value (_tmp10_);
#line 366 "user-dict.vala"
		_tmp12_ = (GeeList*) _tmp11_;
#line 366 "user-dict.vala"
		gee_collection_clear ((GeeCollection*) _tmp12_);
#line 366 "user-dict.vala"
		_g_object_unref0 (_tmp12_);
#line 2949 "user-dict.c"
	}
#line 368 "user-dict.vala"
	_tmp13_ = self->priv->okuri_nasi_entries;
#line 368 "user-dict.vala"
	gee_map_clear (_tmp13_);
#line 24 "user-dict.vala"
	_g_object_unref0 (okuri_nasi_iter);
#line 24 "user-dict.vala"
	_g_object_unref0 (okuri_ari_iter);
#line 329 "user-dict.vala"
	_g_object_unref0 (self->priv->file);
#line 330 "user-dict.vala"
	_g_free0 (self->priv->etag);
#line 331 "user-dict.vala"
	_g_object_unref0 (self->priv->converter);
#line 332 "user-dict.vala"
	_g_object_unref0 (self->priv->okuri_ari_entries);
#line 334 "user-dict.vala"
	_g_object_unref0 (self->priv->okuri_nasi_entries);
#line 24 "user-dict.vala"
	G_OBJECT_CLASS (skk_user_dict_parent_class)->finalize (obj);
#line 2971 "user-dict.c"
}

/**
     * File based implementation of Dict with write access.
     */
static GType
skk_user_dict_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SkkUserDictClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) skk_user_dict_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SkkUserDict), 0, (GInstanceInitFunc) skk_user_dict_instance_init, NULL };
	GType skk_user_dict_type_id;
	skk_user_dict_type_id = g_type_register_static (SKK_TYPE_DICT, "SkkUserDict", &g_define_type_info, 0);
	SkkUserDict_private_offset = g_type_add_instance_private (skk_user_dict_type_id, sizeof (SkkUserDictPrivate));
	return skk_user_dict_type_id;
}

GType
skk_user_dict_get_type (void)
{
	static volatile gsize skk_user_dict_type_id__once = 0;
	if (g_once_init_enter (&skk_user_dict_type_id__once)) {
		GType skk_user_dict_type_id;
		skk_user_dict_type_id = skk_user_dict_get_type_once ();
		g_once_init_leave (&skk_user_dict_type_id__once, skk_user_dict_type_id);
	}
	return skk_user_dict_type_id__once;
}

static void
_vala_skk_user_dict_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	SkkUserDict * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SKK_TYPE_USER_DICT, SkkUserDict);
#line 24 "user-dict.vala"
	switch (property_id) {
#line 24 "user-dict.vala"
		case SKK_USER_DICT_READ_ONLY_PROPERTY:
#line 24 "user-dict.vala"
		g_value_set_boolean (value, skk_dict_get_read_only ((SkkDict*) self));
#line 24 "user-dict.vala"
		break;
#line 3015 "user-dict.c"
		default:
#line 24 "user-dict.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "user-dict.vala"
		break;
#line 3021 "user-dict.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

